//Загрузка данных для приложения
function LoadDataForApplication() {


    let src = "Web/Media/Images/favicon.png";
    setFavicons(src);

    //Смотреть снизу вверх



    let Wait_5 = function () {
        //document.getElementById("info").innerHTML += "...Готово.<br>Запуск приложения...   ";
        DivInfo.innerHTML += "...Готово.<br>Запуск приложения...   ";

        console.log("Внимание! Все необходимые данные пришли. Запуск приложения ");
        StopLoad(); //Остановка анимации загрузки //
        DrawApplication();//Прорисовка дизайна приложения
        //ResizeDrawApplication();
        //Получить Текущее состояние соединения с Binance. 
        let Message = {
            "Type": "СonnectBinanceStatus"
        };
        MessageSend(Message);
        //Получить все оповищения.
        Message = {
            "Type": "AlertsAll"
        };
        MessageSend(Message);

        //Получить IP статус.
        Message = {
            "Type": "CheckExternalIP"
        };
        MessageSend(Message);

        //Запрос обновить информацию о аккаунте (кошелек, состояние)
        GetUpdateAI();
    }





    //Получить график цены выбранного символа
    let Wait_4 = function () {
        //document.getElementById("info").innerHTML += "...Готово.<br>Обновление графика цен...   ";
        DivInfo.innerHTML += "...Готово.<br>Обновление графика цен...   ";

        let Symbol = G.Bot.Symbol;
        console.log("Запрос Price для символа " + Symbol);
        GetPrice(Symbol, true)

        let timerId = setInterval(function () { // начать повторы с интервалом 0.5 сек
            if (("Price" + G.Bot.Symbol) in G.C.N) {
                clearInterval(timerId);// остановить повторы
                Wait_5();
                //return true;
            }
        }, 100);
        //return true;
    };

    //Получить список и правила для всех символов
    let Wait_3 = function () {
        //document.getElementById("info").innerHTML += "...Готово.<br>Список символов и правила торговли...   ";
        DivInfo.innerHTML += "...Готово.<br>Список символов и правила торговли...   ";

        let Message = {
            "Type": "ExchangeInformation"
        };
        MessageSend(Message);

        let timerId = setInterval(function () { // начать повторы с интервалом 0.5 сек
            if ("SI" in G) {
                clearInterval(timerId);// остановить повторы
                Wait_4();
            }
        }, 100);
    };
    //Получить настройки робота    
    let Wait_2 = function () {
        //document.getElementById("info").innerHTML += "...Готово.<br>Настройки робота...   ";
        DivInfo.innerHTML += "...Готово.<br>Настройки робота...   ";

        let Message = {
            "Type": "BotLoad"
        };
        MessageSend(Message);

        let timerId = setInterval(function () { // начать повторы с интервалом 0.5 сек
            if (G.Bot != undefined) {
                if (G.Bot.Symbol != "" && G.Bot.Symbol != undefined) {
                    clearInterval(timerId);// остановить повторы
                    Wait_3();
                }
            }
        }, 100);
    };

    //Получить настройки GUI  
    let Wait_1_1 = function () {
        //document.getElementById("info").innerHTML += "...Готово.<br>Настройки графиков...   ";
        DivInfo.innerHTML += "...Готово.<br>Настройки графиков...   ";

        let Message = {
            "Type": "GUIChartLoad"
        };
        MessageSend(Message);
        let timerId = setInterval(function () { // начать повторы с интервалом 0.5 сек
            if (G.GUIChartLoad) {
                clearInterval(timerId);// остановить повторы
                Wait_2();
            }
        }, 100);
    };


    //Получить настройки GUI  
    let Wait_1 = function () {
        // document.getElementById("info").innerHTML += "...Готово.<br>Настройки GUI...   ";
        DivInfo.innerHTML += "...Готово.<br>Настройки GUI...   ";
        let Message = {
            "Type": "GUISettingsLoad"
        };
        MessageSend(Message);
        let timerId = setInterval(function () { // начать повторы с интервалом 0.5 сек
            if (G.S.GUI_Theme) {
                clearInterval(timerId);// остановить повторы
                Wait_1_1();
            }
        }, 100);
    };


    Wait_1();

}


//Установить иконку
function setFavicons(favImg) {
    let headTitle = document.querySelector('head');
    let setFavicon = document.createElement('link');
    setFavicon.setAttribute('rel', 'shortcut icon');
    setFavicon.setAttribute('href', favImg);
    headTitle.appendChild(setFavicon);
}


//Прорисовка дизайна приложения
function DrawApplication() {

    //console.log("DrawApplication ");
    // Очищаем страницу от контента.
    document.body.innerHTML = "";
    //Событие: Размер окна приложения изменён.
    window.addEventListener("resize", DrawApplication);
    switch (G.Page.Name) {
        case "Trade": //Торговля. Гостевая страница. 
            DrawTradePage();
            break;
        case "NN"://Нейросеть. Настройки НС.
            DrawNNPage();
            break;
        case "Settings"://Настройки приложения.
            DrawPageSettings();
            break;

    }


    //return true;
}


function ResizeDrawApplication() {
    //Событие: Размер окна приложения изменён.
    //window.addEventListener("resize", DrawApplication);
}

//Общие окна для всех страниц приложения.

//Главное меню. (Верхняя строка)
function MainMenu(inDiv) {
    //------------------------------------------------------------------------------------------------------------------
    let FontSize = G.D.S.FontSizeNormal;
    let Size = GetDivSizeContent(inDiv);
    let LineHeight = Size.h;
    let Gap = 25;

    //Торговля
    let Div1 = MenuItem(Gap / 2, LineHeight, G.D.C.TWin, FontSize, G.L[G.S.L].m1, inDiv);
    //Нейронная сеть
    let Div2 = MenuItem(Gap, LineHeight, G.D.C.TWin, FontSize, G.L[G.S.L].m2, inDiv);
    // Настройки
    let Div3 = MenuItem(Gap, LineHeight, G.D.C.TWin, FontSize, G.L[G.S.L].m3, inDiv);

    //------------------------------------------------------------------------------------------------------------------
    switch (G.Page.Name) {
        case "Trade":
            Div1.style.color = G.D.C.TWinLight;
            break;
        case "NN":
            Div2.style.color = G.D.C.TWinLight;
            break;
        case "Settings":
            Div3.style.color = G.D.C.TWinLight;
            break;
    }


    //Основные кнопки меню - их события
    //кошелек
    //Клик на кнопке.
    Div1.onclick = function () {
        G.Page.Name = "Trade";//NN,Trade
        DrawApplication();
    };
    //Нейронная сеть
    //Клик на кнопке.
    Div2.onclick = function () {
        G.Page.Name = "NN";//NN,Trade
        DrawApplication();
    };
    // Настройки
    //Клик на кнопке.
    Div3.onclick = function () {
        G.Page.Name = "Settings";//NN,Trade
        DrawApplication();
    };

    //Текущее состояние соединения с Binance. 
    let w = 90;
    let l = Size.w - w;
    let h = G.D.S.ContFontSizeNormal;
    let tSVG = (Size.h - h) / 2;
    let DivConnection = ImageSVG([tSVG - 2, "", l, ""], [h, h], SVG_Connection(), inDiv);
    let DivDisConnection = ImageSVG([tSVG - 2, "", l, ""], [h, h], SVG_DisConnection(), inDiv);
    DivDisConnection.style.display = "none";
    DivConnection.style.display = "none";

    //Ссылка на сайт Binance
    let DivBinance = TextSimpleClick([tSVG, "", l + h + 2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Binance", inDiv);
    DivBinance.onclick = function () {
        window.open("https://www.binance.com");
    }

    G.I["СonnectBinanceStatus"].F = function (СonnectBinanceStatus) {//Изменен статус соединения с Binance.
        //console.log("Статус соединения с Binance был G.СonnectBinanceStatus = " + G.СonnectBinanceStatus);

        if (СonnectBinanceStatus == "unknown") {//неизвестно - при старте
            return
        }
        if (СonnectBinanceStatus) {//соединение
            DivConnection.style.display = "inline";
            DivDisConnection.style.display = "none";
        } else {//разъединение
            DivDisConnection.style.display = "inline";
            DivConnection.style.display = "none";
        }

        if (G.СonnectBinanceStatus == СonnectBinanceStatus) {//Статус соединения с Binance не изменился
            return;
        }
        //Статус соединения с Binance изменился
        G.СonnectBinanceStatus = СonnectBinanceStatus;
        if (G.СonnectBinanceStatus) {//Статус соединения с Binance изменился на соеденино
            //console.log("Статус соединения с Binance изменился на " + G.СonnectBinanceStatus);
            //Запрашиваем подписки на изменения цен.
            for (let Symbol of G.C.S.SubscribePrice) {
                G.C.N["Price" + Symbol].Data = [];
                GetPrice(Symbol, true)
            }
            G.C.S.SubscribePrice = [];
        } else {//Статус соединения с Binance изменился на разъеденино
            //console.log("Статус соединения с Binance изменился на " + G.СonnectBinanceStatus);
            //Запомним подписки на изменения цен.
            for (let Name in G.C.N) {
                let GCNName = G.C.N[Name];//объект отрисовываемого графика
                if (GCNName.Name1 == "Price") {
                    G.C.S.SubscribePrice.push(GCNName.Name2);
                }
                //console.log("Сохраняем список подписок на изменения цен = " + G.C.S.SubscribePrice);

            }
        }
    }
    G.I["СonnectBinanceStatus"].F(G.СonnectBinanceStatus); //Вызов для моментального отображения



    //Иконка отслеживает изменение внешнего IP приложения.
    w = 20;
    l = l - w;
    let Div_IP_Ok = ImageSVG([tSVG - 1, "", l, ""], [h, h], SVG_IP("rgb(100,255,100)"), inDiv);
    let Div_IP_Changed = ImageSVG([tSVG - 1, "", l, ""], [h, h], SVG_IP("rgb(255,100,100)"), inDiv);
    Div_IP_Ok.style.display = "none";
    Div_IP_Changed.style.display = "none";


    G.I["CheckExternalIP"].F = function (IP_Changed) {//Изменен IP
        //console.log("Изменен IP = " + IP_Changed);

        if (!G.S.CheckIP) {//Прооверка ненужна
            Div_IP_Ok.style.display = "none";
            Div_IP_Changed.style.display = "none";
            return;
        }
        if (IP_Changed) {//соединение
            Div_IP_Ok.style.display = "inline";
            Div_IP_Changed.style.display = "none";
        } else {//разъединение
            Div_IP_Changed.style.display = "inline";
            Div_IP_Ok.style.display = "none";
        }
        G.CheckExternalIP = IP_Changed;

    }
    G.I["CheckExternalIP"].F(G.CheckExternalIP);//Вызов для моментального отображения

    //Индикатор оперативной памяти
    w = 140;
    l = l - w;
    let Div_InfoRAM = TextSimple([tSVG, "", l + h + 2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    WSMessageHandle["InfoRAM"] = function (M) {
        //console.log("Получена информация по потреблению ОП:");
        //console.log(JSON.stringify(M));
        G.InfoRAM = M.Ram;
        //Индикатор ОП
        Div_InfoRAM.innerHTML = G.L[G.S.L].RAM + " " + G.InfoRAM + " " + G.L[G.S.L].Gb;
    };
    let m = {};
    m.Ram = G.InfoRAM;
    WSMessageHandle["InfoRAM"](m);//Вызов для моментального отображения


    //Текущее состояние процессов обучения НС.
    w = 125;
    l -= w;
    let DivSVG_Working = ImageSVG([tSVG - 1, "", l, ""], [h, h], SVG_Working(), inDiv);
    DivSVG_Working.style.display = "none";
    //Обучение НС
    let DivTraining = TextSimple([tSVG, "", l + h + 2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].m4, inDiv);
    DivTraining.style.display = "none";

    G.I["NNListTraining"].F = function (NNListTraining) {//Изменен статус соединения с Binance.
        G.NN.ListTraining = NNListTraining;
        if (G.NN.ListTraining == null) {
            G.NN.ListTraining = [];
        }
        if (G.NN.ListTraining.length > 0) {
            DivSVG_Working.style.display = "inline";
            DivTraining.style.display = "inline";
        } else {
            DivSVG_Working.style.display = "none";
            DivTraining.style.display = "none";
        }
    }
    G.I["NNListTraining"].F(G.NN.ListTraining);

    if (G.NN.ListTraining) {
        let Message = {
            "Type": "NNListTraining",
        };
        MessageSend(Message);    //Получить список обучаемых НС в текущий момент.
    }



}

//Окно для графика в контейнере G.C.DivContainer.
//Всего существует 3 типа графиков: Standard, Architecture, Trigger. Для каждого из них свои окна.
//Стандартное (оси, настройки, легенда). Архитектура (Без осей настроек и легенды, только поле для схемы). Триггер (без настроек и легенды, только оси) 
//Вызов в случае: переход на другую страницу, изменения типа графика.
//Основная цель назначить контейнеры для графика G.C.DivC и другие связанные с графиком контейнера
function ChartWin(Type) {
    //console.log("ChartWin Type=" + Type);

    G.C.ChartType = Type;

    let inDiv = G.C.DivContainer; //главный контейнер
    inDiv.innerHTML = "";
    let SizeWin = GetDivSizeContent(inDiv);    //Размеры контейнера

    switch (Type) {
        case "Standard": //Определит: G.C.DivC, G.C.DivSet, G.C.DivTop, G.C.DivY, G.C.DivX. 
            {//+модуль, чтобы let не ругалась
                //Создаем два окна График и Настройки. Вычисляем их размеры.    
                let WinChartL = 0;
                let WinChartW = SizeWin.w;
                if (G.Page.ChartSet) { //отображено окно настроек
                    let WinChartSetW = G.D.S.SideWinW;
                    WinChartL = WinChartSetW + G.D.S.GapWin;
                    WinChartW = SizeWin.w - WinChartL;
                    let DivWindowContainer = WindowContainer([0, "", 0, ""], [WinChartSetW, SizeWin.h], inDiv);
                    G.C.DivSet = ModDivScrollV(DivWindowContainer, "ChartWin"); //Контейнер окна настройки
                    G.Page.ChartSetUpDate = true;//Изменились ли данные окна настройки графика
                    ChartStandardSet();
                }
                let DivChart = WindowContainer([0, "", WinChartL, ""], [WinChartW, SizeWin.h], inDiv);//окно графика
                //Разметка для элементов окна графика
                let l0 = G.D.S.GapIn;
                let t0 = G.D.S.GapIn;
                let hTop = G.D.S.ContFontSizeNormal;
                //Контейнер графика  
                let tcc = t0 + hTop + G.D.S.GapIn;
                let lcc = G.D.S.GapIn;
                let wcc = WinChartW - 2 * G.D.S.GapIn;
                let hcc = SizeWin.h - tcc - G.D.S.GapIn;
                //Ширина осей
                let wY = 70;//   Контейнер Y оси  
                let hX = 40;//   Контейнер X оси
                //   Контейнер Y оси 
                let hY = hcc - hX;
                let tY = 0;
                let lY = 0;
                //   Контейнер X оси
                let wX = wcc - wY;
                let tX = hY;
                let lX = wY;
                //   Контейнер графической части
                let wc = wX;
                let hc = hY;
                let tc = 0;
                let lc = wY;
                //-------------------------
                //Размещаем контейнеры.
                //Шапка (кнопка Настройки и поле легенды для отображения имен графиков)
                G.C.DivTop = Container([t0, "", l0, ""], [wcc, hTop], DivChart);
                //Контейнер для всего графика с осями. 
                let DivContainer = Container([tcc, "", lcc, ""], [wcc, hcc], DivChart);
                //   Контейнер Y оси
                G.C.DivY = Container([tY, "", lY, ""], [wY, hY], DivContainer);
                //   Контейнер X оси
                G.C.DivX = Container([tX, "", lX, ""], [wX, hX], DivContainer);

                //   Контейнер графической части
                G.C.DivC = Container([tc, "", lc, ""], [wc, hc], DivContainer);
                //   Контейнер активного курсора. Повторяет контейнер графической части G.C.DivC, но в отличии от него не перерисовывается, при обновлении графика.
                let DivContainerActiveСursor = Container([tc, "", lc, ""], [0, 0], DivContainer);
                G.C.ActiveСursor.Div = Container([0, "", 0, ""], [0, 0], DivContainerActiveСursor);//Активный курсор
                //   Контейнер линейки - прямоугольника. Повторяет контейнер графической части G.C.DivC, но в отличии от него не перерисовывается, при обновлении графика.
                G.C.DivMeasure = Container([tc, "", lc, ""], [0, 0], DivContainer);

                //Слой для событий графика. Ранее события были на G.C.DivC. Но новые слои его перекрывали. Этот контейнер всегда крайний в списке DivContainer, в нем нет графических элементов.
                G.C.DivEvent = Container([tc, "", lc, ""], [wc, hc], DivContainer);
                //Выключение контекстного меню на графике
                G.C.DivEvent.oncontextmenu = function () {
                    return false;
                };

                //console.log("G.C.DivC инициализирован");

                //Прорисовка осей при помощи рамок
                G.C.DivY.style.borderRight = "1px solid " + G.D.C.ChartBox;
                G.C.DivX.style.borderTop = "1px solid " + G.D.C.ChartBox;
                //Квадратик рисующий продолжение осей
                DivXY = Container([tX, "", lY, ""], [wY, hX], DivContainer);
                DivXY.style.borderTop = "1px solid " + G.D.C.ChartBox;
                DivXY.style.borderRight = "1px solid " + G.D.C.ChartBox;

                //Функция строка состояния. Используется в случаях
                //1.  скачивания цен с Binance. В функцию отправляется прогресс скачивания.
                //2.  ожидания данных с Golang. 
                let DivInfo = Container([tcc, "", lc + G.D.S.GapIn, ""], ["", G.D.S.ContFontSizeNormal], DivChart);
                DivInfo.style.display = "none";
                let timeoutID;
                clearTimeout(timeoutID)
                G.I["UpdateDataChart"] = {};
                G.I["UpdateDataChart"].F = function (Info) {
                    clearTimeout(timeoutID);
                    DivInfo.innerHTML = "";
                    let text;
                    if (Info.Time) { //Если есть время то происходит скачивания цен с Binance.
                        let D = UnixToDate(Info.Time);
                        text = "Обновление данных " + Info.Name1 + " " + Info.Name2 + " " + D.date + " " + D.time;
                    } else {//Если время не указано то происходит  ожидания данных с Golang. 
                        text = "Загрузка данных " + Info.Name1 + " " + Info.Name2;
                    }
                    TextSimple([G.D.S.GapIn, "", G.D.S.GapIn, ""], ["", G.D.S.ContFontSizeNormal], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", text, DivInfo);
                    DivInfo.style.display = "inline";
                    timeoutID = setTimeout(function () { DivInfo.style.display = "none"; }, 2000);
                }
            }
            break;
        case "Architecture"://Определит: G.C.DivC. 
            G.C.DivC = WindowContainer([0, "", 0, ""], ["100%", "100%"], inDiv);//окно графика
            //console.log("G.C.DivC инициализирован");
            break;
        case "Trigger"://Определит: G.C.DivC, G.C.DivY, G.C.DivX. 
            //Разметка для элементов окна графика
            //Контейнер для всего графика с осями. 
            let tcc = G.D.S.GapIn;
            let lcc = G.D.S.GapIn;
            let wcc = SizeWin.w - 2 * G.D.S.GapIn;
            let hcc = SizeWin.h - 2 * G.D.S.GapIn;
            //Ширина осей
            let wY = 70;//   Контейнер Y оси  
            let hX = 40;//   Контейнер X оси
            //   Контейнер Y оси 
            let hY = hcc - hX;
            let tY = 0;
            let lY = 0;
            //   Контейнер X оси
            let wX = wcc - wY;
            let tX = hY;
            let lX = wY;
            //   Контейнер графической части
            let wc = wX;
            let hc = hY;
            let tc = 0;
            let lc = wY;
            //-------------------------
            let DivChart = WindowContainer([0, "", 0, ""], ["100%", "100%"], inDiv);//окно графика
            //Размещаем контейнеры.
            //Контейнер для всего графика с осями. 
            let DivContainer = Container([tcc, "", lcc, ""], [wcc, hcc], DivChart);
            //   Контейнер Y оси
            G.C.DivY = Container([tY, "", lY, ""], [wY, hY], DivContainer);
            //   Контейнер X оси
            G.C.DivX = Container([tX, "", lX, ""], [wX, hX], DivContainer);
            //   Контейнер графической части
            G.C.DivC = Container([tc, "", lc, ""], [wc, hc], DivContainer);
            //console.log("G.C.DivC инициализирован");
            //Прорисовка осей при помощи рамок
            G.C.DivY.style.borderRight = "1px solid " + G.D.C.ChartBox;
            G.C.DivX.style.borderTop = "1px solid " + G.D.C.ChartBox;
            //Квадратик, рисующий продолжение осей
            DivXY = Container([tX, "", lY, ""], [wY, hX], DivContainer);
            DivXY.style.borderTop = "1px solid " + G.D.C.ChartBox;
            DivXY.style.borderRight = "1px solid " + G.D.C.ChartBox;
            break;
    }
}


//Дополнительные функции для окна графиков типа Standard

//Шапка графика (Настройки и легенда)
function ChartStandardTop() {

    let inDiv = G.C.DivTop;
    inDiv.innerHTML = "";
    let SizeWin = GetDivPS_Parent(inDiv);

    let h = SizeWin.h;

    //Настройка
    let color = G.D.C.TWin;
    if (G.Page.ChartSet) { //отображено окно настроек
        color = G.D.C.TWinLight;
    }
    //"Настройки";
    let DivSelectSettings = TextSimpleClick([0, "", 0, ""], ["", h], color, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].m3, inDiv);
    let SelectSettingsW = GetDivPS_Parent(DivSelectSettings).w;
    //Клик на кнопке.
    DivSelectSettings.onclick = function () {
        DivSelectSettings.style.color = G.D.C.TWinLight;
        G.Page.ChartSet = !G.Page.ChartSet;
        G.Page.ChartSetUpDate = true;//Изменились ли данные окна настройки графика
        ChartWin(G.C.ChartType);
        DrawChart();
    };

    //Легенда. Старт.
    //Контейнер оставшегося места, после "Настройка"
    let DivContainerLegendW = SizeWin.w - SelectSettingsW;
    let DivContainerLegend = Container([0, "", SelectSettingsW, ""], [DivContainerLegendW, h], inDiv);
    //DivContainerLegend.style.display  = "flex";
    //DivContainerLegend.style.justifyContent = "center"; 

    //Контейнер контента, по центру
    let DivCenterLegend = Container([0, "", 0, ""], ["", h], DivContainerLegend);

    let wSum = 0; //суммарная ширина
    let l = 0;
    for (let i = 0; i < G.C.S.Display.length; i++) {
        let Name = G.C.S.Display[i];
        if (!(Name in G.C.N)) {
            continue;
        }
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        let DivContainer = Container([0, "", l, ""], ["", h], DivCenterLegend);
        let Color = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";

        switch (GCNName.Type) {
            case "Dot":
                ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatDot(Color), "", false, DivContainer);
                break;
            case "Box":
                ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatBox(Color), "", false, DivContainer);
                break;
            case "Line":
                ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatLine(Color), "", false, DivContainer);
                break;
            case "LineSeparated":
                ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatLineSeparated(Color), "", false, DivContainer);
                break;
            case "Interval":
                ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatInterval(Color), "", false, DivContainer);
                break;
        }


        let lDivName = h + 2;
        let DivName = TextSimple([0, "", lDivName, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", GCNName.Name2 + " " + GCNName.Title, DivContainer);
        let DivNameW = GetDivPS_Parent(DivName).w;
        let wDivContainer = lDivName + DivNameW;
        DivContainer.style.width = Math.round(wDivContainer) + "px";
        l += wDivContainer + G.D.S.GapIn;
        wSum += wDivContainer + G.D.S.GapIn;
    }
    let lDivCenterLegend = (DivContainerLegendW - wSum) / 2;
    DivCenterLegend.style.left = Math.round(lDivCenterLegend) + "px";
    //Легенда. Стоп.

}



//Окно настройки графика. Обновляет данные.
function ChartStandardSet() {
    if (!(G.Page.ChartSet)) {//Окно настройки графика НЕ отображено..
        return;
    }
    if (!(G.Page.ChartSetUpDate)) {//С момента последнего обновления НЕ приходили новые графики
        return;
    }



    G.Page.ChartSetUpDate = false;//Изменились ли данные окна настройки графика

    let inDiv = G.C.DivSet;

    inDiv.innerHTML = "";

    let SizeWin = GetDivPS_Parent(inDiv);

    let h = SizeWin.h;
    let w = SizeWin.w;

    //Настройка
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;

    let t = G.D.S.GapIn;
    let hText = G.D.S.ContFontSizeNormal;

    //Добавить
    TextSimple([t, "", l0, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Add, inDiv);
    t += hText + G.D.S.GapIn;
    //Пара
    let l2 = 100;
    let w2 = 200;
    let SelectSymbol = G.S.TopSymbol[0];
    //"Пара"
    TextSimple([t, "", l1, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, inDiv);
    let DivListSelect1 = ListSelect([t, "", l2, ""], [w2, hText], G.S.TopSymbol[0], G.S.TopSymbol, inDiv);
    let DivAdd1 = ImageFrameSVG([t, "", "", l0], [hText, hText], SVG_Plus(), G.D.C.ButtonFon, true, inDiv);

    DivAdd1.onclick = function () {//Добавление пары
        //Есть ли данные на график?  
        let Name = "Price" + SelectSymbol;
        G.Page.AddPriceChart.push(Name);
        GetPrice(SelectSymbol, false)
    };
    DivListSelect1.fnSelectContent = function (SelectContent) {
        SelectSymbol = SelectContent;
    }
    t += hText + G.D.S.GapIn;

    //"График"
    TextSimple([t, "", l0, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Graph, inDiv);
    t += hText + G.D.S.GapIn;


    for (let i = 0; i < G.C.S.Display.length; i++) {//Отрисовка всех отображаемых графиков
        let Name = G.C.S.Display[i];
        if (!(Name in G.C.N)) {
            continue;
        }
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        let DivContainer = Container([t, "", l0, ""], [w, hText], inDiv);
        ChartStandardSetModule(GCNName, true, DivContainer);
        t += hText + G.D.S.GapIn;

    }
    inDiv.UpdateScroll();

}

//Плашки со свойствами графиков, расположены над графиком (Full=false) и в настройках (Full=true). Активные - сами обновляют все связанные с изменением окна.
//inDiv - это контейнер плашки, Full =false/true - Укороченная, для легенды / Полная, для настроек
function ChartStandardSetModule(GCNName, Full, inDiv) {

    inDiv.style.overflow = "hidden";    //Скрываем всё что не помещается в контейнер

    let inDivSize = GetDivPS_Parent(inDiv);
    let h = inDivSize.h;
    let w = inDivSize.w;

    let l0 = G.D.S.GapIn;
    let hText = G.D.S.ContFontSizeNormal;
    let t = hText + G.D.S.GapIn;

    //Контейнер для клика. SVG + имя графика
    let DivContainerSVGTextName = Container([0, "", 0, ""], ["", h], inDiv);
    DivContainerSVGTextName.style.cursor = "pointer";


    let DivSVG;//иконка графика
    ColorBackground = "";
    if (Full) {//Полная, для настроек
        ColorBackground = G.D.C.ButtonFon;
    }
    let Color = "rgba(" + GCNName.ColorR + "," + GCNName.ColorG + "," + GCNName.ColorB + "," + GCNName.ColorA + ")";

    switch (GCNName.Type) {
        case "Dot":
            DivSVG = ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatDot(Color), ColorBackground, false, DivContainerSVGTextName);
            break;
        case "Box":
            DivSVG = ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatBox(Color), ColorBackground, false, DivContainerSVGTextName);
            break;
        case "Line":
            DivSVG = ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatLine(Color), ColorBackground, false, DivContainerSVGTextName);
            break;
        case "LineSeparated":
            DivSVG = ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatLineSeparated(Color), ColorBackground, false, DivContainerSVGTextName);
            break;
        case "Interval":
            DivSVG = ImageFrameSVG([0, "", 0, ""], [h, h], SVG_ChatInterval(Color), ColorBackground, false, DivContainerSVGTextName);
            break;
    }


    let lTextName = h + 2;
    //console.log(" Данные для графика GCNName.Name2 = " + GCNName.Name2 + ". GCNName.Title =" + GCNName.Title);

    let DivTextName = TextSimple([0, "", lTextName, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", GCNName.Name2 + " " + GCNName.Title, DivContainerSVGTextName);
    let wTextName = GetDivPS_Parent(DivTextName).w;
    let wDivContainer = lTextName + wTextName;
    DivContainerSVGTextName.style.width = Math.round(wDivContainer) + "px"

    if (Full) {//Полная, для настроек
        //Контейнер для настройки этого графика, будет вставлен в родительский, а все дочерние элементы, будут сдвинуты на высоту этого контейнера

        //Выбор цвета графика
        TextSimple([t, "", lTextName, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Цвет", inDiv);
        t += h + G.D.S.GapIn;
        let SizeColor = Math.floor((w - lTextName) / G.D.C.Palette.length) - 1;
        let l = lTextName;
        for (let i = 0; i < G.D.C.Palette.length; i++) {
            let ColorFon = "rgb(" + G.D.C.Palette[i][0] + "," + G.D.C.Palette[i][1] + "," + G.D.C.Palette[i][2] + ")";
            let ColorContainer = FrameContainer([t, "", l, ""], [SizeColor, SizeColor], ColorFon, inDiv);
            //Событие
            ColorContainer.onmouseover = function () {//фокус
                ColorContainer.style.border = (G.D.S.FrameSize + 2) + "px solid " + G.D.C.Frame;
            };
            ColorContainer.onmouseout = function () {//НЕ фокус
                ColorContainer.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
            };
            ColorContainer.onclick = function () {//клик
                //GCNName.Color = ColorFon;
                GCNName.ColorR = G.D.C.Palette[i][0];
                GCNName.ColorG = G.D.C.Palette[i][1];
                GCNName.ColorB = G.D.C.Palette[i][2];
                GUIChartSave();
                ReDrawChart()
            }

            l += SizeColor + 1;
        }
        t += SizeColor + G.D.S.GapIn;

        //Прозрачность
        TextSimple([t, "", lTextName, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Прозрачность", inDiv);
        t += h + G.D.S.GapIn;
        //Скролл Прозрачность
        let timeoutIDScroll;//Так как каждое смещение скрола будет сохраняться в БД, добавленна задержка
        let ScrollMove1 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
            //Пришло значение value, после сдвига ползунка
            GCNName.ColorA = value;
            clearTimeout(timeoutIDScroll);//Отсмена предыдущей задержки
            timeoutIDScroll = setTimeout(GUIChartSave, 1000);//1 сек.
            ReDrawChart()
        };
        let wscroll = Math.floor((w - lTextName));
        let SetValue = ScrollBar([t, "", lTextName, ""], wscroll, "horizontal", ScrollMove1, inDiv);
        SetValue(GCNName.ColorA) //установит положения ползунка
        t += G.D.S.ScrollThickness + G.D.S.GapIn;

        //Выбор типа графика
        if (GCNName.Type == "Dot" || GCNName.Type == "Box" || GCNName.Type == "Line" || GCNName.Type == "LineSeparated") {
            TextSimple([t, "", lTextName, ""], ["", hText], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Тип графика", inDiv);
            t += hText + G.D.S.GapIn;
            l = lTextName;
            let DivSVGDot = ImageFrameSVG([t, "", l, ""], [SizeColor, SizeColor], SVG_ChatDot(G.D.C.Icon), G.D.C.ButtonFon, true, inDiv);
            DivSVGDot.onclick = function () {//клик
                GCNName.Type = "Dot";
                GUIChartSave();
                ReDrawChart();
            }
            DivSVGDot.onmouseover = function () {//фокус
                DivSVGDot.style.border = (G.D.S.FrameSize + 2) + "px solid " + G.D.C.Frame;
            };
            DivSVGDot.onmouseout = function () {//НЕ фокус
                DivSVGDot.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
            };
            l += SizeColor + 1;

            let DivSVGBox = ImageFrameSVG([t, "", l, ""], [SizeColor, SizeColor], SVG_ChatBox(G.D.C.Icon), G.D.C.ButtonFon, true, inDiv);
            DivSVGBox.onclick = function () {//клик
                GCNName.Type = "Box";
                GUIChartSave();
                ReDrawChart();
            }
            DivSVGBox.onmouseover = function () {//фокус
                DivSVGBox.style.border = (G.D.S.FrameSize + 2) + "px solid " + G.D.C.Frame;
            };
            DivSVGBox.onmouseout = function () {//НЕ фокус
                DivSVGBox.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
            };
            l += SizeColor + 1;

            let DivSVGLine = ImageFrameSVG([t, "", l, ""], [SizeColor, SizeColor], SVG_ChatLine(G.D.C.Icon), G.D.C.ButtonFon, true, inDiv);
            DivSVGLine.onclick = function () {//клик
                GCNName.Type = "Line";
                GUIChartSave();
                ReDrawChart();
            }
            DivSVGLine.onmouseover = function () {//фокус
                DivSVGLine.style.border = (G.D.S.FrameSize + 2) + "px solid " + G.D.C.Frame;
            };
            DivSVGLine.onmouseout = function () {//НЕ фокус
                DivSVGLine.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
            };
            l += SizeColor + 1;

            let DivSVGLineSeparated = ImageFrameSVG([t, "", l, ""], [SizeColor, SizeColor], SVG_ChatLineSeparated(G.D.C.Icon), G.D.C.ButtonFon, true, inDiv);
            DivSVGLineSeparated.onclick = function () {//клик
                GCNName.Type = "LineSeparated";
                GUIChartSave();
                ReDrawChart();
            }
            DivSVGLineSeparated.onmouseover = function () {//фокус
                DivSVGLineSeparated.style.border = (G.D.S.FrameSize + 2) + "px solid " + G.D.C.Frame;
            };
            DivSVGLineSeparated.onmouseout = function () {//НЕ фокус
                DivSVGLineSeparated.style.border = G.D.S.FrameSize + "px solid " + G.D.C.Frame;
            };
            l += SizeColor + 1;
            t += SizeColor + G.D.S.GapIn;
        }



        let hNew = t;


        //Событие
        let OpenModule = function () {

            //inDiv.style.height = inDivSize.h + hNew + "px";
            inDiv.style.height = hNew + "px";

            let found = false;
            //inDivParent = inDiv.parentElement;
            inDivParent = G.C.DivSet;
            //перебор всех дочерних элементов в контейнере
            for (let i = 0; i < inDivParent.childNodes.length; i++) {
                if (inDiv.isEqualNode(inDivParent.childNodes[i])) {//Найден наш inDiv в родительском контейнере
                    found = true;
                    continue;
                }
                if (found) {
                    //Сдвигаем вниз все следующие за нашим inDiv
                    inDivParent.childNodes[i].style.top = Math.round(inDivParent.childNodes[i].offsetTop + hNew - inDivSize.h) + "px";
                }

            }
        };

        let CloseModule = function () {
            inDiv.style.height = inDivSize.h + "px";
            let found = false;
            inDivParent = inDiv.parentElement;
            //перебор всех дочерних элементов в контейнере
            for (let i = 0; i < inDivParent.childNodes.length; i++) {
                if (inDiv.isEqualNode(inDivParent.childNodes[i])) {//Найден наш inDiv в родительском контейнере
                    found = true;
                    continue;
                }
                if (found) {
                    //Сдвигаем вниз все следующие за нашим inDiv
                    inDivParent.childNodes[i].style.top = Math.round(inDivParent.childNodes[i].offsetTop - hNew + inDivSize.h) + "px";
                }

            }
        };

        let Open = true;
        DivContainerSVGTextName.onclick = function () {

            if (Open) {
                OpenModule();
                Open = false;
            } else {
                CloseModule();
                Open = true;
            }
            G.C.DivSet.UpdateScroll();
        }
    }



    ;
}



