
//Прорисовка дизайна приложения
function DrawPageSettings() {
    //console.log("DrawTradePage ");

    //Получение размера окна приложения
    let View = GetViewSize();

    //------------------------------------------------------------------------------------------------------------------
    //Размеры пустых контейнеров
    //Меню
    let menu = {};
    menu.t = G.D.S.GapPage;
    menu.l = G.D.S.GapPage;
    menu.h = 40;
    menu.w = View.w - 2 * G.D.S.GapPage;


    //Левый столбец
    let left = {};
    left.t = menu.t + menu.h + G.D.S.GapWin;
    left.l = G.D.S.GapPage;
    left.h = View.h - left.t - G.D.S.GapPage;
    left.w = G.D.S.SideWinW;

    //Правый столбец
    let right = {};
    right.t = left.t;
    right.l = left.l + left.w + G.D.S.GapWin;
    right.h = left.h;
    right.w = View.w - right.l - G.D.S.GapPage;

    //console.log("menu.t=" + menu.t);
    //console.log("info.t=" + info.t);
    //console.log("chart.t=" + chart.t);


    //------------------------------------------------------------------------------------------------------------------
    //Создаем контейнер "Background". Все последующие элементы будут помещены в этот контейнер

    let DivBackground = Background(View.w, View.h);

    //Размещение контейнеров
    let DivMenu = WindowContainer([menu.t, "", menu.l, ""], [menu.w, menu.h], DivBackground)
    let DivLeft = WindowContainer([left.t, "", left.l, ""], [left.w, left.h], DivBackground);
    let DivRight = WindowContainer([right.t, "", right.l, ""], [right.w, right.h], DivBackground);

    //Наполнение контейнеров
    MainMenu(DivMenu);
    CreateLeft(DivLeft, DivRight);
}

//Функция создает и размещает окно "Левый столбец".
function CreateLeft(inDiv, DivRight) {
    //------------------------------------------------------------------------------------------------------------------
    //Название окна
    //Две кнопки : Купить и Продать
    //Полоса ввода "Цена"
    //   "Цена"
    //   поле ввода цены
    //   единицы
    //   кнопка "текущая"
    //Скролл устанавливающий цену
    //Полоса ввода "Объем"
    //   "Объем"
    //   поле ввода объема
    //   единицы
    //   кнопка "весь"
    //Скролл устанавливающий цену
    //Инфо

    //------------------------------------------------------------------------------------------------------------------
    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);


    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;


    //Меню 
    //{ N: Название, F: Функция прорисовки, P: Название местоположения , },
    let MenuItem = [
        { N: G.L[G.S.L].s1, F: SettingsWin_General, P: "General", },//Общие
        { N: G.L[G.S.L].s2, F: SettingsWin_Simbols, P: "Simbols", },//Все пары
        //{ N: "Тест WebSocket", F: SettingsWin_WebSocket, P: "WebSocket", },//
        { N: G.L[G.S.L].s3, F: SettingsWin_Authorization, P: "Authorization", },//Авторизация
        //{ N: "Мобильное приложение", F: SettingsWin_MobileApp, P: "MobileApp", },//
        { N: G.L[G.S.L].s4, F: SettingsWin_TableNN, P: "TableNN", },//Таблица НС
        //{ N: "Подбор настроек НС", F: SettingsWin_SetNN, P: "SetNN", },//
        //{ N: "База данных", F: SettingsWin_Database, P: "Database", },//
    ];
    //Меню.
    for (let i = 0; i < MenuItem.length; i++) {
        MenuItem[i].Div = TextSimpleClick([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", MenuItem[i].N, inDiv);
        MenuItem[i].Div.onclick = function () {
            for (let i = 0; i < MenuItem.length; i++) {
                MenuItem[i].Div.style.color = G.D.C.TWin;//сброс цвета
            }
            MenuItem[i].Div.style.color = G.D.C.TWinLight;//подсветка выбранного
            DivRight.innerHTML = "";
            G.Page.Settings.SelectedTab = MenuItem[i].P;
            MenuItem[i].F(DivRight);
        }
        t += h;
    }
    //Авто выделение при первой отрисовки экрана.
    for (let i = 0; i < MenuItem.length; i++) {
        if (G.Page.Settings.SelectedTab == MenuItem[i].P) {
            MenuItem[i].Div.onclick();
        }
    }


}




//"Общие"
function SettingsWin_General(inDiv) {
    inDiv.innerHTML = "";

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let l1 = l0 + G.D.S.Tab;
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let WW = 450; //ширина окна
    //let wA = 620;//ширина поля ввода
    let wB = G.D.S.ButtonWidthNormal; //ширина кнопки
    let color;

    inDiv = Container([0, "", 0, ""], [WW, "100%"], inDiv);//Контейнер со скролом 
    inDiv = ModDivScrollV(inDiv, "SettingsWin_General");//добовляем скрол

    //Версия приложения

    if (G.VersiVersionon == 0) {
        let Message = {
            "Type": "GetApplicationVersion",
        };
        MessageSend(Message);
    }
    //Версия приложения
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm010, inDiv);
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.VersiVersionon, inDiv);

    t += 2 * h;
    //Язык
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm020, inDiv);
    let ListLanguage = [];
    for (let l in G.L) { // Выводим свойства вложенного объекта
        console.log("l= " + l);
        ListLanguage.push(l);
    }

    let DivListSelect = ListSelect([t, "", "", l0], [wB, h], G.S.L, ListLanguage, inDiv);
    //Изменение пары
    DivListSelect.fnSelectContent = function (SelectContent) {
        console.log("SelectContent= " + SelectContent);
        G.S.L = SelectContent;
        DrawApplication();
        GUISettingsSave();
    }
    t += 2 * h;

    //Тема
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm030, inDiv);
    t += h;

    if (G.S.GUI_Theme == "bright") {
        color = G.D.C.TWinLight;
    } else {
        color = G.D.C.TWin;
    }
    //Светлая
    let Div1 = TextSimpleClick([t, "", l1, ""], ["", ""], color, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm031, inDiv);
    Div1.onclick = function () {
        SetTheme("bright");
        DrawApplication();
        GUISettingsSave();
    }
    t += h;

    if (G.S.GUI_Theme == "gray") {
        color = G.D.C.TWinLight;
    } else {
        color = G.D.C.TWin;
    }

    //Серая
    let Div2 = TextSimpleClick([t, "", l1, ""], ["", ""], color, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm032, inDiv);
    Div2.onclick = function () {
        SetTheme("gray");
        DrawApplication();
        GUISettingsSave();

    }
    t += h;

    if (G.S.GUI_Theme == "black") {
        color = G.D.C.TWinLight;
    } else {
        color = G.D.C.TWin;
    }

    //Темная
    let Div3 = TextSimpleClick([t, "", l1, ""], ["", ""], color, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm033, inDiv);
    Div3.onclick = function () {
        SetTheme("black");
        DrawApplication();
        GUISettingsSave();

    }
    t += 2 * h;

    //Соединение
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm040, inDiv);
    t += h;

    //Подключаться к Binance автоматически
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm041, inDiv);
    //CheckBox
    let fnCheckBoxOn = function (On) {
        if (On) {
            G.S.Online = true;
        } else {
            G.S.Online = false;
        }
        console.log("  G.S.Online =" + G.S.Online);
        GUISettingsSave();
    };
    let CheckBoxOn = G.S.Online;
    //console.log("  CheckBoxOn=" + CheckBoxOn);
    CheckBox([t, "", "", l0], [h, h], CheckBoxOn, fnCheckBoxOn, inDiv);
    t += 2 * h;

    //IP
    //Сообщить об изменении IP
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm050, inDiv);

    //CheckBox
    let fnCheckBoxOn2 = function (On) {
        if (On) {
            G.S.CheckIP = true;
        } else {
            G.S.CheckIP = false;
        }
        console.log("  G.S.CheckIP =" + G.S.CheckIP);
        GUISettingsSave();
        DrawApplication();

    };
    let CheckBoxOn2 = G.S.CheckIP;
    //console.log("  CheckBoxOn=" + CheckBoxOn);
    CheckBox([t, "", "", l0], [h, h], CheckBoxOn2, fnCheckBoxOn2, inDiv);
    t += h;

    //Отслеживать IP
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm051, inDiv);
    let Div_IP = TextFrameInput([t, "", "", l0], [wB, h], 30, G.S.IP, inDiv);
    Div_IP.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)        
        let IP = Div_IP.value;
        G.S.IP = IP;
        GUISettingsSave();
    };
    t += h;

    //Текущий IP
    TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm052, inDiv);
    //Получить
    let DivBExternalIP = ButtonText([t, "", "", l0], [wB, h], G.L[G.S.L].Get, inDiv);

    DivBExternalIP.onclick = function () {
        let Message = {
            "Type": "GetExternalIP",
        };
        MessageSend(Message);
    }
    t += h;
    //console.log("G.ExternalIP =" + G.ExternalIP);

    if (G.ExternalIP != "") {
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sm052, inDiv);
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.ExternalIP, inDiv);
        t += h;
    }

    inDiv.UpdateScroll();



}

//"Все пары"
function SettingsWin_Simbols(inDiv) {
    inDiv.innerHTML = "";

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let SizeWin = GetDivSizeContent(inDiv);

    //-------------------------

    //type SIStruct struct 
    //Symbol          string  //Имя пары
    //StatusTRADING   bool    //Разрешена ли торговля парой?
    //BaseAsset       string  //Имя базовой валюты
    //BasePrecision   int     //Требуемое количество символов базовой валюты после запятой при создании ордера (для цены и количества)
    //QuoteAsset      string  //Имя квотируемой валюты
    //QuotePrecision  int     //Требуемое количество символов квотируемой валюты после запятой при создании ордера (для цены и количества)
    //OrderTypesLIMIT bool    //Можно создать ордер типа LIMIT, для этой пары?
    //MinPrice        float64 //Минимальная цена ордера
    //TickSize        float64 //Кратность цены. Цена должна быть кратна этому значению.
    //MinQty          float64 //Минимальный объем ордера [базовая валюта]
    //StepSize        float64 //Кратность объема. Объем должен быть кратна этому значению.
    //MinNotional     float64 //Минимальная итоговая сумма ордера. Полученный объем, после сделки. [квотируемая валюта].
    //PermissionsSPOT bool    //Разрешена ли торговля типа SPOT, для этой пары?

    //Шапка таблицы

    let Cap = {};
    let lc = G.D.S.GapIn;

    Cap.Add = {};
    Cap.Add.l = lc;//координата с лева
    Cap.Add.n = "";//текст в шапке
    lc += 25;

    Cap.Symbol = {};
    Cap.Symbol.l = lc;
    Cap.Symbol.n = G.L[G.S.L].Symbol;// "Пара"
    lc += 165;

    Cap.BaseAsset = {};
    Cap.BaseAsset.l = lc;
    Cap.BaseAsset.n = G.L[G.S.L].ss010;//"Базовая <br>валюта"
    lc += 115;

    Cap.QuoteAsset = {};
    Cap.QuoteAsset.l = lc;
    Cap.QuoteAsset.n = G.L[G.S.L].ss020;//"Котируемая <br>валюта"
    lc += 100;

    Cap.MinPrice = {};
    Cap.MinPrice.l = lc;
    Cap.MinPrice.n = G.L[G.S.L].ss030;//"Минимальная <br>цена"
    lc += 105;

    Cap.MinQty = {};
    Cap.MinQty.l = lc;
    Cap.MinQty.n = G.L[G.S.L].ss040;//"Минимальный <br>объем [Б]"
    lc += 105;

    Cap.MinNotional = {};
    Cap.MinNotional.l = lc;
    Cap.MinNotional.n = G.L[G.S.L].ss050;// "Минимальный <br>объем [К]"
    lc += 105;

    Cap.StatusTRADING = {};
    Cap.StatusTRADING.l = lc;
    Cap.StatusTRADING.n = G.L[G.S.L].ss060;//"Разрешена <br>торговля"
    lc += 85;

    Cap.OrderTypesLIMIT = {};
    Cap.OrderTypesLIMIT.l = lc;
    Cap.OrderTypesLIMIT.n = G.L[G.S.L].ss070;//"Разрешен <br>LIMIT"
    lc += 85;

    Cap.PermissionsSPOT = {};
    Cap.PermissionsSPOT.l = lc;
    Cap.PermissionsSPOT.n = G.L[G.S.L].ss080;//"Разрешен <br>SPOT"
    lc += 85;

    Cap.BasePrecision = {};
    Cap.BasePrecision.l = lc;
    Cap.BasePrecision.n = G.L[G.S.L].ss090;//"Точность <br>[Б]"
    lc += 70;

    Cap.QuotePrecision = {};
    Cap.QuotePrecision.l = lc;
    Cap.QuotePrecision.n = G.L[G.S.L].ss100;//"Точность <br>[К]"
    lc += 70;

    Cap.TickSize = {};
    Cap.TickSize.l = lc;
    Cap.TickSize.n = G.L[G.S.L].ss110;//"Кратность <br>цены"
    lc += 85;

    Cap.StepSize = {};
    Cap.StepSize.l = lc;
    Cap.StepSize.n = G.L[G.S.L].ss120;// "Кратность <br>объема"
    lc += 85;

    Cap.BaseCommissionPrecision = {};
    Cap.BaseCommissionPrecision.l = lc;
    Cap.BaseCommissionPrecision.n = G.L[G.S.L].ss130;//"Точность <br>комиссии[Б]"
    lc += 100;

    Cap.QuoteCommissionPrecision = {};
    Cap.QuoteCommissionPrecision.l = lc;
    Cap.QuoteCommissionPrecision.n = G.L[G.S.L].ss140;//"Точность <br>комиссии[К]"
    lc += 100;

    //Заголовок."Список всех торговых пар"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ss150, inDiv);
    t += 2 * h;

    for (let key in Cap) {//Шапка
        TextSimple([t, "", Cap[key].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Cap[key].n, inDiv);
    }
    t += 2 * h;
    //Контейнер для таблицы
    let hT = SizeWin.h - t - G.D.S.GapIn;
    let DivContainer = Container([t, "", 0, ""], ["100%", hT], inDiv);
    let DivCont = ModDivScrollV(DivContainer, "SettingsWin_Simbols");
    t = 0;//сброс
    let wD = lc;
    //Функция отрисовки таблицы
    let DrawTable = function (TopSymbol) {
        for (let Symbol in G.SI) {//строки

            let CheckBoxOn = true;
            if (G.S.TopSymbol.indexOf(Symbol) == -1) {
                CheckBoxOn = false;
            }
            if (TopSymbol) {
                if (!CheckBoxOn) {
                    continue;
                }
            } else {
                if (CheckBoxOn) {
                    continue;
                }
            }


            //CheckBox
            let fnCheckBoxOn = function (On) {
                if (On) {
                    G.S.TopSymbol.push(Symbol);
                } else {
                    for (let i = 0; i < G.S.TopSymbol.length; i++) {
                        if (G.S.TopSymbol[i] == Symbol) {
                            G.S.TopSymbol.splice(i, 1); //Удаляет элементы начиная с i 1 шт.
                            i--;
                        }
                    }
                }
                //Сортировка списка пар
                G.S.TopSymbol.sort();
                GUISettingsSave();
            };

            CheckBox([t, "", Cap["Add"].l, ""], [h, h], CheckBoxOn, fnCheckBoxOn, DivCont);

            //Таблица
            for (let key in G.SI[Symbol]) {//столбцы
                if (!(key in Cap)) {
                    continue;
                }
                let Content = G.SI[Symbol][key];
                switch (key) {
                    case "OrderTypesLIMIT":
                    case "PermissionsSPOT":
                    case "StatusTRADING":
                        if (Content) {
                            Content = G.L[G.S.L].Yes;//"Да"
                        } else {
                            Content = G.L[G.S.L].No;// "Нет"
                        }
                        break;
                }
                DemarcationLine([t, "", 0, ""], wD, "horizontal", DivCont);
                TextSimple([t, "", Cap[key].l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, DivCont);
            }
            t += h;

        }

    }

    DrawTable(true);           //В начале избранные
    DrawTable(false);           //все остальное

    DivCont.UpdateScroll();
}

//"Тест WebSocket"
function SettingsWin_WebSocket(inDiv) {
    inDiv.innerHTML = "";

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let lb1 = 500;//до кнопки
    let wb1 = 200;//ширина кнопки
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let color;


    //Строка.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Тест вэбсокет соединения с Binance", inDiv);
    t += 2 * h;

    //Строка 
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Посмотреть документацию", inDiv);
    let DivDoc = ButtonText([t, "", lb1, ""], [wb1, h], "Перейти", inDiv);
    DivDoc.onclick = function () {
        window.open("https://binance-docs.github.io/apidocs/spot/en/#websocket-market-streams");
    }
    t += 2 * h;



    //Строка 
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Текущие подписки на ВС потоки", inDiv);
    let Div1 = ButtonText([t, "", lb1, ""], [wb1, h], "Посмотреть", inDiv);
    t += h;
    let Div2 = TextSimple([t, "", l0, ""], [lb1 + wb1 - l0, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    ModDivFrame(Div2);
    t += h;
    G.I["LookSubscriptions_R"] = {};
    G.I["LookSubscriptions_R"].F = function (Info) {
        Div2.innerHTML = JSON.stringify(Info);
    }
    Div1.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "LookSubscriptions",
        };
        MessageSend(Message);
    }

    //Строка.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Отписаться от всех подписок на потоки", inDiv);
    let Div3 = ButtonText([t, "", lb1, ""], [wb1, h], "Отписаться", inDiv);
    t += h;
    Div3.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "UnSubscriptionsAll",
        };
        MessageSend(Message);
    }

    //Строка.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Вэбсокет соединение", inDiv);
    let Div31 = ButtonText([t, "", lb1, ""], [wb1 / 2, h], "Запустить", inDiv);
    let Div32 = ButtonText([t, "", lb1 + wb1 / 2, ""], [wb1 / 2, h], "Закрыть", inDiv);
    t += 2 * h;
    Div31.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "StartWS",
        };
        MessageSend(Message);
    }
    Div32.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "StartWS",
        };
        MessageSend(Message);
    }

    //Строка.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Прослушивание выбсокет соединение", inDiv);
    let DivR1 = ButtonText([t, "", lb1, ""], [wb1 / 2, h], "Начать", inDiv);
    let DivR2 = ButtonText([t, "", lb1 + wb1 / 2, ""], [wb1 / 2, h], "Остановить", inDiv);
    DivR1.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "ListenBinanceWebSocketStart",
        };
        MessageSend(Message);
    }
    DivR2.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "ListenBinanceWebSocketStop",
        };
        MessageSend(Message);
    }
    t += 2 * h;

    //Строка 4.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Строка запроса", inDiv);
    t += h;
    let Div4 = TextFrameInput([t, "", l0, ""], [lb1 + wb1 - l0, h], 1000, "", inDiv);
    t += h;
    let Div5 = ButtonText([t, "", lb1, ""], [wb1, h], "Отправить", inDiv);
    t += 2 * h;
    Div5.onclick = function () {
        let Message = {
            "Type": "WSTest",
            "TestName": "Request",
            "V1": Div4.value,
        };
        MessageSend(Message);
    }






    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Сообщения", inDiv);
    t += h;
    let DivCont = Container([t, "", 0, ""], ["100%", 20 * h], inDiv);
    ModDivFrame(DivCont);
    DivCont = ModDivScrollV(DivCont, "SettingsWin_WebSocket"); //добовляем скрол
    DivCont.UpdateScroll();
    let Div6 = TextSimple([0, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", DivCont);
    Div6.style.userSelect = "text";
    t += 20 * h;
    let Div7 = ButtonText([t, "", lb1, ""], [wb1, h], "Очистить", inDiv);
    Div7.onclick = function () {
        Div6.innerHTML = "";
        DivCont.UpdateScroll();
    }
    G.I["ListenBinanceWebSocket"] = {};
    G.I["ListenBinanceWebSocket"].F = function (Info) {
        Div6.innerHTML = Div6.innerHTML + "<br>" + Info.Direction + " :" + Info.MessageJSON;
        DivCont.UpdateScroll();
    }




}

//"Авторизация"
function SettingsWin_Authorization(inDiv) {
    inDiv.innerHTML = "";

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;
    let l1 = 2 * G.D.S.GapIn;

    let wA = 620;//ширина поля ввода
    let WW = wA + 2 * G.D.S.GapIn + G.D.S.ScrollThickness; //ширина окна

    let wB = 200; //ширина кнопки
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;


    inDiv = Container([0, "", 0, ""], [WW, "100%"], inDiv);//Контейнер со скролом 
    inDiv = ModDivScrollV(inDiv, "SettingsWin_General");//добовляем скрол

    //"Авторизация на Binance"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa010, inDiv);
    t += 2 * h;

    //Ввод API Key 
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "API Key", inDiv);
    t += h;
    let DivAPIKey = TextFrameInput([t, "", l0, ""], [wA, h], 64, "", inDiv);
    t += h;



    //Ввод Secret Key
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Secret Key", inDiv);
    t += h;
    let DivSecretKey = TextFrameInput([t, "", l0, ""], [wA, h], 64, "", inDiv);
    t += 1.5 * h;

    //Оповещение о валидности ввода 
    let DivAuthorizationDone = TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    G.I["Authorization_R"].F = function (Info) {
        if (Info) {
            //"Доступ к аккаунту подтвержден"
            DivAuthorizationDone.innerHTML = G.L[G.S.L].sa020;
        } else {
            // "Не удалось выполнить вход в аккаунт"
            DivAuthorizationDone.innerHTML = G.L[G.S.L].sa030;
        }
    }

    //Кнопка "Подтвердить"
    let DivB = ButtonText([t, "", "", l0], [wB, 2 * h], G.L[G.S.L].sa040, inDiv);
    DivB.onclick = function () {
        let Message = {
            "Type": "Authorization",
            "APIKey": DivAPIKey.value,
            "SecretKey": DivSecretKey.value,
        };
        MessageSend(Message);
    }
    t += 3 * h;


    //"Удалить сохранённые ключи"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa050, inDiv);
    //"Удалить"
    let DivBDelete = ButtonText([t, "", "", l0], [wB, h], G.L[G.S.L].Delete, inDiv);

    DivBDelete.onclick = function () {
        let Message = {
            "Type": "AuthorizationDelete",
        };
        MessageSend(Message);
    }

    t += 2 * h;

    //Получить информацию об разрешениях API ключа.
    //"Настройки API ключа"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa060, inDiv);
    //"Получить"
    let DivBAPIKeyPermission = ButtonText([t, "", "", l0], [wB, h], G.L[G.S.L].Get, inDiv);

    DivBAPIKeyPermission.onclick = function () {
        let Message = {
            "Type": "GetAPIKeyPermission",
        };
        MessageSend(Message);
    }
    t += h;
    console.log("G.APIKeyPermission =" + G.APIKeyPermission);

    if (G.APIKeyPermission != undefined) {

        let Content;
        //"Время создания ключа."
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa070, inDiv);
        if (G.APIKeyPermission.CreateTime) { Content = UnixToDate(G.APIKeyPermission.CreateTime).date + " " + UnixToDate(G.APIKeyPermission.CreateTime).time; } else { Content = "Не создан"; }
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, inDiv);
        t += h;
        //"Ограничение по IP."
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa080, inDiv);
        if (G.APIKeyPermission.IPRestrict) { Content = G.L[G.S.L].Yes; } else { Content = G.L[G.S.L].No; }//"Да" "Нет"
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, inDiv);
        t += h;
        //"Разрешено чтение данных аккаунта."
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa090, inDiv);
        if (G.APIKeyPermission.EnableReading) { Content = G.L[G.S.L].Yes; } else { G.L[G.S.L].sa100; }//"Да" "Нет. (Рекомендуется включить)"
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, inDiv);
        t += h;
        //"Разрешена спотовая и маржинальная торговля."
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa110, inDiv);
        if (G.APIKeyPermission.EnableSpotAndMarginTrading) { Content = G.L[G.S.L].Yes; } else { Content = G.L[G.S.L].sa100; }//"Да" "Нет. (Рекомендуется включить)"
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, inDiv);
        t += h;
        //"Разрешен вывод средств."
        TextSimple([t, "", l1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].sa120, inDiv);
        if (G.APIKeyPermission.EnableWithdrawals) { Content = G.L[G.S.L].sa130; } else { Content = G.L[G.S.L].No; }// "Да.  (Рекомендуется отключить)" "Нет"
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Content, inDiv);
        t += h;

    }

    t += 3 * h;
    let Htext1 = G.L[G.S.L].hsa010;


    let DivHelp1 = TextSimple([t, "", l0, ""], [wA - 2 * G.D.S.GapIn, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, inDiv);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический

    inDiv.UpdateScroll();

}

//"Мобильное приложение"
function SettingsWin_MobileApp(inDiv) {
    inDiv.innerHTML = "";

    inDiv = ModDivScrollV(inDiv, "SettingsWin_MobileApp");

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let wA = 620;//ширина контента
    let wB = 200; //ширина кнопки

    //-------------------------
    //Строка 1.
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Мобильное приложение", inDiv);
    t += 2 * h;

    //Строка 
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Создать файл для переноса данных", inDiv);
    let DivBDelete = ButtonText([t, "", l0 + wA - wB, ""], [wB, h], "Создать", inDiv);
    t += h;

    DivBDelete.onclick = function () {
        let Message = {
            "Type": "PackagingMobile",
        };
        MessageSend(Message);
    }

    let Info = TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    Info.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    t += 3 * h;


    WSMessageHandle["PackagingMobile"] = function (M) {
        console.log("Получена  информацию о Упаковка DB для переноса на Android:");
        console.log(JSON.stringify(M));
        let InfoStr = ""
        console.log("M.Info.length = " + M.Info.length);
        if (M.Info != null) {
            for (i = 0; i < M.Info.length; i++) {//Сообщение ввиде массива
                InfoStr += M.Info[i] + "<br>";
            }
        }
        console.log("InfoStr = " + InfoStr);

        Info.innerHTML = InfoStr;
    };

    //Проверка работы в фоновом режиме
    // Получить локальный IP-адреса приложения
    let Message = {
        "Type": "GetLocalIP",
    };
    MessageSend(Message);


    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Проверка работы мобильного приложения в фоновом режиме.", inDiv);
    //let DivBBackgroundCheck = ButtonText([t, "", l0 + wA - wB, ""], [wB, h], "Запустить", inDiv);
    t += h;
    let InfoLocalIP = TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    t += h;
    let InfoBackgroundCheck = TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    InfoBackgroundCheck.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический


    WSMessageHandle["GetLocalIP_R"] = function (M) {
        console.log("Получена информацию о локального IP-адреса");
        console.log(JSON.stringify(M));
        let LocalIP = M.LocalIP;    //string
        InfoLocalIP.innerHTML = "IP: " + LocalIP;
    };

    WSMessageHandle["BackgroundCheck"] = function (M) {
        console.log("Получена информацию о Проверка работы в фоновом режиме:");
        console.log(JSON.stringify(M));
        let TimeDifference = M.TimeDifference;  //int64
        let TimeDuration = M.TimeDuration;  //int64
        let Status = M.Status         //string
        InfoBackgroundCheck.innerHTML = "Статус: " + Status + "<br> Рассинхронизация: " + DurationMsToDate(TimeDifference) + "<br> Длительность теста: " + DurationMsToDate(TimeDuration);
    };
    t += 4 * h;



    let Htext1 = "" +
        "Инструкция по установке приложения на Android.<br>" +
        "<br>" +
        "&nbsp 1. Настроить параметры робота, для авто торговли.<br>" +
        "&nbsp 2. Создать файл для переноса данных.<br>" +
        "&nbsp 3. Скопировать все файлы (BotBotic.apk и BotBoticMobile.db) из каталога «Mobile» и поместить их на мобильное устройство. *<br>" +
        "&nbsp 4. Установить приложение BotBotic.apk.<br>" +
        "&nbsp 5. Открыть приложение, и загрузить файл данных BotBoticMobile.db. Все параметры и настройки будут перенесены на мобильное устройство. <br>" +
        "&nbsp 6. Чтобы запустить авто торговлю нажмите кнопку «Начать». <br>" +
        "<br>" +
        "*Перенос файлов с компьютера на устройство Android. Для этого необходимо подключить мобильное устройство " +
        "к компьютеру с помощью кабеля USB. В диалоговом окне режима работы USB выберите - передача файлов. " +
        "Затем откройте папку с файлами на компьютере и скопируйте их в папку на мобильном устройстве." +
        "<br>" +
        "<br>" +
        "Проверка работы мобильного приложения в фоновом режиме. <br>" +
        "<br>" +
        "Для нормальной работы мобильного приложения, требуется постоянная активность, и неограниченный доступ к интернету. Как правило, на мобильном устройстве, после выключения экрана, приложения переключаться в фоновый режим работы. Это означает, что приложению будет ограничен доступ к интернету, а по прошествию некоторого времени, приложение может быть выключено. <br>" +
        "Что бы обеспечить нормальную работу приложению, в настройках мобильного устройства, необходимо для приложения:  <br>" +
        "- разрешить неограниченное использование трафика в фоновом режиме. <br>" +
        "- запретить функцию экономии заряда аккумулятора <br>" +
        "Внимание, эти настройки уменьшат время автономной работы, мобильного устройства. <br>" +
        "<br>" +
        "Помимо этих настроек могут быть другие настройки или приложения, которые могут ограничивать работу приложения, например фаерфолы, приложения-оптимизаторы, и прочее...  <br>" +
        "<br>" +
        "Что бы убедиться в правильной работе приложения на мобильном устройстве, воспользуйтесь проверкой работы в фоновом режиме. Мобильное и текущее приложение должны быть подключены к одной локальной сети. На текущем приложении будет запущен сервер, симулирующий работу сервера Binance. Приложение на мобильном устройстве будет постоянно отправлять в текущее приложение показатели времени. Инструкция по использованию проверки:  <br>" +
        "<br>" +
        "&nbsp 1. Запустите приложение на мобильном устройстве, перейдите в настройки, введите IP указанный выше, в поле IP мобилного приложения. <br>" +
        "&nbsp 2. Запустите проверку на мобильном приложении.  <br>" +
        "&nbsp 3. Готово. <br>" +
        "<br>" +
        "В текущем приложении будут обновляться показатели Рассинхронизации (это суммарное время бездействия мобильного приложения) и Длительности теста. Если с течением длительного времени (10-30 мин. зависит от настроек мобильного устройства), рассинхронизация не превысит 1-3 минут соответственно, то можно считать, что приложение на мобильном устройстве будет работать нормально. Если мобильное устройство находиться на зарядке, то как правило приложения не переходят в фоновый режим, поэтому во время проверки следует отключить устройство от зарядки. Если показатель длительности теста перестал обновляться, это значит что приложению ограничивается доступ к интернету. <br>" +
        "<br>"
        ;

    let DivHelp1 = TextSimple([t, "", l0, ""], [wA - 2 * G.D.S.GapIn, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, inDiv);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
    inDiv.UpdateScroll();

}


//"Таблица НС"
function SettingsWin_TableNN(inDiv) {
    inDiv.innerHTML = "";


    //Список нейронных сетей. Проверка наличия данные для отображения?
    if (!("List" in G.NN)) {
        let Message = {
            "Type": "NNList",
        };
        MessageSend(Message);
        return;
    }


    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;
    let w0 = 240;//первый столбец
    let w = 170;//остальные столбцы

    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let SizeWin = GetDivSizeContent(inDiv);

    //-------------------------
    //"Таблица НС"
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].snnt010, inDiv);
    t += 2 * h;

    //Левый столбец. Параметры НС.
    let LC = [];
    let i = 0;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nng010;//"Название"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.Name };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nn3;//"Общее"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nng041;//"Время обучения"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return DurationMsToDate(NNSet.TimeTrain) };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nng042;//"Время генерации данных"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return DurationMsToDate(NNSet.TimeInputOutput) };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nn4;//"Архитектура"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nna010;//"Тип архитектуры"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.NN.Architect };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].snnt020;// = "Слои";
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let br = 18;
        let s = "[";
        for (let i = 0; i < NNSet.NN.ArchitectSetup.length; i++) {
            s += NNSet.NN.ArchitectSetup[i] + " ";
            if (s.length > br) {
                s += "<br>";
                br += br;
            }
        }
        s += "]";
        return s;
    };
    i++;

    LC[i] = {};
    LC[i].n = "";//
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nna080;//"Вычислительная мощность"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let NeuronN = NNSet.NN.Neuron.length;//Количество нейронов, без входного, но с выходным слоям.
        let AxonN = NNSet.NN.Axon.length;//Количество аксонов.
        let ComputingPower = NeuronN + AxonN;
        return ComputingPower;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp010;//"Входные данные"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp020;//"Алгоритм компрессии"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        switch (NNSet.AlgorithmCompressionType) {
            case "Smooth":
                return G.L[G.S.L].nndp021;//"Сглаженный"
            case "Extremum":
                return G.L[G.S.L].nndp022; //"Экстремум"
        }
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp030;//"Глубина сглаживания"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = "-";
        switch (NNSet.AlgorithmCompressionType) {
            case "Smooth":
                Content = NNSet.AC_Smooth_Depth;
                return Content;
            case "Extremum":
                return Content;
        }
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp040;//"Минимальный зазор"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = "-";
        switch (NNSet.AlgorithmCompressionType) {
            case "Smooth":
                Content = NNSet.AC_Smooth_Gap;
                return Content;
            case "Extremum":
                Content = NNSet.AC_Extremum_Gap;
                return Content;
        }
    };//возвратит значение для НС 
    i++;


    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp050;//"Нелинейность зазора"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = "-";
        switch (NNSet.AlgorithmCompressionType) {
            case "Smooth":
                Content = NNSet.AC_Smooth_NonlinearGap;
                return Content;
            case "Extremum":
                Content = NNSet.AC_Extremum_NonlinearGap;
                return Content;
        }
    };//возвратит значение для НС 
    i++;



    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp140;//"Сила шума"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.NoiseInput };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp150;//"Выходные данные"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp160;//"Размытие сигнала продажи"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.StopSale };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp161;//"Размытие сигнала покупки"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.StopBuy };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nndp162;//"Зазор между сигналами"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.Gap };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nn7;//"Сходимость"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc010;//"Пройдено эпох обучения"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = (NNSet.ErrorTrade_Iteration) ? NNSet.ErrorTrade_Iteration[NNSet.ErrorTrade_Iteration.length - 1].toFixed(2) : 0;
        return Content;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].g01;//"Сходимость средняя"

    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = (NNSet.ErrorTrade_Average) ? NNSet.ErrorTrade_Average[NNSet.ErrorTrade_Average.length - 1].toFixed(6) : "-";
        return Content;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].g02;//"Сходимость нет сигнала"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = (NNSet.ErrorTrade_NoSignal) ? NNSet.ErrorTrade_NoSignal[NNSet.ErrorTrade_NoSignal.length - 1].toFixed(6) : "-";
        return Content;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].g08;//"Сходимость покупка"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = (NNSet.ErrorTrade_Buy) ? NNSet.ErrorTrade_Buy[NNSet.ErrorTrade_Buy.length - 1].toFixed(6) : "-";
        return Content;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].g07;// "Сходимость продажа"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = (NNSet.ErrorTrade_Sale) ? NNSet.ErrorTrade_Sale[NNSet.ErrorTrade_Sale.length - 1].toFixed(6) : "-";
        return Content;
    };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc040;// "Алгоритмы оптимизации"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        return NNSet.NN.Optimization;
    }
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc050;//"Скорость обучения"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.NN.Rate };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc060;//"Момент обучения"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        let Content = "-";
        if (NNSet.NN.Optimization == "Momentum" || NNSet.NN.Optimization == "MomentumE") {
            Content = NNSet.NN.Momentum;
        }
        return Content;
    };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc070;//"Функция активации"
    LC[i].d = 1;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc080;//"Скрытые слои"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) {
        return NNSet.NN.Activation[1];
    }
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnc090;//"Выходной слой"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) {
        return NNSet.NN.Activation[NNSet.NN.Activation.length - 1];
    }
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nn8;//"Триггер"
    LC[i].d = 0;//Вложенность
    LC[i].f = function () { return "" };
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt020;//"Алгоритм"
    LC[i].d = 1;//Вложенность
    LC[i].f = function (NNSet) {
        switch (NNSet.TriggerAlgorithm) {
            case "Income":
                return G.L[G.S.L].nnt021;//"Доход"
            case "Accuracy":
                return G.L[G.S.L].nnt022; //"Точность"
            case "Manual":
                return G.L[G.S.L].nnt023;//"Ручной"
        }
    };//возвратит значение для НС 
    i++;
    /*
        LC[i] = {};
        LC[i].n = "Размер матрицы";//
        LC[i].d = 1;//Вложенность
        LC[i].f = function (NNSet) {
            switch (NNSet.TriggerAlgorithm) {
                case "Income":
                    return NNSet.TriggerIncomeMatrixSize;
                case "Accuracy":
                    return NNSet.TriggerAccuracyMatrixSize;
                case "Manual":
                    return "-";
            }
        };//возвратит значение для НС 
        i++;
    
    
        LC[i] = {};
        LC[i].n = "Радиус поиска";//
        LC[i].d = 1;//Вложенность
        LC[i].f = function (NNSet) {
            switch (NNSet.TriggerAlgorithm) {
                case "Income":
                    return NNSet.TriggerIncomeRadius;
                case "Accuracy":
                    return NNSet.TriggerAccuracyRadius;
                case "Manual":
                    return "-";
            }
        };//возвратит значение для НС 
        i++;
    */
    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt051;//"Триггер покупки"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.TriggerBuy.toFixed(1) };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt052;//"Триггер продажи"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) { return NNSet.TriggerSale.toFixed(1) };//возвратит значение для НС 
    i++;

    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt053;//"Доход, в %."
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) {
        switch (NNSet.TriggerAlgorithm) {
            case "Income":
                if (NNSet.TriggerIncomeMatrix != null) {
                    //Есть данные поиска триггера
                    let BestTrigger = NNSet.TriggerIncomeMatrix[NNSet.TriggerIncomeBestBi][NNSet.TriggerIncomeBestSi];
                    let Content = BestTrigger.Income.toExponential(3);
                    return Content;
                }
            case "Accuracy":
                return "-";
            case "Manual":
                return "-";
        }
    };//возвратит значение для НС 
    i++;
    /*
        LC[i] = {};
        LC[i].n = "Доход максимальный";//
        LC[i].d = 2;//Вложенность
        LC[i].f = function (NNSet) {
            switch (NNSet.TriggerAlgorithm) {
                case "Income":
                    let MaxIncome = "-";
                    if (NNSet.Trade != null) {
                        //Максимальный доход и количество сделок
                        MaxIncome = -Infinity;
                        for (let i = 0; i < NNSet.Trade.length; i++) {
                            let Income = NNSet.Trade[i].Income;//доход
                            if (MaxIncome < Income) {
                                MaxIncome = Income;
                            }
                        }
                        MaxIncome = MaxIncome.toExponential(3);
                    }
                    return MaxIncome;
                case "Accuracy":
                    return "-";
                case "Manual":
                    return "-";
            }
        };//возвратит значение для НС 
        i++;
    */
    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt054;//"Количество сделок"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) {
        switch (NNSet.TriggerAlgorithm) {
            case "Income":
                if (NNSet.TriggerIncomeMatrix != null) {
                    //Есть данные поиска триггера
                    let BestTrigger = NNSet.TriggerIncomeMatrix[NNSet.TriggerIncomeBestBi][NNSet.TriggerIncomeBestSi];
                    let Content = BestTrigger.NOrder;
                    return Content;
                }
            case "Accuracy":
                return "-";
            case "Manual":
                return "-";
        }

    };//возвратит значение для НС 
    i++;
    /*
        LC[i] = {};
        LC[i].n = "Максимальное кол. сделок";//
        LC[i].d = 2;//Вложенность
        LC[i].f = function (NNSet) {
            switch (NNSet.TriggerAlgorithm) {
                case "Income":
                    let MaxNOrder = "-";
                    if (NNSet.Trade != null) {
                        MaxNOrder = -Infinity;
                        for (let i = 0; i < NNSet.Trade.length; i++) {
                            let NOrder = NNSet.Trade[i].NOrder;//количество сделок
                            if (MaxNOrder < NOrder) {
                                MaxNOrder = NOrder;
                            }
                        }
                    }
                    return MaxNOrder;
                case "Accuracy":
                    return "-";
                case "Manual":
                    return "-";
            }
    
        };//возвратит значение для НС 
        i++;
    */


    LC[i] = {};
    LC[i].n = G.L[G.S.L].nnt081;// "Точность"
    LC[i].d = 2;//Вложенность
    LC[i].f = function (NNSet) {
        switch (NNSet.TriggerAlgorithm) {
            case "Income":
                return "-";
            case "Accuracy":
                if (NNSet.TriggerAccuracyMatrix != null) {
                    //Есть данные поиска триггера
                    let BestTrigger = NNSet.TriggerAccuracyMatrix[NNSet.TriggerAccuracyBestBi][NNSet.TriggerAccuracyBestSi];
                    let Content = BestTrigger.Accuracy.toFixed(3)
                    return Content;
                }
            case "Manual":
                return "-";
        }
    };//возвратит значение для НС 
    i++;
    /*
        LC[i] = {};
        LC[i].n = "Максимальная точность";//
        LC[i].d = 2;//Вложенность
        LC[i].f = function (NNSet) {
            switch (NNSet.TriggerAlgorithm) {
                case "Income":
                    return "-";
                case "Accuracy":
                    if (NNSet.TriggerAccuracyMatrix != null) {
                        //Есть данные поиска триггера
                        let MaxAccuracy = -Infinity;
                        for (let iTB = 0; iTB < NNSet.TriggerAccuracyMatrix.length; iTB++) { //покупка от -100 до 0(не включительно)
                            for (let iTS = 0; iTS < NNSet.TriggerAccuracyMatrix.length; iTS++) { //продажа от 100 до 0(не включительно)
                                let Accuracy = NNSet.TriggerAccuracyMatrix[iTB][iTS].Accuracy
                                //if (Accuracy > 0) {
                                if (MaxAccuracy < Accuracy) {
                                    MaxAccuracy = Accuracy;
                                }
                                //}
                            }
                        }
                        MaxAccuracy = MaxAccuracy.toFixed(3)
                        return MaxAccuracy;
                    }
                case "Manual":
                    return "-";
            }
        };//возвратит значение для НС 
        i++;
    */


    //Контейнер для списка с вертикальным(слева) скролом 
    let hContainerV = SizeWin.h - t - G.D.S.ScrollThickness;//- 2 * G.D.S.GapIn
    let wContainerV = SizeWin.w - 2 * G.D.S.GapIn;
    let DivContV = Container([t, "", 0, ""], [wContainerV, hContainerV], inDiv);
    DivContV = ModDivScrollV(DivContV, "Settings_TableNN_V"); //добавляем скролл
    DivContV.UpdateScroll();




    //Отрисовка названий параметров НС (1 столбец).
    let tp = 0;
    for (let j = 0; j < LC.length; j++) {//Параметры НС.
        let lj = l0 + G.D.S.GapIn * LC[j].d;
        TextSimple([tp, "", lj, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", LC[j].n, DivContV);
        tp += h;
    }


    //Контейнер для списка с горизонтальным(внизу) скролом 
    let hContainerH = tp;//hContainerV- 1 * G.D.S.GapIn
    let wContainerH = wContainerV - w0;//- 2 * G.D.S.GapIn
    let DivContH = Container([0, "", w0, ""], [wContainerH, hContainerH], DivContV);
    //Отдельный контейнер скрола
    let tContainerH = t + hContainerV;//- 5Позиция скрола

    let DivScroll = Container([tContainerH, "", w0, ""], [wContainerH, G.D.S.ScrollThickness], inDiv);
    DivContH = ModDivScrollH2(DivContH, DivScroll, false); //добавляем скролл
    DivContH.UpdateScroll();



    let l = G.D.S.GapIn;
    //Шапка таблицы. Названия НС. + Параметры НС.
    for (let i = 0; i < G.NN.List.length; i++) {//Список всех НС в БД.
        let NameNN = G.NN.List[i];
        //Есть данные для отображения?
        if (!(NameNN in G.NN.N)) {//Данных нет
            let Message = {
                "Type": "NNLoad",
                "Name": NameNN,
            };
            MessageSend(Message);
            return;
            //После прихода ответа, будет вызвана функция, NNSetWin();
        }
        let NNSet = G.NN.N[NameNN].Set;
        //Названия НС.
        let tp = 0;
        //TextSimple([tp, "", l + l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", NameNN, DivContH);
        // tp = 0;
        for (let j = 0; j < LC.length; j++) {//Значения параметров НС.
            TextSimple([tp, "", l + l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", LC[j].f(NNSet), DivContH);
            tp += h;
        }
        let Length = tp - t;
        DemarcationLine([t, "", l, ""], Length, "vertical", DivContH);
        DivContV.UpdateScroll();
        DivContH.UpdateScroll();
        l += w;
    }
    DivContV.UpdateScroll();
    DivContH.UpdateScroll();

}


//"Подбор настроек НС"
function SettingsWin_SetNN(inDiv) {
    inDiv.innerHTML = "";

    //Функция получения данных
    WSMessageHandle["NNSelectionParameters_R"] = function (M) {
        console.log("Получена  информацию о подборе настроек НС:");
        //console.log(JSON.stringify(M));
        G.SP.In = M.Out;//Out["NumberLayers"(Название параметра)]["3"(Значение парамаметра)] = [Стабильность,Точность,Скорость]0-100%
        G.SP.Name = M.Name;//Строки таблицы.  Заголовки: Name = []string{"NumberLayers", "Optimization", "ActivationHide", "ActivationEnd", "Rate", "Momentum", "Total"}
        G.SP.MapName = M.MapName;//Строки таблицы. Подзаголовки: MapName["NumberLayers"] = []string{"---", "3", "4", "5", "6", "7"} 
        if (G.Page.Settings.SelectedTab == "SetNN") {
            SettingsWin_SetNN(inDiv);
        }
    };

    //NumberLayers, Optimization, ActivationHiddeLayers, ActivationEndLayers,Rate,Momentum

    //Функция отправит запрос если условия изменились
    let SendOut = function () {
        let Message = {
            "Type": "NNSelectionParameters",
            "Out": G.SP.Out,
        };
        MessageSend(Message);
    }

    //Проверка наличия данные для отображения?
    if (!("In" in G.SP)) {
        G.SP.Out = {};
        SendOut();
        return;
    }

    if (ObjectIsEmpty(G.SP.Out)) {//Параметры по умолчанию
        for (let i = 0; i < G.SP.Name.length; i++) {
            let Name = G.SP.Name[i];
            G.SP.Out[Name] = 0;
        }
    }

    //Перевод
    let NameT = {
        NumberLayers: "Архитектура. Количество слоёв",
        Optimization: "Оптимизатор",
        ActivationHide: "Активация. Скрытые слои",
        ActivationEnd: "Активация. Выходной слой",
        Rate: "Скорость",
        Momentum: "Момент",
        Total: "Итого",
    };

    /*
        let NumberLayers = ["---", 3, 4, 5, 6, 7];
        let Optimization = ["---", "SGD", "Momentum", "Adam", "RMSProp"];
        let ActivationHide = ["---", "Sigmoid", "Tanh", "ReLU", "LeakyReLU", "ELU", "Swish"];
        let ActivationEnd = ["---", "Sigmoid", "Tanh", "ReLU", "LeakyReLU", "ELU", "Swish"];
        let Rate = ["---", 0.4, 0.2, 0.1, 0.05, 0.01, 0.005, 0.001, 0.0005, 0.0001, 0.0005, 0.00001];
        let Momentum = ["---", 0.8, 0.4, 0.2, 0.1];
    */


    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;
    let w0 = 240;//первый столбец
    let w = 100;//остальные столбцы

    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;
    let SizeWin = GetDivSizeContent(inDiv);

    //-------------------------
    //Строка 1.
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Подбор настроек НС", inDiv);
    t += 2 * h;
    //Шапка показатели для выбранных параметров
    let TC = [];
    let j = 0;

    TC[j] = {};
    TC[j].n = "Стабильность";//Вероятность приостановки вычисления
    j++;

    TC[j] = {};
    TC[j].n = "Точность";//Максимальная
    j++;

    TC[j] = {};
    TC[j].n = "Скорость";//Достижения точности в 1.5 * максимальной точности. 
    j++;

    TC[j] = {};
    TC[j].n = "Количество";//Достижения точности в 1.5 * максимальной точности. 
    j++;

    let FixedValue = function (InV) {
        for (let i = 0; i < InV.length; i++) {
            //console.log("InV[i]=" + InV[i]);
            //console.log("  typeof(x)=" + typeof (InV[i]));
            InV[i] = Number(InV[i]);
            if (InV[i] < 0.005) {
                //InV[i] = "-";
                InV[i] = "0";
            } else {
                if (i == 3) {//Количество
                    InV[i] = InV[i].toFixed(0);
                } else {
                    InV[i] = InV[i].toFixed(2);
                }

            }
        }
        //console.log("InV=" + InV);
        return InV;
    }

    //Левый столбец. Параметры НС.
    let LC = [];
    let Nstr = 0;

    //Составляем структуру - карту таблицы, для быстрой отрисовки
    for (let i = 0; i < G.SP.Name.length; i++) {
        let Name = G.SP.Name[i];//Строки таблицы.  Заголовки: Name = []string{"NumberLayers", "Optimization", "ActivationHide", "ActivationEnd", "Rate", "Momentum", "Total"}
        //console.log("Name=" + Name);

        //Не кнопочные поля
        LC[Nstr] = {};
        LC[Nstr].n = NameT[Name];//Перевод названия "Архитектура. Количество слоёв";
        LC[Nstr].b = false;//Кнопка
        //console.log("LC[Nstr].n=" + LC[Nstr].n);

        if (Name == "Total") {
            let In = G.SP.In[Name][""];//Out["NumberLayers"(Название параметра)]["3"(Значение парамаметра)] = [Стабильность,Точность,Скорость]0-100%
            LC[Nstr].In = FixedValue(In);// Содержание таблицы
            continue;
        }
        Nstr++;
        for (let j = 0; j < G.SP.MapName[Name].length; j++) {
            let MapName = G.SP.MapName[Name][j];//Строки таблицы. Подзаголовки: MapName["NumberLayers"] = []string{"---", "3", "4", "5", "6", "7"} 
            let In = G.SP.In[Name][MapName];//Out["NumberLayers"(Название параметра)]["3"(Значение парамаметра)] = [Стабильность,Точность,Скорость]0-100%
            //console.log("MapName=" + MapName);
            //console.log("In=" + In);

            //Кнопочные поля
            LC[Nstr] = {};
            LC[Nstr].n = MapName;//"---", "3"
            LC[Nstr].b = true;//Кнопка
            LC[Nstr].bClick = function () {// Функция при нажатии
                G.SP.Out[Name] = j;
                SendOut();
            };
            LC[Nstr].s = false;//Выделенна ли строка
            if (G.SP.Out[Name] == j) {
                LC[Nstr].s = true;
            }
            LC[Nstr].In = FixedValue(In);// Содержание таблицы
            //console.log("LC[Nstr].In=" + LC[Nstr].In);

            Nstr++;

        }
    }




    //Отрисовка верхней шапки

    for (let i = 0; i < TC.length; i++) {//Параметры НС.
        let l = l0 + w0 + w * i;
        TextSimpleA([t, "", l, ""], [w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", TC[i].n, inDiv);
        //DemarcationLine([t, "", l, ""], HLength, "vertical", DivCont);
    }

    t += h;

    //Контейнер для таблицы
    let HTableFull = h * (LC.length - 1);//Полная высота таблицы без итогов
    let HTableVisible = SizeWin.h - (t + 100);//Видимая высота таблицы без итогов
    let WCont = 2 * l0 + w0 + w * (TC.length) + G.D.S.GapIn + G.D.S.ScrollThickness;
    let DivCont = inDiv;//Контейнер для таблицы
    if (HTableVisible >= HTableFull) {//Не Нужен скрол контейнер   
        HTableVisible = HTableFull;
    } else {//Нужен скрол контейнер        
        let DivContainer = Container([t, "", 0, ""], [WCont, HTableVisible], inDiv);
        DivCont = ModDivScrollV(DivContainer, "SettingsWin_SetNN");
    }

    let tHelp = t;
    let lHelp = WCont + G.D.S.GapIn;
    let wHelp = SizeWin.w - lHelp - 2 * G.D.S.GapIn;
    if (wHelp > 500) {
        wHelp = 500;
    }
    let hHelp = SizeWin.h - t;


    //Отрисовка левой шапки
    let tp = 0;
    let l = l0 + G.D.S.GapIn;
    for (let i = 0; i < LC.length - 1; i++) {//Строки, кроме последней строки "Итого"        
        if (LC[i].b) {
            let Div_Button = ButtonText([tp, "", l, ""], [w0 - l, h], LC[i].n, DivCont);
            Div_Button.onclick = LC[i].bClick
            if (LC[i].s) {
                Div_Button.onmouseover = function () { };
                Div_Button.onmouseout = function () { };
                Div_Button.style.background = G.D.C.Sale;
                Div_Button.style.color = G.D.C.Black;
            }


        } else {
            TextSimple([tp, "", l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", LC[i].n, DivCont);
        }

        //DemarcationLine([tp, "", l, ""], WLength, "horizontal", DivCont);
        tp += h;
    }



    //Отрисовка содержания таблицы
    for (let j = 0; j < TC.length; j++) {//Столбцы
        let l = l0 + w0 + w * j;
        let tp = 0;
        for (let i = 0; i < LC.length - 1; i++) {//Строки
            if (LC[i].b) {
                let v = LC[i].In[j];
                let Div_Text = TextSimpleA([tp, "", l, ""], [w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", v, DivCont);
                if (LC[i].s) {
                    Div_Text.style.background = G.D.C.Sale;
                    Div_Text.style.color = G.D.C.Black;
                }

            }
            tp += h;
        }
    }
    DivCont.UpdateScroll();

    //строка "Итого"
    t += h + HTableVisible;
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", LC[LC.length - 1].n, inDiv);
    for (let j = 0; j < TC.length; j++) {//Столбцы
        let l = l0 + w0 + w * j;
        let v = LC[LC.length - 1].In[j];
        TextSimpleA([t, "", l, ""], [w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", v, inDiv);
    }


    let Htext1 = "" +
        "Таблица помогает подбирать параметры для обучения НС.<br>" +
        "<br>" +
        "В первом столбце приведены основные параметры НС.<br>" +
        "&nbsp “---” - означает что параметр не выбран.<br>" +
        "<br>" +
        "Следующие столбцы показывают результат выбранных параметров.<br>" +
        "<br>" +
        "&nbsp Стабильность. Это процент успешно завершенных обучений. Во время обучения, могут накапливаться ошибки вычислений, при достижении больших значений НС прерывает своё обучение. Такая НС считается нестабильной.<br>" +
        "<br>" +
        "&nbsp Точность. Это то на сколько ответ НС совпадает с ожидаемым ответом. В таблице отображается максимальная точность для выбранных параметров.<br>" +
        "<br>" +
        "&nbsp Скорость. Это то, как быстро будет достигнут результат в 50% от максимальной точности. " +
        "Например, если максимальная точность 90%, то при достижении 90-(100-90)/2=85%, будет измерен показатель скорости. " +
        "В таблице отображается максимальная скорость для выбранных параметров. Если точность низкая, то скорость достижения этой точности будет высокой.<br>" +
        "<br>" +
        "&nbsp Количество. Это число обученных НС, параметры которых, совпадают с выбранной параметрами.<br>" +
        "<br>" +
        "Для составления таблицы было обучено несколько тысяч НС, с разными параметрами. " +
        "Каждая строка в таблице — это некоторое количество НС (указанное в правом столбце), которые удовлетворяют выбранным пользователем параметрам обучения НС. " +
        "Этот набор оценивается по стабильности, максимальной точности и максимальной скорости из всего набора НС. " +
        "В процессе выбора определенных параметров, число НС будет уменьшаться.<br>" +
        "<br>"
        ;

    let DivHelp1 = TextSimple([tHelp, "", lHelp, ""], [wHelp, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Htext1, inDiv);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический

}







//База данных
function SettingsWin_Database(inDiv) {
    inDiv.innerHTML = "";
    let SizeWin = GetDivSizeContent(inDiv);

    //------------------------------------------------------------------------------------------------------------------
    //Разметка для элементов
    let l0 = G.D.S.GapIn;
    let wDB = 200;//ширина поля имен баз данных
    let wKey = 200; //ширина поля ключей
    let lDB1 = G.D.S.GapIn;
    let lKey1 = lDB1 + wDB + G.D.S.GapIn;
    let lDB2 = lKey1 + wKey + G.D.S.GapIn;
    let lKey2 = lDB2 + wDB + G.D.S.GapIn;
    let lVal2 = lKey2 + wKey + G.D.S.GapIn;
    let wVal = SizeWin.w - lVal2 - G.D.S.GapIn; //ширина поля значение

    let t = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;


    //Строка.
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Управление базами данных", inDiv);
    t += 2 * h;


    //Заголовки 
    TextSimple([t, "", lDB1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Файлы БД", inDiv);
    TextSimple([t, "", lKey1, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Ключи БД", inDiv);
    TextSimple([t, "", lDB2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Файлы БД", inDiv);
    TextSimple([t, "", lKey2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Ключи БД", inDiv);
    TextSimple([t, "", lVal2, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "Значение ключа", inDiv);

    t += h;


    let hBox = 500;
    let DivContainer1 = Container([t, "", lDB1, ""], [wDB, hBox], inDiv);    //Контейнер для имен баз данных Левый
    ModDivFrame(DivContainer1);
    let DivCont1 = ModDivScrollV(DivContainer1, "SettingsWin_Database1");

    let DivContainer2 = Container([t, "", lKey1, ""], [wDB, hBox], inDiv);    //Контейнер для ключей баз данных Левый
    ModDivFrame(DivContainer2);
    let DivCont2 = ModDivScrollV(DivContainer2, "SettingsWin_Database2");

    let DivContainer3 = Container([t, "", lDB2, ""], [wDB, hBox], inDiv);    //Контейнер для имен баз данных Правый
    ModDivFrame(DivContainer3);
    let DivCont3 = ModDivScrollV(DivContainer3, "SettingsWin_Database3");

    let DivContainer4 = Container([t, "", lKey2, ""], [wDB, hBox], inDiv);    //Контейнер для ключей баз данных Левый
    ModDivFrame(DivContainer4);
    let DivCont4 = ModDivScrollV(DivContainer4, "SettingsWin_Database4");

    let DivContainer5 = Container([t, "", lVal2, ""], [wVal, hBox], inDiv);    //Контейнер для значения ключа Select.Key2
    ModDivFrame(DivContainer5);
    let DivCont5 = ModDivScrollV(DivContainer5, "SettingsWin_Database5");


    let ListFile = []; //Список файлов (один для 2х колонок)
    let ListKey1 = []; //Список ключей в файле Select.File1
    let ListKey2 = []; //Список ключей в файле Select.File2
    let ValKey2; //значения ключа Select.Key2

    let Select = {}
    Select.File1 = ""; //имя файла выделенного в первом блоке
    Select.Key1 = "";  //имя ключа выделенного во втором блоке
    Select.File2 = "";  //имя файла выделенного в последнем блоке
    Select.Key2 = "";  //имя ключа выделенного во втором блоке

    //Select.RenameKey1 = "";  //Новое имя ключа выделенного в первом блоке


    t += hBox;
    t += h;
    let wB = 120;
    let DivBCopy = ButtonText([t, "", l0, ""], [wB, h], "Копировать", inDiv);
    let DivTCopy = TextSimple([t, "", l0 + wB + G.D.S.GapIn, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    DivBCopy.onclick = function () {
        let Message = {
            "Type": "DB_BrowserUpdate",
            "Action": "Copy",
            "SelectFile1": Select.File1,
            "SelectKey1": Select.Key1,
            "SelectFile2": Select.File2,
            "SelectKey2": Select.Key2,

        };
        MessageSend(Message);
    }
    t += 2 * h;
    let DivBDelete = ButtonText([t, "", l0, ""], [wB, h], "Удалить", inDiv);
    let DivTDelete = TextSimple([t, "", l0 + wB + G.D.S.GapIn, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    DivBDelete.onclick = function () {
        let Message = {
            "Type": "DB_BrowserUpdate",
            "Action": "Delete",
            "SelectFile1": Select.File1,
            "SelectKey1": Select.Key1,
            "SelectFile2": Select.File2,
            "SelectKey2": Select.Key2,

        };
        MessageSend(Message);
    }
    t += 2 * h;
    let DivBRename = ButtonText([t, "", l0, ""], [wB, h], "Переименовать", inDiv);
    let DivTRename = TextSimple([t, "", l0 + wB + G.D.S.GapIn, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "", inDiv);
    t += h;
    let DivNewNameKey1 = TextFrameInput([t, "", l0, ""], [512, h], 512, "", inDiv);
    DivNewNameKey1.oninput = function () {
        DivTRename.innerHTML = "ключ " + Select.Key1 + " из " + Select.File1 + " в " + DivNewNameKey1.value;
    };

    DivBRename.onclick = function () {
        let Message = {
            "Type": "DB_BrowserUpdate",
            "Action": "Rename",
            "SelectFile1": Select.File1,
            "SelectKey1": Select.Key1,
            "SelectFile2": Select.File2,
            "SelectKey2": Select.Key2,
            "RenameKey1": DivNewNameKey1.value,
        };
        MessageSend(Message);
    }
    t += h;


    let UpdateList = function () {//обновляет инф, после выделения
        let Message = {
            "Type": "DB_BrowserUpdate",
            "Action": "Update",
            "SelectFile1": Select.File1,
            "SelectKey1": "",
            "SelectFile2": Select.File2,
            "SelectKey2": Select.Key2,

        };
        MessageSend(Message);
    }

    let ReDrawBrowser = function () {
        DivCont1.innerHTML = "";
        DivCont2.innerHTML = "";
        DivCont3.innerHTML = "";
        DivCont4.innerHTML = "";
        DivCont5.innerHTML = "";

        let t1 = 0;
        for (let i = 0; i < ListFile.length; i++) {
            let color = G.D.C.TWin;
            if (ListFile[i] == Select.File1) {
                color = G.D.C.TWinLight;
            }
            let DivTextFile1 = TextSimpleClick([t1, "", l0, ""], ["", h], color, G.D.S.FontSizeNormal, "normal", ListFile[i], DivCont1);
            DivTextFile1.onclick = function () {
                Select.File1 = ListFile[i];
                UpdateList();
                ReDrawBrowser();
            }
            t1 += h;
        }
        t1 = 0;
        for (let i = 0; i < ListKey1.length; i++) {
            let color = G.D.C.TWin;
            if (ListKey1[i] == Select.Key1) {
                color = G.D.C.TWinLight;
            }
            let DivTextKey1 = TextSimpleClick([t1, "", l0, ""], ["", h], color, G.D.S.FontSizeNormal, "normal", ListKey1[i], DivCont2);
            DivTextKey1.onclick = function () {
                Select.Key1 = ListKey1[i];
                ReDrawBrowser();
            }
            t1 += h;
        }
        t1 = 0;
        for (let i = 0; i < ListFile.length; i++) {
            let color = G.D.C.TWin;
            if (ListFile[i] == Select.File2) {
                color = G.D.C.TWinLight;
            }
            let DivTextFile2 = TextSimpleClick([t1, "", l0, ""], ["", h], color, G.D.S.FontSizeNormal, "normal", ListFile[i], DivCont3);
            DivTextFile2.onclick = function () {
                Select.File2 = ListFile[i];
                UpdateList();
                ReDrawBrowser();
            }
            t1 += h;
        }
        t1 = 0;
        for (let i = 0; i < ListKey2.length; i++) {
            let color = G.D.C.TWin;
            if (ListKey2[i] == Select.Key2) {
                color = G.D.C.TWinLight;
            }
            let DivTextKey2 = TextSimpleClick([t1, "", l0, ""], ["", h], color, G.D.S.FontSizeNormal, "normal", ListKey2[i], DivCont4);
            DivTextKey2.onclick = function () {
                Select.Key2 = ListKey2[i];
                UpdateList();
                ReDrawBrowser();
            }
            t1 += h;
        }
        t1 = 0;

        let DivTextValKey2 = TextSimple([t1, "", l0, ""], ["100%", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", ValKey2, DivCont5);
        ModDivWhiteSpace(DivTextValKey2);//перенос строки автоматический
        DivTextValKey2.style.userSelect = "text";//разрешить веделение


        DivCont1.UpdateScroll();
        DivCont2.UpdateScroll();
        DivCont3.UpdateScroll();
        DivCont4.UpdateScroll();
        DivCont5.UpdateScroll();

        DivTCopy.innerHTML = "ключ " + Select.Key1 + " из " + Select.File1 + " в " + Select.File2;
        DivTDelete.innerHTML = "ключ " + Select.Key1 + " из " + Select.File1;
        DivTRename.innerHTML = "ключ " + Select.Key1 + " из " + Select.File1 + " в " + DivNewNameKey1.value;

    }

    G.I["DB_BrowserUpdate"] = {};
    G.I["DB_BrowserUpdate"].F = function (Info) {
        if (Info.ListFile == null) {
            Info.ListFile = [];
        }
        if (Info.ListKey1 == null) {
            Info.ListKey1 = [];
        }
        if (Info.ListKey2 == null) {
            Info.ListKey2 = [];
        }
        if (Info.ValKey2 == null) {
            ValKey2 = "";
        } else {
            ValKey2 = JSON.stringify(Info.ValKey2);
        }
        ListFile = Info.ListFile;
        ListKey1 = Info.ListKey1;
        ListKey2 = Info.ListKey2;


        ReDrawBrowser();
    }
    UpdateList("");


}

