//Обработка сообщений с сервера

//console.log("WSMessageHandle ");
//Пример отправки сообщения на сервер
//  let Messages = ["GUI_GetAllSettings"];
//  MessageSend(Messages);

let WSMessageHandle = {};

//Обработчик входящих сообщений.
function MessageHandle(e) {
    let MessageJSON = e.data;
    //console.log("Получено сообщение " + Message);//обрезать больше n символов
    let StartTimer = Date.now();
    MessageObject = JSON.parse(MessageJSON);
    if ((Date.now() - StartTimer) / 1000 > 0.5) {
        console.log("Тип сообщения = " + MessageObject.Type + ". Длительность JSON.parse() = " + (Date.now() - StartTimer) / 1000 + " [c]");
    }
    if (MessageObject.Type in WSMessageHandle) {
        WSMessageHandle[MessageObject.Type](MessageObject);
    } else {
        console.log("ОШИБКА!!!  Получено сообщение c неправильной инструкцией. Type =" + MessageObject.Type);
    }
};


//Обработчик входящих сообщений.
function MessageHandleOld(e) {
    let MessageJSON = e.data;
    //console.log("Получено сообщение " + MessageJSON.substring(0,500));//обрезать больше n символов
    let StartTimer = Date.now();
    MessageObject = JSON.parse(MessageJSON);
    console.log("Длительность = " + (Date.now() - StartTimer) / 1000 + " [c]");

    //console.log("Получено сообщение " + MessageObject);
    if (MessageObject.Type in WSMessageHandle) {
        WSMessageHandle[MessageObject.Type](MessageObject);
    } else {
        console.log("ОШИБКА!!!  Получено сообщение c неправильной инструкцией");
    }
    //return true;
};

WSMessageHandle["GUI_GetSettings_R"] = function (M) {
    //Получены настройки GUI
    console.log("Получены настройки GUI:");
    //console.log(JSON.stringify(M));
    G.S = M.GUISettings;

    if (G.S.FoldersNN == null) {
        G.S.FoldersNN = {};
    }
    if (!G.S.CheckIP) {
        G.CheckExternalIP = "unknown";
    }
    if (!G.S.L) {
        G.S.L = "en";
    }

    SetTheme(G.S.GUI_Theme);//Цветовая тема
};

WSMessageHandle["GUIChartLoad_R"] = function (M) {
    //Получены пользовательские настройки графиков
    console.log("Получены настройки GUI:");
    //console.log(JSON.stringify(M));
    G.GUIChart = M.GUIChart;

    if (G.GUIChart == null) {
        G.GUIChart = {};
    }
    G.GUIChartLoad = true;//Флаг загрузки пользовательских настроек графиков
};



WSMessageHandle["Bot"] = function (M) {

    //Получить настройки робота
    //console.log("Получены настройки робота:");
    //console.log(JSON.stringify(M));


    switch (M.TypeInfo) {
        case "Full":
            {
                console.log("Получены настройки робота:");
                //console.log(JSON.stringify(M));
                G.BotStatusWork = M.StatusWork;
                G.BotStatusWaitConnect = M.StatusWaitConnect;

                G.Bot = M.Bot;
                if (G.Bot.NNWeight == null) {
                    G.Bot.NNWeight = {};
                }
                let aName1 = [];
                let aName2 = [];
                let aXunit = [];
                let aYunit = [];
                let aData = [];
                //Данные графика. Ответ НС.
                if (M.Bot.Out != null) {

                    for (let NameNN in M.Bot.Out) {
                        //console.log("NameNN = " + NameNN);
                        let Name1 = "NNOutTrade";
                        let Name2 = NameNN;
                        let Xunit = "time";
                        let Yunit = "100";
                        let Data = [];
                        for (let i = 0; i < M.Bot.Out[NameNN].length; i++) {
                            Data.push(M.Bot.Out[NameNN][i].T, M.Bot.Out[NameNN][i].D)
                        }
                        aName1.push(Name1);
                        aName2.push(Name2);
                        aXunit.push(Xunit);
                        aYunit.push(Yunit);
                        aData.push(Data);

                    }

                } else {
                    for (let Name in G.C.N) {
                        if (Name.includes("NNOutTrade")) {//возвращает true, если в строке  есть подстрока 
                            delete G.C.N[Name];//Удаляем данные графика
                            console.log("delete = " + Name);
                        }
                    }
                }

                if (M.Bot.OutSum != null) {
                    //Данные графика. Сумарный ответ НС.
                    let Name1 = "NNOutSum";
                    let Name2 = "";
                    let Xunit = "time";
                    let Yunit = "100";
                    let Data = [];
                    for (let i = 0; i < M.Bot.OutSum.length; i++) {
                        Data.push(M.Bot.OutSum[i].T, M.Bot.OutSum[i].D)
                    }
                    aName1.push(Name1);
                    aName2.push(Name2);
                    aXunit.push(Xunit);
                    aYunit.push(Yunit);
                    aData.push(Data);
                } else {
                    let Name = "NNOutSum";
                    delete G.C.N[Name];//Удаляем данные графика
                    console.log("delete = " + Name);

                }
                if (aName1.length > 0) {
                    UpdateDataChart(aName1, aName2, aData, aXunit, aYunit);
                }


            }
            break;
        case "Start":
            {
                G.BotStatusWork = M.StatusWork;
                G.BotStatusWaitConnect = M.StatusWaitConnect;

                G.Bot.B_Start = M.Bot.B_Start;
                G.Bot.Q_Start = M.Bot.Q_Start;
                G.Bot.B_Current = M.Bot.B_Current;
                G.Bot.Q_Current = M.Bot.Q_Current;
                G.Bot.B_InOrder = M.Bot.B_InOrder;
                G.Bot.Q_InOrder = M.Bot.Q_InOrder;

                G.Bot.NNWeight = M.Bot.NNWeight;



                G.Bot.StatusSession = M.Bot.StatusSession;
                G.Bot.StatusCreateOrder = M.Bot.StatusCreateOrder;

                //G.Bot.Attention = M.Bot.Attention;
                G.Bot.AttentionCode = M.Bot.AttentionCode;
                //G.Bot.TimeReStart = M.Bot.TimeReStart;



                //console.log("M.Bot.Out = " + M.Bot.Out);

            }
            break;
        case "Trade":
            {
                G.Bot.B_Start = M.Bot.B_Start;
                G.Bot.Q_Start = M.Bot.Q_Start;
                G.Bot.B_Current = M.Bot.B_Current;
                G.Bot.Q_Current = M.Bot.Q_Current;
                G.Bot.B_InOrder = M.Bot.B_InOrder;
                G.Bot.Q_InOrder = M.Bot.Q_InOrder;
            }
            break;
        case "Status":
            {
                G.BotStatusWork = M.StatusWork;
                G.BotStatusWaitConnect = M.StatusWaitConnect;
            }
            break;
        case "NNOut":
            {
                //console.log("NNOut");
                if (G.Bot.Out == null) {
                    G.Bot.Out = {};
                }
                if (G.Bot.OutSum == null) {
                    G.Bot.OutSum = [];
                }

                //G.Bot.CurrentPrice=M.Bot.CurrentPrice;


                let aName1 = [];
                let aName2 = [];
                let aXunit = [];
                let aYunit = [];
                let aData = [];


                //Данные графика. Ответ НС.
                if (M.Bot.Out != null) {
                    for (let NameNN in M.Bot.Out) {
                        //console.log("NameNN = " + NameNN);
                        let Name1 = "NNOutTrade";
                        let Name2 = NameNN;
                        let Xunit = "time";
                        let Yunit = "100";
                        let Data = [M.Bot.Out[NameNN].T, M.Bot.Out[NameNN].D];
                        aName1.push(Name1);
                        aName2.push(Name2);
                        aXunit.push(Xunit);
                        aYunit.push(Yunit);
                        aData.push(Data);
                        if (NameNN in M.Bot.Out) {
                            let LastTime = 0;
                            if (NameNN in G.Bot.Out) {
                                LastTime = G.Bot.Out[NameNN][G.Bot.Out[NameNN].length - 1].T;
                            }
                            if (LastTime == M.Bot.Out[NameNN].T) {
                                G.Bot.Out[NameNN][G.Bot.Out[NameNN].length - 1] = M.Bot.Out[NameNN];
                            } else {
                                if (!(NameNN in G.Bot.Out)) {
                                    G.Bot.Out[NameNN] = [];
                                }
                                G.Bot.Out[NameNN].push(M.Bot.Out[NameNN]);
                            }
                        }
                    }
                }
                //Данные графика. Сумарный ответ НС.
                let Name1 = "NNOutSum";
                let Name2 = "";
                let Xunit = "time";
                let Yunit = "100";
                let Data = [M.Bot.OutSum.T, M.Bot.OutSum.D];
                aName1.push(Name1);
                aName2.push(Name2);
                aXunit.push(Xunit);
                aYunit.push(Yunit);
                aData.push(Data);
                let LastTime = 0;
                if (G.Bot.OutSum.length > 0) {
                    LastTime = G.Bot.OutSum[G.Bot.OutSum.length - 1].T;
                }
                if (LastTime == M.Bot.OutSum.T) {
                    G.Bot.OutSum[G.Bot.OutSum.length - 1] = M.Bot.OutSum;
                } else {
                    G.Bot.OutSum.push(M.Bot.OutSum);
                }
                if (aName1.length > 0) {
                    UpdateDataChart(aName1, aName2, aData, aXunit, aYunit);
                }

            }
            break;

    }
    //Если обновляемые данные видны, то обновляем просмотр
    if (G.Page.Name == "Trade") {
        if (G.Page.Trade.SelectedTabR == "AutoTrading") {
            if ("Trade_AutoTrading" in G.F) {
                G.F.Trade_AutoTrading();
            }
        }

        if (G.Page.Trade.SelectedTabL == "Bot") {
            if ("Trade_Bot" in G.F) {
                G.F.Trade_Bot();
            }
        }
    }
};


WSMessageHandle["DataForChart_R"] = function (M) {

    //Данные для графика. Пришедшее сообщение — это событие для создания или обновления графика
    if (M.Data.length > 2) {
        //console.log("График. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Количество элементов = " + (M.Data.length / 2));
        //console.log("Получены данные для графика. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Xunit = " + M.Xunit + "; Yunit = " + M.Yunit);
        //console.log("Данные = " + M.Data);

        //console.log("            Количество элементов = " + (M.Data.length / 2));
        //console.log(JSON.stringify(M).slice(0, 500));//первые n символов
        //console.log("....");
        //console.log(JSON.stringify(M).slice(-500));//последние n символов
    }
    if (M.Data.length <= 2) {//
        //console.log("Получены данные для графика. "+ M.Name2+" "+UnixToDate(Number(M.Data[0])).date+" "+UnixToDate(Number(M.Data[0])).time+" "+M.Data[1]);
        //console.log("Получены данные для графика. " + M.Name2 + " Х=" + M.Data[0] + " Y=" + M.Data[1]);//
    }//
    if (M.Name1 == "Price") {
        //console.log("График. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Количество элементов = " + (M.Data.length / 2));
    }
    if (M.Name1 != "Price") {
        //console.log("График. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Количество элементов = " + (M.Data.length / 2));
        //console.log("Получены данные для графика. " + M.Name2 + " Х=" + M.Data[0] + " Y=" + M.Data[1]);//

    }


    //let StartTimer = Date.now();
    //console.log("Старт.     График. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Количество элементов = " + (M.Data.length / 2));
    UpdateDataChart(M.Name1, M.Name2, M.Data, M.Xunit, M.Yunit);
    //console.log("Отрисован. График. Name1 = " + M.Name1 + "; Name2 = " + M.Name2 + "; Количество элементов = " + (M.Data.length / 2));

    //if ((Date.now() - StartTimer) / 1000 > 0.5) {
    //    console.log("Длительность UpdateDataChart() = " + (Date.now() - StartTimer) / 1000 + " [c]");
    //}
};


WSMessageHandle["NNList_R"] = function (M) {

    console.log("Получен список НС:");
    //console.log(JSON.stringify(M));
    G.NN.List = M.NNList;
    if (G.NN.List == null) {
        G.NN.List = [];
    }
    if (G.Page.Name == "NN") {
        NNListWin();
    }
    if (G.Page.Name == "Settings" && G.Page.Settings.SelectedTab == "TableNN") {
        DrawApplication();
    }
};

WSMessageHandle["ApplicationVersion"] = function (M) {

    console.log("Получена версия прилложения:");
    //console.log(JSON.stringify(M));
    G.VersiVersionon = M.ApplicationVersion;

    if (G.Page.Name == "Settings" && G.Page.Settings.SelectedTab == "General") {
        DrawApplication();
    }
};




WSMessageHandle["NNLoad_R"] = function (M) {

    //console.log("Получены данные НС:");
    //console.log(JSON.stringify(M));//

    let NameNN = M.NNSet.Name;
    //Есть ли в списке имя этой НС. Если нет, то добавим.
    let add = true;
    for (let i = 0; i < G.NN.List.length; i++) {
        if (NameNN == G.NN.List[i]) {
            add = false;
        }
    }
    if (add) {
        G.NN.List.push(NameNN);
    }
    G.NN.N[NameNN] = {};
    G.NN.N[NameNN].Set = M.NNSet;

    if (!(NameNN in G.Page.NN.DataSetSelectList)) {
        G.Page.NN.DataSetSelectList[NameNN] = 0;
    }


    //Если обновляемые данные видны, то обновляем просмотр
    if (G.Page.Name == "NN") {// && G.SubPage.NN == "Trigger" && G.Page.NN.SelectNameNN == NameNN
        NNSetWin();
    }
    if (G.Page.Name == "Settings" && G.Page.Settings.SelectedTab == "TableNN") {
        DrawApplication();
    }

};


WSMessageHandle["DrawApplication"] = function (M) {

    console.log("Получена команда отрисовки приложения:");
    console.log(JSON.stringify(M));
    DrawApplication();
};


WSMessageHandle["ExchangeInformation_R"] = function (M) {

    console.log("Получены данные о всех парах и правила торговли. ExchangeInformation :");
    //console.log(JSON.stringify(M).slice(0, 500));//первые n символов
    //console.log("....");
    //console.log(JSON.stringify(M).slice(-500));//последние n символов

    G.SI = {};
    G.SI = M.SI
};


WSMessageHandle["UpdateAI"] = function (M) {
    console.log("Получена  информацию о аккаунте (кошелек, состояние). :");
    //console.log(JSON.stringify(M));
    G.AI = M.AI;

    if (G.Page.Trade.SelectedTabL == "Balance") {
        if ("Trade_Balance" in G.F) {
            G.F.Trade_Balance();
        }
        return;
    }

    if ("Trade_ManualTrading" in G.F) {
        G.F.Trade_ManualTrading();
    }
    if ("Trade_Bot" in G.F) {
        G.F.Trade_Bot();
    }


};


WSMessageHandle["UpdateOrderHistory"] = function (M) {
    console.log("Получена  информацию о истории ордеров :");
    console.log(JSON.stringify(M));
    //G.OH[пара]=[]OrderHistoryStruct
    OH = M.OH;//массив
    if (OH != null) {
        let Symbol = OH[0].Symbol
        console.log("символ = " + Symbol);
        if (!(Symbol in G.OH)) {//Данных на этот символ нет.
            console.log("Данных на этот символ нет.");
            G.OH[Symbol] = OH;
        } else {//Данные на этот символ уже имеются, это обновлен.
            console.log("Данных на этот символ нет.");
            //Ищем совпадения по OrderID и заменяем на новый из OH
            for (let i = 0; i < OH.length; i++) {
                let Found = false;
                for (let j = 0; j < G.OH[Symbol].length; j++) {
                    if (OH[i].OrderID == G.OH[Symbol][j].OrderID) {        //Найдено совпадения по OrderID заменяем на новый из OH
                        G.OH[Symbol][j] = OH[i];
                        Found = true;
                        break;
                    }
                }
                if (!Found) {  //совпадения по OrderID найдено,   добавляем новый из OH в конец списка
                    G.OH[Symbol].push(OH[i]);
                }
            }
        }
    } else {
        //G.OH[Symbol]=[];
    }
    if ("Trade_Order" in G.F) {
        G.F.Trade_Order();
    }
};


WSMessageHandle["CreateOrderInfo"] = function (M) {
    console.log("Получена  информацию о истории ордеров :");
    console.log(JSON.stringify(M));
    if ("CreateOrderInfo" in G.F) {
        G.F.CreateOrderInfo(M.Info);
    }
};

WSMessageHandle["APIKeyPermission"] = function (M) {

    console.log("Получена Информация об разрешениях API ключа. :");
    console.log(JSON.stringify(M));

    G.APIKeyPermission = M.APIKeyPermission;

    //Если обновляемые данные видны, то обновляем просмотр
    if (G.Page.Name == "Settings" && G.Page.Settings.SelectedTab == "Authorization") {
        DrawApplication();
    }
};


WSMessageHandle["ExternalIP"] = function (M) {

    console.log("Получена Информация о внешнем IP приложения. :");
    console.log(JSON.stringify(M));

    G.ExternalIP = M.ExternalIP;

    //Если обновляемые данные видны, то обновляем просмотр
    if (G.Page.Name == "Settings" && G.Page.Settings.SelectedTab == "General") {
        DrawApplication();
    }
};




WSMessageHandle["InfoGUI"] = function (M) {
    //console.log("Получена информация о состоянии серверной части:");
    //console.log(JSON.stringify(M));
    //G.I[M.InfoID].F- это принимающая и обрабатывающая функция, которая пишется в месте кода назначения
    if (M.InfoID in G.I) {
        if ("F" in G.I[M.InfoID]) {
            G.I[M.InfoID].F(M.Info);
        }
    }
};

WSMessageHandle["Alerts"] = function (M) {
    //console.log("Получены оповещения:");
    //console.log(JSON.stringify(M));

    //Оповещения. Небольшие и несистематические сообщения для GUI. Alerts[ID]Info, В GUI соответствует G.A[ID]={}
    for (let ID in M.Alerts) {
        //Добавим оповещение 
        G.A[ID] = M.Alerts[ID];
        if (ID in G.Af) {
            //Для этого оповещения есть функция 
            G.Af[ID]();
        }
    }



};


WSMessageHandle["InfoRAM"] = function (M) {
    G.InfoRAM = M.Ram;
};

//Ф-ция запроса данных цен, для построения графика, если они отсутствуют. Forced=true Принудительно (в независимости от наличия данных) сделает запросс
//Действие "SUBSCRIBE"|"UNSUBSCRIBE"
function GetPrice(Symbol, Forced) {
    if (!Symbol) {//Есть данные для отображения графика     
        console.log("ОШИБКА!!! Запрос Price для символа " + Symbol);
    }
    //console.log("Запрос Price для символа " + Symbol + " Принудительный = " + Forced);

    if (Forced) { //Принудительный запрос
        Message = { //Запрос на получение данных для графика  
            "Type": "Price",
            "Symbol": Symbol,
            "Action": "SUBSCRIBE", //Действие "SUBSCRIBE"|"UNSUBSCRIBE"
            "StartTime": 0,   //Запрос свечей, от этого UNIX времени включительно. При = 0, от первой свечи. При <0 , = текущая свеча - |StartTime|
            "EndTime": 0,   //Запрос свечей, до этого UNIX времени включительно. При = 0, до текущей свечи.
        };
        MessageSend(Message);
    } else {//Если данные есть то запроса не будет, и график будет перерисован
        if (("Price" + Symbol) in G.C.N) {//Есть данные для отображения графика   
            //console.log("Повторный запрос Price для символа " + Symbol);
            DrawChart();
        } else {//Нет данных для отображения графика           
            Message = { //Запрос на получение данных для графика  
                "Type": "Price",
                "Symbol": Symbol,
                "Action": "SUBSCRIBE", //Действие "SUBSCRIBE"|"UNSUBSCRIBE"
                "StartTime": 0,   //Запрос свечей, от этого UNIX времени включительно. При = 0, от первой свечи. При <0 , = текущая свеча - |StartTime|
                "EndTime": 0,   //Запрос свечей, до этого UNIX времени включительно. При = 0, до текущей свечи.
            };
            MessageSend(Message);
        }
    }


}
//Ф-ция запроса данных цен, для построения графика, если они отсутствуют.
//Действие "SUBSCRIBE"|"UNSUBSCRIBE"
function DeletePrice(Symbol) {
    Message = { //Запрос на получение данных для графика  
        "Type": "Price",
        "Symbol": Symbol,
        "Action": "UNSUBSCRIBE", //Действие "SUBSCRIBE"|"UNSUBSCRIBE"
        "StartTime": 0,   //Запрос свечей, от этого UNIX времени включительно. При = 0, от первой свечи. При <0 , = текущая свеча - |StartTime|
        "EndTime": 0,   //Запрос свечей, до этого UNIX времени включительно. При = 0, до текущей свечи.
    };
    MessageSend(Message);
}


//Запрос обновить информацию о аккаунте (кошелек, состояние)
function GetUpdateAI() {
    let Message = {
        "Type": "UpdateAI",
    };
    MessageSend(Message);
}


function GUISettingsSave() {//Сохраняет настройки GUI
    let Message = {
        "Type": "GUISettingsSave",
        "GUISettings": G.S,
        /*
        "GUI_Theme": G.S.GUI_Theme,
        "TopSymbol": G.S.TopSymbol,
        "OrderSymbol": G.S.OrderSymbol,
        "ManualTradeSymbol": G.S.ManualTradeSymbol,
        "FoldersNN": G.S.FoldersNN,
        ...
        */
    };
    MessageSend(Message);
}



function GUIChartSave() {//Сохраняет настройки GUI
    for (let Name in G.C.N) {
        let GCNName = G.C.N[Name];//объект отрисовываемого графика
        G.GUIChart[Name] = {};
        G.GUIChart[Name].Type = GCNName.Type;
        G.GUIChart[Name].ColorR = GCNName.ColorR;
        G.GUIChart[Name].ColorG = GCNName.ColorG;
        G.GUIChart[Name].ColorB = GCNName.ColorB;
        G.GUIChart[Name].ColorA = GCNName.ColorA;
        //G.GUIChart[Name].Title = GCNName.Title;
    }

    let Message = {
        "Type": "GUIChartSave",
        "GUIChart": G.GUIChart,
    };
    MessageSend(Message);
}

