//Все данные клиента (переменные, ф-ции, объекты). Обновляемая БД. В основном контент GUI = Графики, настройки, ...
let G = {};
//Версия приложения
G.VersiVersionon = 0;
//Язык приложения
G.L = {};//G.L["en"].t1="текс 1"; G.L[G.S.Language].t1="текс 1";G.L[G.S.L].t1="текс 1";

//Местоположение.
G.Page = {};
G.Page.Name = "Trade";//Текущая страница. NN,Trade,Settings

G.Page.NN = {};//Для страницы NN
G.Page.NN.SelectedNNTab = "Favorites";//Имя вкладки окна списка НС, открываемая при входе: Favorites,Archive.
G.Page.NN.SelectedTab = "General";//Имя вкладки окна настроек НС, открываемая при входе: General,Architecture,Convergence,Trigger.....
G.Page.NN.SelectedTrigger = "Trigger";//Какой график показывать "Trigger" или "Price"
G.Page.NN.SelectNameNN = "";//Выбранная НС. //Вместо G.Page.NN.SelectNameNN
G.Page.NN.DataSetSelectList = {};//Выбранный набор из списка G.Page.NN.DataSetSelectList["NameNN"]=индекс


G.Page.Trade = {};//Для страницы Trade
G.Page.Trade.SelectedTabL = "Bot";//Имя вкладки на странице Trade, левого окна, открываемая при входе: Bot, Balance, Order.
G.Page.Trade.SelectedTabR = "AutoTrading";//Имя вкладки окна торговли: AutoTrading, ManualTrading.

G.Page.Settings = {};//Для страницы Settings
G.Page.Settings.SelectedTab = "General";//Имя вкладки окна настроек НС, открываемая при входе: View,,,.....


G.Page.ChartSet = false;// Отображено ли окно настройки графика
G.Page.AddPriceChart = [];// Добавленные пользователем графики, с помощью меню настройки графиков.



G.Page.ChartSetUpDate = true;//Изменились ли данные окна настройки графика
G.Page.TopSelectSymbol = false;//Выбор символа по умолчанию - избавится
G.СonnectBinanceStatus = "unknown"; //Текущее состояние соединения. true - соединено (последнее соединение не более 30сек назад, было успешным) / false /unknown
G.InfoRAM = 0;//Индикатор оперативной памяти
G.CheckExternalIP = "unknown";//Проверить изменился ли внешний IP


G.S = {}; //Пользовательские настройки GUI, что храниться в БД.

G.PartDelete = 0.2;//Прореживание. Величина прореживания.
G.PartAdd = 0.8;//Добавление. Величина Добавление.
G.PartAddNoise = 0.75;//Зашумленность добавляемых весов. 
G.TypeArchitecturePlot = "Default";//"Default" обычный график архитектуры | "Pruning" покажет удаляемые элементы для операции прореживания.  | "Extension" покажет добовляемые элементы для операции расширения. 

//дизайн
G.D = {};
//G.D.F - шрифт
//G.D.C - цвета
//G.D.S - размеры



//Датчика сервера.
G.I = {}; // Принимает различную информацию с сервера, и запускается функция .F. Информация: Текущие процессы, прогрессы, состояния, ошибки, другая инфа. 
//G.I[M.InfoID].F(M.Info); где M.InfoID идентификатор функции .F,  (M.Info) - аргумент функции (объект/переменная...) 
G.I.СonnectBinanceStatus = {};
G.I.Authorization_R = {};
G.I.NNListTraining = {};
G.I.CheckExternalIP = {};


//Разное
G.F = {}; //Динамические ф-ции
//Разное
G.TimerIdPriceSubscribe = {};//Таймеры подписок на обновляемые графики G.TimerIdPriceSubscribe[пара]= timerId

//графики
G.C = {};
//G.C.DivC - Div контейнер графика. В нем будет элементы CANVAS, для каждого графика свой CANVAS.
//G.C.DivY - Div контейнер вертикальной оси
//G.C.DivX - Div контейнер горизонтальной оси
//G.C.DivSet  - Div контейнер окна настройки
//G.C.DivTop  - Div контейнер шапки графика
//G.C.DivContainer - Div контейнер, наивысшего уровня, он включает все остальные контейнеры графика, нужен для полной очистки графика. Включает окно настроек.
//G.C.Сontext - canvas холст графика
//G.C.ChartType - Тип графика. Всего существует 3 типа для графиков: Standard, Architecture, Trigger. Для каждого из них свои окна.
G.C.ActiveСursor = {};   //Переменная активного курсора.
//G.C.ActiveСursor.Div   Контейнер активного курсора. Повторяет контейнер графической части G.C.DivC, но в отличии от него не перерисовывается, при обновлении графика.



//*Правила
//1. В объекте могут храниться, и обновляться данные для множества графиков. Но отображаются только G.C.S.Display
//2. По оси X может быть только одна размерность (особенности масштабирования мышью). Но по Y может быть множества единиц измерений.
//3. Трансформации. Только 2 переменные изменяется непосредственно DisplayXMax и Kpx, остальные вычисляться на базе этих изменений:
//   Перемещение. Изменяется правое видимое значение DisplayXMax
//   Авто обновление данных. Изменяется правое видимое значение DisplayXMax
//   Масштабирование. Изменяется правое видимое значение DisplayXMax, и масштаб Kpx - коэффициент, на который будем умножать значение, и получать пикселы.


G.C.S = {};//Общие Настройки для графиков
G.C.S.Display = []; //Список отображаемых графиков. [Name,...]
G.C.S.SubscribePrice = [];//Подписки на изменение цены до разъединения с Binance. [Пара,..]
//Отступ с права [количество пикселей], при G.C.U[Xunit].AutoScale=true
G.C.S.WAutoScale = 0.9;//[%] от всей ширины, который занимает график при AutoScale
G.C.S.HMin = 5; //[px]  минимальная высота Y (чтобы не сливался с осью)
G.C.S.GapMinW = 3; //Зазор для прямоугольного графика появиться когда минимальная ширина столбика больше этого значения.
G.C.S.DotRadius = 4; //Радиус точки
G.C.S.MinData = 20;// минимальное отображаемое количество точек графика         

//Настройки для конкретного графика
G.C.N = {};//G.C.N[Name] - Название графика (вместо Name - название) Название= Тип + Пара (Name=Name1+Name2) Пример = "PriceETHUSDT" или "NNETHUSDT";
//G.C.N[Name].Name1 ;//Name1= Первое имя. Price/Convergence/Smooth/Compression/OutputData/OutputTest/NNOutTrade/NNOutTest/OrderTest/OrderTrade
//G.C.N[Name].Name2 ;//Name2= Второе имя. Пара/имя НС/""
//G.C.N[Name].Title ;//Пользовательское имя. Дополнительное имя, которое будет дополнять первое имя. = Цена/ сходимость / триггер
//G.C.N[Name].Type = Box/Line/Dot;//Тип графика
//G.C.N[Name].Color = //Цвет
//G.C.N[Name].Data - Все данные для графика. Массив (двумерный) типа G.C.Name.Data = [[X, Y],  ...] где X время Unix [ms], Y значение (цена, сигнал НС, сходимость)
//G.C.N[Name].MapDisplayData  [[X[px], Y[px]],... ]
//G.C.N[Name].Yunit = ETHUSDT/BTCUSDT/1/convergence. Единица. Если единица совпадает с другими данными, то ось становиться общая для этих графиков.
//G.C.N[Name].Xunit = time/iteration. Еденица. Если еденица совпадает с другими данными, то ось становиться общая для этих графиков.
//Настройки отображения. Активно изменяемые параметры
//Удален G.C.N[Name].DisplaySettings = true/false;Есть ли настройки отображения, или это новый график.
//G.C.N[Name].X/Y.AutoScale = true/false; для Y график автоматически масштабируеться по минимальному/максимальному значению, для X - автообновление(смещение при добавлении новых данных)
//G.C.N[Name].X/Y.DisplayMin = Отображаемые на экране данные по оси, = значения из G.C.N[Name][].Data
//G.C.N[Name].X/Y.DisplayMax = Отображаемые на экране данные по оси, = значения из G.C.N[Name][].Data
//G.C.N[Name].X/Y.Kpx коэффициент, на который будем умножать значение, и получать пикселы. Непосредственно связан с (DisplayMax-DisplayMin)
//G.C.N[Name].X/Y.AbsoluteMax = Наибольшее значения из всех данных в списке отображаемых графиков G.C.S.Display.
//G.C.N[Name].X/Y.AbsoluteMin = Наименьшее значения из всех данных в списке отображаемых графиков G.C.S.Display.


//Пользовательчкие настройки для конкретного графика (Цвет, Тип, Прозрачность)
G.GUIChart = {};//G.GUIChart[Name] - Название графика (вместо Name - название) Название= Тип + Пара (Name=Name1+Name2) Пример = "PriceETHUSDT" или "NNETHUSDT";
G.GUIChartLoad = false;//Флаг загрузки




//Нейронные сети
G.NN = {};
//G.NN.List = []; Список всех НС в БД.
//G.NN.ListTraining = []; Список обучаемых НС в текущий момент.
G.NN.ListTasting = []; //Список тестируемых НС в текущий момент.

//G.NN.DivNNList; Контейнер окна.
//G.NN.DivNNSet; Контейнер окна.
G.NN.N = {};
//G.NN.N[Name]= {}; Название НС (вместо Name - название)
//G.NN.N[Name].Set; Объект настройки. Соответствует NNSetStruct struct
G.SP = {};//Подбор настроек НС


//Робот
G.Bot = {};//Объект робота.
G.BotStatusWork = false;//Робот рабоает.
G.BotStatusWaitConnect = false;//Робот соединен.


//Оповещения.  Небольшие и несистематические сообщения для GUI. Alerts[ID]Info, В GUI соответствует G.A[ID]={}
G.A = {};
G.Af = {};//Набор функций, которые реагируют на эти сообщения

//Все пары и правила торговли, для каждого символа.. ExchangeInformation
G.SI = {}; // map[пара]SIStruct 
//Информация по аккаунту (Соответствует AIStruct struct) 
//G.AI = {};
//Информация по всем ордерам, для пары. G.OH[пара]=[]OrderHistoryStruct
G.OH = {};

//Информация об разрешениях API ключа.
//G.APIKeyPermission = {};
//Внешний IP приложения.
G.ExternalIP = "";
//Настройки ручной торговли 
G.T = {};

//G.InputOutputDataStatistic[NameNN]={статистика}
G.InputOutputDataStatistic = {};
G.StatisticIn = {};
G.StatisticOut = {};

//----------------------------------------------------------------------------------------------------------------------
//Цветовые схемы
function SetTheme(Theme) {
    //hsl:  тон, насыщенность тона, светлота
    switch (Theme) {
        case "gray"://Серая
            G.D.C = {
                //Name: "gray",
                //Элементы
                FonSite: "hsl(0,0%,50%)", //цвет фона сайта //(128,128,128)
                //FonSite: "hsl(0,0%,30%)", //цвет фона сайта //(77,77,77)
                Frame: "hsl(0,0%,35%)", //цвет рамок окна, и разделительных линий//(89,89,89)
                WinFon: "hsl(0,0%,40%)", //цвет фона окна   //(102,102,102) 
                //Текст
                TWin: "hsl(0,0%,5%)", //цвет текста, в окнах обычный//(13,13,13)
                TWinLight: "hsl(0,0%,65%)", //цвет текста, в окнах подсвеченный//(166,166,166)
                //Кнопка
                ButtonText: "hsl(0,0%,65%)", //цвет текста кнопки //(166,166,166)
                ButtonTextFocus: "hsl(0,0%,55%)", //цвет текста фокуса кнопок//(140,140,140)
                ButtonFon: "hsl(0,0%,25%)", //цвет фона кнопок//(64,64,64)
                ButtonFonFocus: "hsl(0,0%,20%)", //цвет фона фокуса кнопок//(51,51,51)
                //текстовое поле ввода
                FonTextBox: "hsl(0,0%,30%)", //цвет фона полей ввода текста//(77,77,77)
                //Элементы диаграмм
                ChartBox: "hsl(0,0%,65%)", //Прямоугольники//(166,166,166)
                //Иконки
                Icon: "hsl(0,0%,65%)",//цвет иконки SVG(166,166,166)
            };
            break;
        case "bright"://Cветлая
            G.D.C = {//*элементы (кнопки..) сделать контрастнее (темнее)
                //Name: "bright",
                //Элементы
                FonSite: "hsl(0,0%,100%)", //цвет фона сайта //(255,255,255)
                Frame: "hsl(0,0%,85%)", //цвет рамок окна, и разделительных линий //(217,217,217)
                WinFon: "hsl(0,0%,98%)", //цвет фона окна //(250,250,250)
                //Текст
                TWin: "hsl(0,0%,35%)", //цвет текcта, в окнах обычный //(89,89,89)
                TWinLight: "hsl(0,0%,65%)", //цвет текста, в окнах подсвеченный //(166,166,166)
                //Кнопка
                ButtonText: "hsl(0,0%,60%)", //цвет текста кнопки //(153,153,153)
                ButtonTextFocus: "hsl(0,0%,40%)", //цвет текста фокуса кнопок //(102,102,102)
                ButtonFon: "hsl(0,0%,95%)", //цвет фона кнопок //(242,242,242)
                ButtonFonFocus: "hsl(0,0%,90%)", //цвет фона фокуса кнопок //(230,230,230)
                //текстовое поле ввода
                FonTextBox: "hsl(0,0%,92%)", //цвет фона полей ввода текста //(235,235,235)
                //Элементы диаграмм
                ChartBox: "hsl(0,0%,90%)", //Прямоугольники //(230,230,230)
                //Иконки
                Icon: "hsl(0,0%,90%)", //цвет иконки SVG(230,230,230)
            };
            break;
        case "black"://Черная
            G.D.C = {//* график светлее
                //Name: "black",
                //Элементы
                FonSite: "hsl(0,0%,0%)", //цвет фона сайта //(0,0,0)
                Frame: "hsl(0,0%,20%)", //цвет рамок окна, и разделительных линий //(51,51,51)
                WinFon: "hsl(0,0%,10%)", //цвет фона окна //(26,26,26)
                //Текст
                TWin: "hsl(0,0%,50%)", //цвет текста, в окнах обычный //(128,128,128)
                TWinLight: "hsl(0,0%,30%)", //цвет текста, в окнах подсвеченный //(77,77,77)
                //Кнопка
                ButtonText: "hsl(0,0%,40%)", //цвет текста кнопки //(102,102,102)
                ButtonTextFocus: "hsl(0,0%,35%)", //цвет текста фокуса кнопок //(89,89,89)
                ButtonFon: "hsl(0,0%,5%)", //цвет фона кнопок//(13,13,13)
                ButtonFonFocus: "hsl(0,0%,10%)", //цвет фона фокуса кнопок //(26,26,26)
                //текстовое поле ввода
                FonTextBox: "hsl(0,0%,0%)", //цвет фона полей ввода текста//(0,0,0)
                //Элементы диаграмм
                ChartBox: "hsl(0,0%,30%)", //Прямоугольники //(77,77,77)
                //Иконки
                Icon: "hsl(0,0%,30%)", //цвет иконки SVG(77,77,77)
            };
            break;
        default://Серая
            console.log("  ОШИБКА!!! Theme=" + Theme);

            break;
    };
    //Палитра цветов для выбора (графики) rgb
    G.D.C.Palette = [[0, 0, 0], [85, 85, 85], [170, 170, 170], [255, 255, 255], [255, 0, 0], [255, 127, 0], [255, 255, 0], [0, 255, 0], [0, 255, 255], [0, 127, 255], [0, 0, 255], [127, 0, 255], [255, 0, 255]];
    G.D.C.Buy = "rgb(100,50,50)";//Купить(красный)
    G.D.C.Sale = "rgb(50,85,50)";//Продать(зеленый)
    G.D.C.Black = "rgb(0,0,0)";//
    G.S.GUI_Theme = Theme;//В конце функции, поле - есть индикатор загрузеи настройки GUI
}



//Размеры стиля
G.D.S = {
    //Шрифты
    //Название
    Name: "Arial",//("Arial")
    //Отступ текса (красная строка), px
    Tab: 6,
    //Минимальный
    FontSizeMin: 10,
    //Нормальный
    FontSizeNormal: 15,
    //Максимальный
    FontSizeMax: 30,
    //Высота контейнера для текста
    //Минимальный
    ContFontSizeMin: 13,//10+3
    //Нормальный
    ContFontSizeNormal: 18,//15+3
    //Максимальный
    ContFontSizeMax: 36,//30+6
    //Рамка
    //толщина, px
    FrameSize: 1,
    //Радиус скругления, px
    Radius: 2,
    //Высота Кнопки
    ButtonH: 30,
    //Высота меню
    Hmenu: 40,
    //Зазоры
    GapIn: 6, //отступы от краев внутри окна, и между элементами
    GapWin: 6, //Минимальные зазоры между окнами, px
    GapPage: 5, //Отступы от краев страницы, px
    //Скрол
    //Толщина линии скольжения.
    ScrollThickness: 16,
    //Длина ползунка
    ScrollLengthSlider: 32,
    //Ширина боковых окон: настройки графика, создать сделку вручную, список НС
    SideWinW: 370,
    //Ширина кнопки: размер 1
    ButtonWidthNormal: 160,
};


G.D.S.ScrollThickness









//Архив.
