
//Прорисовка дизайна приложения
function DrawTradePage() {
    //console.log("DrawTradePage ");

    //Получение размера окна приложения
    let View = GetViewSize();

    //------------------------------------------------------------------------------------------------------------------
    //Размеры пустых контейнеров
    //Меню
    let menu = {};
    menu.t = G.D.S.GapPage;
    menu.l = G.D.S.GapPage;
    menu.h = 40;
    menu.w = View.w - 2 * G.D.S.GapPage;

    //Окно графика
    let chart = {};
    chart.t = menu.t + menu.h + G.D.S.GapWin;
    chart.l = G.D.S.GapPage;
    chart.h = 0.6 * (View.h - chart.t);
    chart.w = View.w - 2 * G.D.S.GapPage;

    //Окно сделки
    let order = {};
    order.t = chart.t + chart.h + G.D.S.GapWin;
    order.l = G.D.S.GapPage;
    order.h = View.h - order.t - G.D.S.GapPage;//оставшаяся высота

    //Окно создать
    let create = {}
    create.t = order.t;
    create.h = order.h;
    create.w = G.D.S.SideWinW;
    create.l = View.w - create.w - G.D.S.GapPage;

    order.w = View.w - create.w - G.D.S.GapWin - 2 * G.D.S.GapPage//по окну создать
    //console.log("menu.t=" + menu.t);
    //console.log("info.t=" + info.t);
    //console.log("chart.t=" + chart.t);


    //------------------------------------------------------------------------------------------------------------------
    //Создаем контейнер "Background". Все последующие элементы будут помещены в этот контейнер

    let DivBackground = Background(View.w, View.h);

    //Размещение контейнеров
    let DivMenu = WindowContainer([menu.t, "", menu.l, ""], [menu.w, menu.h], DivBackground)

    G.C.DivContainer = Container([chart.t, "", chart.l, ""], [chart.w, chart.h], DivBackground);
    //console.log("G.C.DivContainer инициализирован");

    let DivSet = WindowContainer([order.t, "", order.l, ""], [order.w, order.h], DivBackground);
    let DivCreate = WindowContainer([create.t, "", create.l, ""], [create.w, create.h], DivBackground);

    //G.B.DivSet = DivSet;//через глобальную переменную, чтобы вызывать функцию без аргументов

    //Наполнение контейнеров
    MainMenu(DivMenu);
    TradOrderWin(DivCreate);
    TradeSetWin(DivSet);


    ChartWin("Standard");

    //Запрос на получение данных для графика  
    DrawChart();
}


//Функция создает и размещает окно "Настройки".
function TradeSetWin(inDiv) {
    //console.log("NNSetWin ");
    //let inDiv = G.B.DivSet;

    //0.Очишаем
    inDiv.innerHTML = "";


    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);

    //Контейнер под шапкой //со скролом
    let ht = 50;
    let DivCont = Container([ht, "", 0, ""], ["100%", SizeWin.h - ht], inDiv);

    //Шапка - меню
    let TradeMenuItem = [
        { N: G.L[G.S.L].t1, F: Trade_Bot, P: "Bot", },//Робот
        { N: G.L[G.S.L].t2, F: Trade_Balance, P: "Balance", },//Баланс
        { N: G.L[G.S.L].t3, F: Trade_Order, P: "Order", },//Сделки
    ];


    //Шапка
    let l = G.D.S.GapIn;

    for (let i = 0; i < TradeMenuItem.length; i++) {
        TradeMenuItem[i].Div = TextSimpleClick([G.D.S.GapIn, "", l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", TradeMenuItem[i].N, inDiv);
        TradeMenuItem[i].Div.onclick = function () {
            for (let i = 0; i < TradeMenuItem.length; i++) {
                TradeMenuItem[i].Div.style.color = G.D.C.TWin;
            }
            TradeMenuItem[i].Div.style.color = G.D.C.TWinLight;
            G.Page.Trade.SelectedTabL = TradeMenuItem[i].P;
            TradeMenuItem[i].F(DivCont);
        }
        l += GetDivPS_Parent(TradeMenuItem[i].Div).w + 2 * G.D.S.GapIn;
    }

    for (let i = 0; i < TradeMenuItem.length; i++) {
        if (G.Page.Trade.SelectedTabL == TradeMenuItem[i].P) {
            TradeMenuItem[i].Div.onclick();
        }
    }


}


//Робот (настройки)
function Trade_Bot(DivCont) {

    G.F.Trade_Bot = function () {
        Trade_Bot(DivCont);
    }
    DivCont.innerHTML = "";
    let Bot = G.Bot;
    Bot.CurrentPrice = GetEndY("Price" + Bot.Symbol);//Берем из графика текущую цену
    //console.log("Bot.CurrentPrice " + Bot.CurrentPrice);

    let SizeWin = GetDivSizeContent(DivCont);

    let t = 0;
    let l0 = G.D.S.GapIn;
    let l1 = l0 + G.D.S.Tab;
    let h = G.D.S.ContFontSizeNormal;
    let w1 = 160;//Ширина полей заполнения левый столбец
    let w05 = Math.round(w1 / 2);//Ширина половины поля
    let l2 = w05 + 2 * G.D.S.GapIn;

    //Макет под шапкой
    //Некоторые общие размеры
    LW = 420;//Ширина левый столбец
    let RL = LW + G.D.S.GapIn;
    let RW = SizeWin.w - RL;
    if (RW > 500) {//Максимальная  Ширина правый столбец
        RW = 500;
    }

    //Контейнер со скролом Левый
    let DivContL = Container([0, "", 0, ""], [LW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "Trade_BotL");//добавляем скролл
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", RL, ""], [RW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "Trade_BotR");//добавляем скролл


    let BotSave = function () {
        Message = {
            "Type": "BotSave",
            "Bot": Bot,
        };
        MessageSend(Message);
    }

    //Пара
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivContL);
    if (Bot.StatusSession) {//Сессия открыта
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Symbol, DivContL);
    }
    else {//Сессия закрыта
        let DivListSelect = ListSelect([t, "", "", l0], [w1, h], Bot.Symbol, G.S.TopSymbol, DivContL);
        //Изменение пары
        DivListSelect.fnSelectContent = function (SelectContent) {
            //console.log("SelectContent= " + SelectContent);
            Bot.Symbol = SelectContent;
            Bot.B_Unit = G.SI[SelectContent].BaseAsset;
            Bot.Q_Unit = G.SI[SelectContent].QuoteAsset;
            BotSave();
            Trade_Bot(DivCont);
            GetPrice(Bot.Symbol, false);
        }
    }
    t += h;


    //Упреждение
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb010, DivContL);
    if (G.BotStatusWork) {//Статус робота -  работает
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Additive, DivContL);
    } else {//Статус робота - не работает
        let Div_Additive = TextFrameInput([t, "", "", l0], [w1, h], 10, Bot.Additive, DivContL);
        Div_Additive.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_Additive.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.Additive = Number(Div_Additive.value);
            BotSave();
        }
    }
    t += 2 * h;

    //Выделить объем.
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb020, DivContL);
    t += h;
    G.L[G.S.L].tb31
    //Выделить объем. Шапка таблицы.
    //Доступно
    TextSimple([t, "", "", l2], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].VFree, DivContL);
    //Объем
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Volume, DivContL);
    t += h;

    //Выделить объем. Валюта базовая.
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.B_Unit, DivContL);
    //Доступный объем. Валюта базовая.
    let B_Max = "0";
    if ("AI" in G && G.AI.BalancesFree && Bot.B_Unit in G.AI.BalancesFree) {
        B_Max = G.AI.BalancesFree[Bot.B_Unit];//Макс доступный объем

    }
    TextSimpleA([t, "", "", l2], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", B_Max, DivContL);//Макс доступный объем

    //Выделенный объем. Валюта базовая.
    if (Bot.StatusSession) {//Сессия открыта
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.B_UserSet, DivContL);
    }
    else {//Сессия закрыта
        let Div_BalanceBaseStartUserSet = TextFrameInput([t, "", "", l0], [w05, h], 10, Bot.B_UserSet, DivContL);
        Div_BalanceBaseStartUserSet.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_BalanceBaseStartUserSet.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.B_UserSet = Number(Div_BalanceBaseStartUserSet.value);
            BotSave();
        }
    }
    t += h;

    //Выделить объем. Валюта котируемая.
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Q_Unit, DivContL);
    //Доступный объем. Валюта котируемая.
    let Q_Max = "0"
    if ("AI" in G && G.AI.BalancesFree && Bot.Q_Unit in G.AI.BalancesFree) {
        Q_Max = G.AI.BalancesFree[Bot.Q_Unit];//Макс доступный объем
    }
    TextSimpleA([t, "", "", l2], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Q_Max, DivContL);//Макс доступный объем

    //Выделенный объем. Валюта котируемая.
    if (Bot.StatusSession) {//Сессия открыта
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Q_UserSet, DivContL);
    }
    else {//Сессия закрыта
        let Div_BalanceQuoteStartUserSet = TextFrameInput([t, "", "", l0], [w05, h], 10, Bot.Q_UserSet, DivContL);
        Div_BalanceQuoteStartUserSet.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_BalanceQuoteStartUserSet.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.Q_UserSet = Number(Div_BalanceQuoteStartUserSet.value);
            BotSave();
        }
    }
    t += 2 * h;

    //Начальная стоимость для выделенного объема:
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb030, DivContL);
    t += h;

    //Стоимость для выделенного объема. Шапка таблицы.
    //По текущей цене
    TextSimple([t, "", "", l2], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb031, DivContL);
    //Стоимость
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb032, DivContL);
    t += h;

    //Стоимость для выделенного объема. Валюта
    let Cont_B = Bot.B_Unit + " [" + Bot.Q_Unit + "]";
    //let Cont_B = "Для " + Bot.B_Unit + " [" + Bot.Q_Unit + "]";

    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Cont_B, DivContL);

    //Текущая (по текущей цене) стоимость выделенного объема
    let B_CostCurrent = Bot.B_UserSet * Bot.CurrentPrice;//Выделенный объем*текущая цена;
    if (!B_CostCurrent) {
        B_CostCurrent = 0;
    }
    B_CostCurrent = NumToFormatN(B_CostCurrent, 10);

    TextSimpleA([t, "", "", l2], [w05, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", B_CostCurrent, DivContL);
    //Стоимость выделенного объема
    if (Bot.StatusSession) {//Сессия открыта
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.B_CostSet, DivContL);
    }
    else {//Сессия закрыта
        let Div_B_CostSet = TextFrameInput([t, "", "", l0], [w05, h], 10, Bot.B_CostSet, DivContL);
        Div_B_CostSet.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_B_CostSet.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.B_CostSet = Number(Div_B_CostSet.value);
            BotSave();
        }
    }
    t += h;

    //Валюта
    let Cont_Q = Bot.Q_Unit + " [" + Bot.B_Unit + "]";
    //let Cont_Q = "Для " + Bot.Q_Unit + " [" + Bot.B_Unit + "]";

    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Cont_Q, DivContL);

    //Текущая (по текущей цене) стоимость выделенного объема
    let Q_CostCurrent = Bot.Q_UserSet / Bot.CurrentPrice;//Выделенный объем/текущая цена;
    if (!B_CostCurrent) {
        Q_CostCurrent = 0;
    }
    Q_CostCurrent = NumToFormatN(Q_CostCurrent, 10);
    TextSimpleA([t, "", "", l2], [w05, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Q_CostCurrent, DivContL);


    //Стоимость выделенного объема
    if (Bot.StatusSession) {//Сессия открыта
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Q_CostSet, DivContL);
    }
    else {//Сессия закрыта
        let Div_Q_CostSet = TextFrameInput([t, "", "", l0], [w05, h], 10, Bot.Q_CostSet, DivContL);
        Div_Q_CostSet.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_Q_CostSet.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.Q_CostSet = Number(Div_Q_CostSet.value);
            BotSave();
        }
    }
    t += 2 * h;



    //Скорость обновления сигнала [c]
    TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb040, DivContL);
    if (G.BotStatusWork) {//Статус робота -  работает
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.TimeUpdate, DivContL);
    } else {//Статус робота - не работает
        let Div_TimeUpdate = TextFrameInput([t, "", "", l0], [w1, h], 10, Bot.TimeUpdate, DivContL);
        Div_TimeUpdate.oninput = function () {   //событие изменение содержания поля ввода текста
            AutoVerificationNumber(this);//Проверка ввода данных
        };
        Div_TimeUpdate.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
            Bot.TimeUpdate = Number(Div_TimeUpdate.value);
            BotSave();
        }
    }
    t += 2 * h;


    let DivContainerNNList = Container([t, "", 0, ""], ["100%", ""], DivContL);//контейнер для перерисовки
    DivContainerNNList.innerHTML = "";
    let tR = 0;
    //"НС участвующие в торговле и их влияние:"
    TextSimple([tR, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb050, DivContainerNNList);
    tR += h;
    tR += G.D.S.GapIn;
    let hB2 = h;//Высота кнопки "Удалить"
    let wB2 = Math.round(w1 / 2);//Ширина кнопки "Удалить" и поля ввода
    for (let NameNN in Bot.NNWeight) {
        //Название НС
        TextSimple([tR, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", NameNN, DivContainerNNList);
        if (G.BotStatusWork) {//Статус робота -  работает
            //Значенеия коэфициентов
            TextSimple([tR, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.NNWeight[NameNN], DivContainerNNList);
        } else {//Статус робота - не работает
            //Значенеия коэфициентов
            let DivTextFrameInput = TextFrameInput([tR, "", "", l0 + wB2], [wB2, hB2], 5, Bot.NNWeight[NameNN], DivContainerNNList);
            DivTextFrameInput.oninput = function () {   //событие изменение содержания поля ввода текста
                AutoVerificationNumber(this);//Проверка ввода данных
            };
            DivTextFrameInput.onchange = function () {    //событие окончание изменение содержания поля ввода текста (потеря фокуса)
                Bot.NNWeight[NameNN] = Number(DivTextFrameInput.value);
                BotSave();
            }
            //Удалить
            let DivButton = ButtonText([tR, "", "", l0], [wB2, hB2], G.L[G.S.L].Delete, DivContainerNNList);

            DivButton.onclick = function () {
                delete Bot.NNWeight[NameNN];//удаляем вес
                BotSave();
            }
        }

        tR += h;
    }
    DivContainerNNList.style.height = tR + "px";
    t += tR;

    //Вспомогательные вычисления для соглосования коэфициентов
    //"Сумма коэфицинтов (рекомендуеться 1.0)"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb051, DivContL);
    let kSum = 0;
    for (let NameNN in Bot.NNWeight) {
        kSum += Bot.NNWeight[NameNN];
    }
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", kSum.toFixed(4), DivContL);
    t += h;
    //"Средний коэфицинт"
    TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb052, DivContL);
    let kAvg = 1.0 / Object.keys(Bot.NNWeight).length;
    TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", kAvg.toFixed(4), DivContL);
    t += 2 * h;




    //Торговая сессия
    if (Bot.StatusSession) {//Сессия открыта
        if (!G.BotStatusWork) {//Статус робота - не работает
            //Торговая сессия
            TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb060, DivContL);
            //Сброс 
            let Div_Session = ButtonText([t, "", "", l0], [w1, h], G.L[G.S.L].Reset, DivContL);
            Div_Session.onclick = function () {
                Message = {
                    "Type": "BotReSession",
                };
                MessageSend(Message);
            }
            t += 2 * h;
        }

        //Статистика торговой сессии:
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb070, DivContL);
        t += 2 * h;
        //Количество сделок
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb071, DivContL);
        let cont = 0;
        if (Bot.Order != null) {
            cont = Bot.Order.length;
        }
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", cont, DivContL);
        t += h;


        //console.log("Bot.B_Start " + Bot.B_Start);
        //console.log("Bot.Q_Start " + Bot.Q_Start);
        //console.log("Bot.CurrentPrice " + Bot.CurrentPrice);


        //Вычисляем прибыль из информации по кашельку робота
        //До начала торгов. Сумарный баланс по текущей цене.(без комиссий)
        let B_SumStart_B = (Bot.B_Start) + (Bot.Q_Start) / Bot.CurrentPrice;
        let Q_SumStart_B = (Bot.Q_Start) + (Bot.B_Start) * Bot.CurrentPrice;
        //console.log("B_SumStart_B " + B_SumStart_B);

        //На текущий момент. Сумарный баланс по текущей цене.(без комиссий)
        let B_SumNow_B = (Bot.B_Current + Bot.B_InOrder) + (Bot.Q_Current + Bot.Q_InOrder) / Bot.CurrentPrice;
        let Q_SumNow_B = (Bot.Q_Current + Bot.Q_InOrder) + (Bot.B_Current + Bot.B_InOrder) * Bot.CurrentPrice;
        //console.log("B_SumNow_B " + B_SumNow_B);

        // Прибыль. По текущей цене
        let B_Profit_B = B_SumNow_B - B_SumStart_B;
        let Q_Profit_B = Q_SumNow_B - Q_SumStart_B;
        //console.log("B_Profit_B " + B_Profit_B);
        if (!B_Profit_B) {
            B_Profit_B = 0;
        }
        if (!Q_Profit_B) {
            Q_Profit_B = 0;
        }
        B_Profit_B = B_Profit_B.toFixed(6);
        Q_Profit_B = Q_Profit_B.toFixed(6);


        //Доход
        TextSimple([t, "", l0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Income, DivContL);
        t += h;
        //Валюта - Доход
        TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.B_Unit, DivContL);
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", B_Profit_B, DivContL);
        t += h;
        //Валюта - Доход
        TextSimple([t, "", l1, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Q_Unit, DivContL);
        TextSimple([t, "", "", l0], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Q_Profit_B, DivContL);

    }
    DivContL.UpdateScroll();
    t = 0;

    //Справка
    TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Help, DivContR);
    t += 2 * h;
    //Справка
    let DivHelp1 = TextSimple([t, "", 0, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].htb010, DivContR);
    ModDivPadding(["", "", "", G.D.S.GapIn], DivHelp1);
    DivHelp1.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический


    //Обновление скрола. Вызывается когда размер DivContent изменился в следствии изменения контента. 
    DivContL.UpdateScroll();
    DivContR.UpdateScroll();

    GetPrice(Bot.Symbol, false);

}


//Баланс
function Trade_Balance(DivCont) {

    G.F.Trade_Balance = function () {
        Trade_Balance(DivCont);
    }

    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    DivCont.innerHTML = "";

    //Размеры
    let ContLW = 350;
    let ContRW = 550;
    let l2RW = 350;//

    //let ContH= SizeWin.h;
    let t = 0;
    let l0 = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;

    //Контейнер со скроолом Левый
    let DivContL = Container([0, "", 0, ""], [ContLW, "100%"], DivCont);
    DivContL = ModDivScrollV(DivContL, "Trade_BalanceL");//добовляем скрол
    //Контейнер со скроолом Правый
    let DivContR = Container([0, "", ContLW, ""], [ContRW, "100%"], DivCont);
    DivContR = ModDivScrollV(DivContR, "Trade_BalanceR");//добовляем скрол

    DivContL.UpdateScroll();
    DivContR.UpdateScroll();


    if (G.AI == undefined) {
        console.log(" G.AI Нет данных");
        GetUpdateAI();
        //"Загрузка"
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Loading, DivContL);
        return;
    }
    if (ObjectIsEmpty(G.AI)) {
        //"Нет данных"
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].NoData, DivContL);
        return;
    }


    //Твблица
    let wt1 = 100;
    let wt23 = (ContLW - G.D.S.GapIn - wt1) / 2;
    //"Активы"
    TextSimple([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb010, DivContL);
    //"Доступно"
    TextSimpleA([t, "", wt1, ""], [wt23, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].VFree, DivContL);
    //"В сделке"
    TextSimpleA([t, "", wt1 + wt23, ""], [wt23, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].VLocked, DivContL);
    t += h;
    DemarcationLine([t, "", l0, ""], ContLW - 2 * G.D.S.GapIn, "horizontal", DivContL);

    for (let Asset in G.AI.BalancesFree) {//столбцы
        TextSimple([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Asset, DivContL);//Валюта
        TextSimpleA([t, "", wt1, ""], [wt23, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.AI.BalancesFree[Asset], DivContL);//Доступный объем
        let BalancesLocked = (G.AI.BalancesLocked[Asset] == undefined) ? 0 : G.AI.BalancesLocked[Asset];
        TextSimpleA([t, "", wt1 + wt23, ""], [wt23, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", BalancesLocked, DivContL);
        t += h;
        DemarcationLine([t, "", l0, ""], ContLW - 2 * G.D.S.GapIn, "horizontal", DivContL);
    }
    DivContL.UpdateScroll();


    //Контейнер Правый
    t = 0;
    //"Информация по аккаунту"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb101, DivContR);
    t += h;
    //"Комиссия для мэйкеров (отложенная сделка)"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb102, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.AI.MakerCommission * 100 + "%", DivContR);
    t += h;
    //"Комиссия для тэйкеров (мгновенная сделка)"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb103, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.AI.TakerCommission * 100 + "%", DivContR);
    t += h;
    //"Комиссия для покупателя"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb104, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.AI.BuyerCommission * 100 + "%", DivContR);
    t += h;
    //"Комиссия для продавца"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb105, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.AI.SellerCommission * 100 + "%", DivContR);
    t += h;
    //"Разрешена торговля"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb106, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", (G.AI.CanTrade) ? G.L[G.S.L].Yes : G.L[G.S.L].No, DivContR);
    t += h;
    //"Разрешен вывод средств"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb107, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", (G.AI.CanWithdraw) ? G.L[G.S.L].Yes : G.L[G.S.L].No, DivContR);
    t += h;
    //"Разрешен ввод средств"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb108, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", (G.AI.CanDeposit) ? G.L[G.S.L].Yes : G.L[G.S.L].No, DivContR);
    t += h;
    //"Тип аккаунта"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb109, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.AI.AccountType, DivContR);
    t += h;
    //"Разрешенна торговля типа SPOT"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb110, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", (G.AI.PermissionsSPOT) ? G.L[G.S.L].Yes : G.L[G.S.L].No, DivContR);
    t += h;
    //"Дата последнего изменения информации"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb111, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", UnixToDate(G.AI.UpdateTime).date + " " + UnixToDate(G.AI.UpdateTime).time, DivContR);
    t += h;
    //
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].tb112, DivContR);
    TextSimple([t, "", l2RW, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", UnixToDate(G.AI.DownloadTime).date + " " + UnixToDate(G.AI.DownloadTime).time, DivContR);
    t += h;



    //"Обновить"
    let DivB = ButtonText([t, "", l2RW, ""], [ContRW - l2RW, 2 * h], G.L[G.S.L].Refresh, DivContR);
    DivB.onclick = function () {
        GetUpdateAI();

    }

    DivContR.UpdateScroll();
}


//Сделки(история)
function Trade_Order(DivCont) {

    G.F.Trade_Order = function () {
        Trade_Order(DivCont);
    }
    DivCont.innerHTML = "";

    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);

    //Размеры
    //let ContH= SizeWin.h;
    let t = 0;
    let l0 = G.D.S.GapIn;
    let h = G.D.S.ContFontSizeNormal;

    let Symbol = G.S.OrderSymbol;

    let GetUpdateOrderHistorys = function (SelectSymbol) {
        let Message = {
            "Type": "UpdateOrderHistory",
            "Symbol": SelectSymbol,
        };
        MessageSend(Message);
    }

    //Пара
    let l2 = 100;
    let w2 = 160;
    //"Пара"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivCont);
    let DivListSelect1 = ListSelect([t, "", l2, ""], [w2, h], Symbol, G.S.TopSymbol, DivCont);
    DivListSelect1.fnSelectContent = function (SelectSymbol) {
        Symbol = SelectSymbol;
        G.S.OrderSymbol = SelectSymbol;
        GetPrice(Symbol, false);
        GUISettingsSave();
        GetUpdateOrderHistorys(SelectSymbol);
    }
    let l3 = l2 + w2 + G.D.S.GapIn;
    let w3 = 100;
    //"Обновить"
    let Div_Update = ButtonText([t, "", l3, ""], [w3, h], G.L[G.S.L].Refresh, DivCont);
    Div_Update.onclick = function () {
        GetUpdateOrderHistorys(G.S.OrderSymbol);
    }
    t += 2 * h;


    if (!(Symbol in G.OH)) {//Данных нет.
        //"Загрузка"
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Loading, DivCont);
        G.OH[Symbol] = [];
        GetUpdateOrderHistorys(Symbol);
        return;
    }
    if (G.OH[Symbol].length == 0) {//Нет сделок по выбранной паре
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].NoData, DivCont);
    } else {//Есть сделки по выбранной паре
        //Шапка таблицы

        let Cap = [];
        let lc = G.D.S.GapIn;
        //"Дата создания | ID"
        Cap[0] = { l: lc, w: 145, n: G.L[G.S.L].to010 + " | ID" };
        lc += Cap[0].w;
        //"Действие"
        Cap[1] = { l: lc, w: 70, n: G.L[G.S.L].Action };
        lc += Cap[1].w;
        //"Цена нач. | кон."
        Cap[2] = { l: lc, w: 130, n: G.L[G.S.L].to011 };
        lc += Cap[2].w;
        //"Объем"
        Cap[3] = { l: lc, w: 150, n: G.L[G.S.L].Volume };
        lc += Cap[3].w;
        //"Выполнено"
        Cap[4] = { l: lc, w: 150, n: G.L[G.S.L].to012 };
        lc += Cap[4].w;
        //"Комиссия"
        Cap[5] = { l: lc, w: 150, n: G.L[G.S.L].to013 };
        lc += Cap[5].w;
        //"Сост. | Дата обн. "
        Cap[6] = { l: lc, w: 160, n: G.L[G.S.L].to014 };
        lc += Cap[6].w;




        //console.log("lc= " + lc);

        //Шапка
        for (let i = 0; i < Cap.length; i++) {
            let Align = "right";
            if (i == 0) {
                Align = "left";
            }
            TextSimpleA([t, "", l0 + Cap[i].l, ""], [Cap[i].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Align, Cap[i].n, DivCont);
        }
        t += h;

        //Контейнер со скролом 
        let wContT = lc + 2 * G.D.S.GapIn + G.D.S.ScrollThickness;
        let DivContT = Container([t, "", l0, ""], [wContT, SizeWin.h - t], DivCont);//Контейнер списка сделок
        DivContT = ModDivScrollV(DivContT, "Trade_Order");//добавляем скролл
        let SizeContT = GetDivSizeContent(DivContT);
        //console.log("wContT= " + wContT);
        //console.log("SizeContT.w= " + SizeContT.w);

        t = 0;


        //Таблицы
        let Content;
        //for (let i = G.OH[Symbol].length - 1; i >= 0; i--) {//в массиве сначала идут новые ордера, по этому цикл в обратном направлении
        for (let i = 0; i < G.OH[Symbol].length; i++) {//в массиве сначала идут новые ордера, по этому цикл в обратном направлении


            let OIS = G.OH[Symbol][i];
            let ColorFon = G.D.C.Buy;//Купить(красный) "BUY"
            if (OIS.Side == "SELL") {
                ColorFon = G.D.C.Sale;//Продать(зеленый)
            }
            let DivContE = FrameContainer([t, "", 0, ""], [SizeContT.w - G.D.S.GapIn, 2 * h], ColorFon, DivContT);//Контейнер одной сделки
            t += 2 * h + 1;

            //1строка
            Content = UnixToDate(OIS.Time).date + " " + UnixToDate(OIS.Time).time;//Дата создания
            TextSimpleA([0, "", Cap[0].l, ""], [Cap[0].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", Content, DivContE);
            Content = (OIS.Side == "BUY") ? G.L[G.S.L].Buy : G.L[G.S.L].Sell;//Тип "Покупка" : "Продажа"
            TextSimpleA([0, "", Cap[1].l, ""], [Cap[1].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = OIS.Price + " " + G.SI[Symbol].QuoteAsset;//Цена начальная
            TextSimpleA([0, "", Cap[2].l, ""], [Cap[2].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = ((OIS.Side == "BUY") ? "+" : "-") + OIS.OrigQuantity.toFixed(6) + " " + G.SI[Symbol].BaseAsset;//Объем базовая валюта
            TextSimpleA([0, "", Cap[3].l, ""], [Cap[3].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = ((OIS.Side == "BUY") ? "+" : "-") + OIS.ExecutedQuantity.toFixed(6) + " " + G.SI[Symbol].BaseAsset;//Выполнено  базовая валюта
            TextSimpleA([0, "", Cap[4].l, ""], [Cap[4].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = "-" + OIS.Commission.toFixed(8) + " " + OIS.CommissionAsset;//Комиссия
            TextSimpleA([0, "", Cap[5].l, ""], [Cap[5].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);

            //Состояние ордера на текущий момент
            //*NEW Заказ был принят обработчиком.
            //*PARTIALLY_FILLED 	Часть заказа выполнена.
            //*FILLED Заказ выполнен.
            //*CANCELED Заказ был отменен пользователем.
            //*PENDING_CANCEL Ожидает отмены. В настоящее время не используется.
            //*REJECTED Заказ не принят обработчиком и не обработан.
            //*EXPIRED 	Ордер был отменен в соответствии с правилами типа ордера (например, LIMIT FOK ордера без исполнения, LIMIT IOC или MARKET ордера с частичным исполнением)
            let work = false;
            switch (OIS.Status) {
                case "NEW":
                    Content = G.L[G.S.L].to020;//"Новый"
                    work = true;
                    break;
                case "PARTIALLY_FILLED":
                    Content = G.L[G.S.L].to021;//"Частично выполнен"
                    work = true;
                    break;
                case "FILLED":
                    Content = G.L[G.S.L].to022;//"Выполнен"
                    break;
                case "CANCELED":
                    Content = G.L[G.S.L].to023;//"Отменен пользоват."
                    break;
                case "PENDING_CANCEL":
                    Content = G.L[G.S.L].to024;//"Ожидает отмены"
                    break;
                case "REJECTED":
                    Content = G.L[G.S.L].to025;//"Не принят"
                    break;
                case "EXPIRED":
                    Content = G.L[G.S.L].to026;//"Отменен сервером"
                    break;
            }

            if (work) {//Ордер можно отменить
                let lB = Cap[6].l + Cap[6].w / 2;
                let wB = Cap[6].w / 2;
                TextSimpleA([0, "", Cap[6].l, ""], [wB - G.D.S.GapIn, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
                //"Отменить"
                let Div_Cancel = ButtonText([0, "", lB, ""], [Cap[6].w / 2, h], G.L[G.S.L].Cancel, DivContE);
                Div_Cancel.onclick = function () {
                    let Message = {
                        "Type": "OrderCancel",
                        "OrderID": OIS.OrderID,
                        "Symbol": Symbol,

                    };
                    MessageSend(Message);
                }

            } else {
                TextSimpleA([0, "", Cap[6].l, ""], [Cap[6].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            }


            //2строка

            Content = OIS.OrderID;//ID
            TextSimpleA([h, "", Cap[0].l, ""], [Cap[0].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", Content, DivContE);
            Content = OIS.PriceEnd + " " + G.SI[Symbol].QuoteAsset;//Цена конечная
            TextSimpleA([h, "", Cap[2].l, ""], [Cap[2].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = ((OIS.Side == "BUY") ? "-" : "+") + (OIS.OrigQuantity * OIS.Price).toFixed(6) + " " + G.SI[Symbol].QuoteAsset;//Объем котируемая валюта
            TextSimpleA([h, "", Cap[3].l, ""], [Cap[3].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = ((OIS.Side == "BUY") ? "-" : "+") + OIS.CummulativeQuoteQuantity + " " + G.SI[Symbol].QuoteAsset;//Выполнено  котируемая валюта
            TextSimpleA([h, "", Cap[4].l, ""], [Cap[4].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
            Content = UnixToDate(OIS.UpdateTime).date + " " + UnixToDate(OIS.UpdateTime).time;//Дата обновления
            TextSimpleA([h, "", Cap[6].l, ""], [Cap[6].w, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Content, DivContE);
        }
        DivContT.UpdateScroll();

    }
    GetPrice(Symbol, false);

}

//Функция создает и размещает правое окно - контейнер для  "Автотогровля" и "Ручная торговля"
function TradOrderWin(inDiv) {
    //0. Очишаем
    inDiv.innerHTML = "";


    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);

    //Контейнер под шапкой //со скролом
    let ht = 50;
    let DivCont = Container([ht, "", 0, ""], ["100%", SizeWin.h - ht], inDiv);

    //Шапка - меню
    let TradeMenuItem = [
        { N: G.L[G.S.L].t4, F: Trade_AutoTrading, P: "AutoTrading", },
        { N: G.L[G.S.L].t5, F: Trade_ManualTrading, P: "ManualTrading", },
    ];

    //Шапка
    let l = G.D.S.GapIn;

    for (let i = 0; i < TradeMenuItem.length; i++) {
        TradeMenuItem[i].Div = TextSimpleClick([G.D.S.GapIn, "", l, ""], ["", ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", TradeMenuItem[i].N, inDiv);
        TradeMenuItem[i].Div.onclick = function () {
            for (let i = 0; i < TradeMenuItem.length; i++) {
                TradeMenuItem[i].Div.style.color = G.D.C.TWin;
            }
            TradeMenuItem[i].Div.style.color = G.D.C.TWinLight;
            G.Page.Trade.SelectedTabR = TradeMenuItem[i].P;
            DivCont.innerHTML = "";
            TradeMenuItem[i].F(DivCont);
        }
        l += GetDivPS_Parent(TradeMenuItem[i].Div).w + 2 * G.D.S.GapIn;
    }

    for (let i = 0; i < TradeMenuItem.length; i++) {
        if (G.Page.Trade.SelectedTabR == TradeMenuItem[i].P) {
            TradeMenuItem[i].Div.onclick();
        }
    }




}

//Автотогровля (правое окно)
function Trade_AutoTrading(inDiv) {
    //------------------------------------------------------------------------------------------------------------------
    //Название окна
    //Две кнопки: Купить и Продать
    //Полоса ввода "Цена"
    //   "Цена"
    //   поле ввода цены
    //   единицы
    //   кнопка "текущая"
    //Скролл устанавливающий цену
    //Полоса ввода "Объем"
    //   "Объем"
    //   поле ввода объема
    //   единицы
    //   кнопка "весь"
    //Скролл устанавливающий цену
    //Инфо
    //console.log("Trade_AutoTrading(inDiv)");

    G.F.Trade_AutoTrading = function () {
        Trade_AutoTrading(inDiv);
    }
    inDiv.innerHTML = "";
    let Bot = G.Bot;
    //------------------------------------------------------------------------------------------------------------------
    //Размеры окна
    let SizeWin = GetDivSizeContent(inDiv);
    //Кнопка "Начать"
    let hB = G.D.S.ButtonH;//Высота кнопки
    let tB = SizeWin.h - hB - G.D.S.GapIn;//строка 3
    let wB = SizeWin.w - 2 * G.D.S.GapIn;


    DivContainer = Container([0, "", 0, ""], ["100%", SizeWin.h - hB - 2 * G.D.S.GapIn], inDiv);
    DivInfo = ModDivScrollV(DivContainer, "Trade_AutoTrading");
    DivInfo.UpdateScroll();

    let SizeInfo = GetDivSizeContent(DivInfo);

    //Кнопка "Начать"
    let ContentB = G.L[G.S.L].Start;
    if (Bot.StatusSession) {//Сессия открыта
        //Продолжить
        ContentB = G.L[G.S.L].Resume;
    }
    if (G.BotStatusWork) {//Статус робота - работает
        //Остановить
        ContentB = G.L[G.S.L].Stop;
    }

    let DivB = ButtonText([tB, "", G.D.S.GapIn, ""], [wB, hB], ContentB, inDiv);
    DivB.onclick = function () {
        if (G.BotStatusWork) {//Статус робота - работает
            let Message = {
                "Type": "CancelProcess",
                "NameProcess": "Bot",
            };
            MessageSend(Message);
        } else {//Статус робота - не работает
            Message = {
                "Type": "BotStart",
            };
            MessageSend(Message);
        }
    }


    if (!G.BotStatusWork) {//Статус робота - не работает
        //Чистое окно
        // return;
    }



    //Функция извлекает только те поля - которые нужны для этого окна


    //Прорисовка
    //Разметка для элементов
    let l0 = G.D.S.GapIn;//первый столбец
    let t = 0;//первый столбец
    let h = G.D.S.ContFontSizeNormal;


    //Состояние автоторговли
    switch (true) {
        case !G.BotStatusWork && Bot.StatusSession:
            //Нет соединения работа. Торговяа сесия открыта. "Автоторговля приостановлена"
            TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta011, DivInfo);
            break;
        case !G.BotStatusWork && !Bot.StatusSession:
            //Нет соединения работа. Торговяа сесия неоткрыта."Автоторговля отключена"
            TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta012, DivInfo);
            break;
        case Bot.StatusCreateOrder && !G.BotStatusWaitConnect:
            //Разрешено создавать сделки. Есть соединения работа. Нормальный режим."Автоторговля включена"
            TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta013, DivInfo);
            break;
        case !Bot.StatusCreateOrder && !G.BotStatusWaitConnect:
            //Не Разрешено создавать сделки. Есть соединения работа. "Режим автоторговли: Тестовый"
            TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta014, DivInfo);
            break;
        case G.BotStatusWaitConnect:
            //Нет соединения работа. "Соединение с сервером…"
            TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta015, DivInfo);
            break;
    }


    if (G.BotStatusWork) {
        let timerId;
        let Duration = DurationMsToDate(Date.now() - Bot.TimeStartWork + Bot.TimeDurationSession);
        let DivDuration = TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Duration, DivInfo);
        if (timerId) {
            clearInterval(timerId);
        }
        timerId = setInterval(function () {
            DivDuration.innerHTML = DurationMsToDate(Date.now() - Bot.TimeStartWork + Bot.TimeDurationSession);
        }, 1000);
    } else {
        let Duration = DurationMsToDate(Bot.TimeDurationSession);
        TextSimple([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Duration, DivInfo);
    }
    t += 2 * h;

    //Таблица состояния счета, распределение денежного объема, робота. 
    let wt1 = 90;
    let wt234 = (SizeInfo.w - G.D.S.GapIn - wt1) / 3;
    //"Объем"
    TextSimple([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Volume, DivInfo);
    //"Начальный"
    TextSimpleA([t, "", wt1, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].ta022, DivInfo);
    //"Доступный"
    TextSimpleA([t, "", wt1 + wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].VFree, DivInfo);
    //"В сделках"
    TextSimpleA([t, "", wt1 + 2 * wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].VLocked, DivInfo);
    t += h;
    let NumToForm;//Преобразованное число к заданной длинне знаков
    let nNumToForm = 9;//количество знаков
    DemarcationLine([t, "", l0, ""], SizeInfo.w - 2 * G.D.S.GapIn, "horizontal", DivInfo);
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.B_Unit, DivInfo);
    NumToForm = NumToFormatN(Bot.B_Start, nNumToForm);
    TextSimpleA([t, "", wt1, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    NumToForm = NumToFormatN(Bot.B_Current, nNumToForm);
    TextSimpleA([t, "", wt1 + wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    NumToForm = NumToFormatN(Bot.B_InOrder, nNumToForm);
    TextSimpleA([t, "", wt1 + 2 * wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    t += h;

    DemarcationLine([t, "", l0, ""], SizeInfo.w - 2 * G.D.S.GapIn, "horizontal", DivInfo);
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Q_Unit, DivInfo);
    NumToForm = NumToFormatN(Bot.Q_Start, nNumToForm);
    TextSimpleA([t, "", wt1, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    NumToForm = NumToFormatN(Bot.Q_Current, nNumToForm);
    TextSimpleA([t, "", wt1 + wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    NumToForm = NumToFormatN(Bot.Q_InOrder, nNumToForm);
    TextSimpleA([t, "", wt1 + 2 * wt234, ""], [wt234, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", NumToForm, DivInfo);
    t += h;

    DemarcationLine([t, "", l0, ""], SizeInfo.w - 2 * G.D.S.GapIn, "horizontal", DivInfo);
    t += h;

    //Таблица сигналов
    wt1 = 140;//1 столбик
    let wt2 = 40;//2 столбик
    let wt3 = 100;//3,4 столбик
    let wt4 = SizeInfo.w - G.D.S.GapIn - wt1 - wt2 - wt3;//4 столбик

    //Таблица НС, участвующих в автоторговле. 
    //"Нейронные сети"
    TextSimple([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].ta031, DivInfo);
    TextSimpleA([t, "", wt1, ""], [wt2, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "k", DivInfo);
    //"Действие"
    TextSimpleA([t, "", wt1 + wt2, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].Action, DivInfo);
    //"Сила"
    TextSimpleA([t, "", wt1 + wt2 + wt3, ""], [wt4, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].ta034, DivInfo);
    t += h;

    DemarcationLine([t, "", l0, ""], SizeInfo.w - 2 * G.D.S.GapIn, "horizontal", DivInfo);
    for (let NameNN in Bot.NNWeight) {//Перебор НС
        TextSimple([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", NameNN, DivInfo);
        TextSimpleA([t, "", wt1, ""], [wt2, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", Bot.NNWeight[NameNN], DivInfo);
        if (Bot.Out != null && (NameNN in G.Bot.Out) && Bot.Out[NameNN].length > 0) {
            let action = ""; //Действие: "" | "продажа" | "покупка"
            let LastOut = Bot.Out[NameNN][Bot.Out[NameNN].length - 1].D;
            //console.log("LastOut = " + LastOut);
            //console.log("Bot.Out[NameNN].length = " + Bot.Out[NameNN].length);
            if (LastOut > 0) { action = G.L[G.S.L].Sell; } else if (LastOut < 0) { action = G.L[G.S.L].Buy; };
            TextSimpleA([t, "", wt1 + wt2, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", action, DivInfo);
            TextSimpleA([t, "", wt1 + wt2 + wt3, ""], [wt4, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", LastOut.toFixed(1), DivInfo);
        }
        t += h;
        DemarcationLine([t, "", l0, ""], SizeInfo.w - 2 * G.D.S.GapIn, "horizontal", DivInfo);
    }

    //Сумарный сигнал
    let ls = 150;
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Signal, DivInfo);
    if (Bot.OutSum != null) {
        let action = "";//Действие: "" | "продажа" | "покупка"
        let LastOutSum = Bot.OutSum[Bot.OutSum.length - 1].D;
        if (LastOutSum > 0) { action = G.L[G.S.L].Sell; } else if (LastOutSum < 0) { action = G.L[G.S.L].Buy; };
        TextSimpleA([t, "", wt1 + wt2, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", action, DivInfo);
        TextSimpleA([t, "", wt1 + wt2 + wt3, ""], [wt4, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", LastOutSum.toFixed(1), DivInfo);
    }
    t += 2 * h;
    //Код важных сообщений, при проверке запуска автоторговли.
    /*
  //Устарел.
 if (Bot.Attention != null) {
     for (i = 0; i < Bot.Attention.length; i++) {//Сообщение ввиде массива
         DivAttention = TextSimple([t, "", l0, ""], [SizeInfo.w - l0, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Bot.Attention[i], DivInfo);
         DivAttention.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
         t += GetDivSizeContent(DivAttention).h;
     }
 }
 */
    //Новый
    if (Bot.AttentionCode != null) {
        for (i = 0; i < Bot.AttentionCode.length; i++) {//Сообщение ввиде массива
            let Attention;
            switch (Bot.AttentionCode[i]) {
                case 100:
                    //"НС не назначены"
                    Attention = G.L[G.S.L].ta0401;
                    break;
                case 200:
                    //"Не удалось запустить авто обновление цены."
                    Attention = G.L[G.S.L].ta0402;
                    break;
                case 300:
                    //"Не удалось получить информацию по аккаунту."
                    Attention = G.L[G.S.L].ta0403;
                    break;
                case 400:
                    //"Не удалось получить информацию по торговой паре."
                    Attention = G.L[G.S.L].ta0404;
                    break;
                case 500:
                    //"Вашему аккаунту запрещено торговать."
                    Attention = G.L[G.S.L].ta0405;
                    break;
                case 600:
                    //"Торговля парой запрещена."
                    Attention = G.L[G.S.L].ta0406;
                    break;
                case 700:
                    //"Для этой пары запрещено создать ордер типа LIMIT."
                    Attention = G.L[G.S.L].ta0407;
                    break;
                case 800:
                    //"Для этой пары запрещена торговля типа SPOT."
                    Attention = G.L[G.S.L].ta0408;
                    break;
                case 900:
                    //"API ключу запрещена торговля. (Измените настройки API ключа)."
                    Attention = G.L[G.S.L].ta0409;
                    break;
                case 1000:
                    //"На аккаунте не достаточно средств, для создание ордера."
                    Attention = G.L[G.S.L].ta0410;
                    break;
                case 1100:
                    //"Выделенных средств для авто торговли, не достаточно, для создание ордера."
                    Attention = G.L[G.S.L].ta0411;
                    break;
            }
            DivAttention = TextSimple([t, "", l0, ""], [SizeInfo.w - l0, ""], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", Attention, DivInfo);
            DivAttention.style.whiteSpace = "normal"; //Устанавливаем перенос строки автоматический
            t += GetDivSizeContent(DivAttention).h;
        }
    }

    DivInfo.UpdateScroll();


}

//Ручная тогровля
//Добавить выбор пары G.S.ManualTradeSymbol
function Trade_ManualTrading(inDiv) {
    //------------------------------------------------------------------------------------------------------------------
    //Название окна
    //Две кнопки : Купить и Продать
    //Полоса ввода "Цена"
    //   "Цена"
    //   поле ввода цены
    //   единицы
    //   кнопка "текущая"
    //Скролл устанавливающий цену
    //Полоса ввода "Объем"
    //   "Объем"
    //   поле ввода объема
    //   единицы
    //   кнопка "весь"
    //Скролл устанавливающий цену
    //Инфо
    G.F.Trade_ManualTrading = function () {
        Trade_ManualTrading(inDiv);
    }
    inDiv.innerHTML = "";

    let DivContainer = Container([0, "", 0, ""], ["100%", GetDivSizeContent(inDiv).h - G.D.S.ButtonH - 2 * G.D.S.GapIn], inDiv);
    DivCont = ModDivScrollV(DivContainer, "Trade_ManualTrading");
    DivCont.UpdateScroll();


    //------------------------------------------------------------------------------------------------------------------
    //Размеры окна
    let SizeWin = GetDivSizeContent(DivCont);
    let l0 = G.D.S.GapIn;//первый столбец
    let lmidle = SizeWin.w / 2;//середина
    let w01 = 110;//ширина поле ввода цены и объема, выбор пары
    let l01 = lmidle - G.D.S.GapIn - w01;//лево поле ввода цены и объема, выбор пары
    let l02 = lmidle + G.D.S.GapIn;//Название валюты, Две кнопки: купить и продать
    let w02 = (SizeWin.w / 4) - G.D.S.GapIn;// Две кнопки: купить и продать, кнопки текущая(цена) и весь(объем)
    let wScroll = SizeWin.w - 2 * G.D.S.GapIn;//ширина скрола, и разделительных линий

    let t = 0;
    let h = G.D.S.ContFontSizeNormal;

    if (G.AI == undefined) {
        GetUpdateAI();
        //"Загрузка"
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Loading, DivCont);
        return;
    }
    if (ObjectIsEmpty(G.AI)) {
        // "Нет данных"
        TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].NoData, DivCont);
        return;
    }



    if (G.T.Symbol == undefined) {//первый заход в окно
        G.T.Symbol = G.S.ManualTradeSymbol;//по умолчанию, GUI настройка
        G.T.Side = undefined; //Тип ордера. BUY-купит ИЛИ SELL-продать
        G.T.Quantity = 0;//объем торгуемый
        G.T.B = {};//Приставка Базовая валюта
        G.T.Q = {};//Приставка Котируемая валюта

    }
    //Инициализация
    G.T.B.Unit = G.SI[G.T.Symbol].BaseAsset;
    G.T.Q.Unit = G.SI[G.T.Symbol].QuoteAsset;
    G.T.Price = GetEndY("Price" + G.T.Symbol);//Последняя цена
    G.T.Price = ValidPrice(G.T.Price, G.T.Symbol);//валидация
    //Не импортируемые поля
    G.T.PriceStart = G.T.Price;//Для ползунка

    let UpdateLimitQuantity = function () { //Обновление пределов объема
        G.T.B.QMax = 0;//Максимальный объем, который есть на аккаунте [Базовая валюта]
        G.T.Q.QMax = 0;//Максимальный объем, который есть на аккаунте [Котируемая валюта]

        if (G.AI.BalancesFree && G.T.B.Unit in G.AI.BalancesFree) {
            G.T.B.QMax = G.AI.BalancesFree[G.T.B.Unit];//Макс доступный объем
        }
        if (G.AI.BalancesFree && G.T.Q.Unit in G.AI.BalancesFree) {
            G.T.Q.QMax = G.AI.BalancesFree[G.T.Q.Unit];//Макс доступный объем
        }
        G.T.B.QMin = MinQuantity(G.T.Price, G.T.Symbol, "Base");//Мин объем  [Базовая валюта], необходимый для создания сделки 
        G.T.Q.QMin = MinQuantity(G.T.Price, G.T.Symbol, "Quote");//Мин объем [Котируемая валюта], необходимый для создания сделки 

        //Это объемы, в пределах которых можно задавать пользовательские значения
        G.T.B.QMinSet = 0;
        G.T.Q.QMinSet = 0;
        G.T.B.QMaxSet = G.T.B.QMax;
        G.T.Q.QMaxSet = G.T.Q.QMax;
    };
    UpdateLimitQuantity();//Обновление пределов объема







    //console.log("G.T.B.QMin = " + G.T.B.QMin + " G.T.B.QMax = " + G.T.B.QMax);
    //console.log("G.T.Q.QMin = " + G.T.Q.QMin + " G.T.Q.QMax = " + G.T.Q.QMax);

    //"Пара"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Symbol, DivCont);
    let DivListSelect1 = ListSelect([t, "", l01, ""], [w01, h], G.T.Symbol, G.S.TopSymbol, DivCont);
    DivListSelect1.fnSelectContent = function (SelectSymbol) {
        G.T.Symbol = SelectSymbol;
        G.S.ManualTradeSymbol = SelectSymbol;
        GetPrice(Symbol, false);
        GUISettingsSave();
        Trade_ManualTrading(inDiv);
    }
    //Две кнопки: купить и продать
    //"Продажа"
    let DivB_SELL = ButtonText([t, "", l02, ""], [w02, h], G.L[G.S.L].Sell, DivCont);
    ModDivBackground(G.D.C.WinFon, DivB_SELL);
    DivB_SELL.onmouseover = null;//фокус      
    DivB_SELL.onmouseout = null;  //НЕ фокус
    //"Покупка"
    let DivB_BUY = ButtonText([t, "", "", l0], [w02, h], G.L[G.S.L].Buy, DivCont);
    ModDivBackground(G.D.C.WinFon, DivB_BUY);
    DivB_BUY.onmouseover = null;//фокус      
    DivB_BUY.onmouseout = null;  //НЕ фокус
    DivB_SELL.onclick = function () {//Продать
        ModDivBackground(G.D.C.Sale, DivB_SELL);
        ModDivBackground(G.D.C.WinFon, DivB_BUY);
        G.T.Side = "SELL";
        Trade_ManualTrading(inDiv);
    }
    DivB_BUY.onclick = function () {//Купить
        ModDivBackground(G.D.C.Buy, DivB_BUY);
        ModDivBackground(G.D.C.WinFon, DivB_SELL);
        G.T.Side = "BUY";
        Trade_ManualTrading(inDiv);
    }
    //Нажимаем на кнопки
    if (G.T.Side == "SELL") {//Продать
        ModDivBackground(G.D.C.Sale, DivB_SELL);
        ModDivBackground(G.D.C.WinFon, DivB_BUY);
    } else if (G.T.Side == "BUY") {//Купить
        ModDivBackground(G.D.C.Buy, DivB_BUY);
        ModDivBackground(G.D.C.WinFon, DivB_SELL);
    }
    t += 2 * h;



    let ChangePriceQuantity = function () { };//Объявление функции. Изменился объем или цена

    //Блок установки цены
    //"Цена"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Price, DivCont);
    Div_Price = TextFrameInput([t, "", l01, ""], [w01, h], 10, G.T.Price, DivCont);//поле ввода цены
    TextSimple([t, "", l02, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.T.Q.Unit, DivCont);//Название котируемой валюта    
    //Кнопка "Текущая"
    let Div_PriceCurrent = ButtonText([t, "", "", l0], [w02, h], G.L[G.S.L].tt010, DivCont);
    t += 1.2 * h;
    //Скролл цены
    let n = 0.1;//интервал в % +-G.T.PriceStart 
    let MinPrice = G.T.PriceStart * (1 - n);
    let MaxPrice = G.T.PriceStart * (1 + n);
    //Формула преобразования интервалов: (MaxPrice-MinPrice)/(ValuePrice-MinPrice)=(1-0)/(ValueScroll-0)
    let ScrollMove1 = function (value) {    //При перемещении ползунка, в функцию отправляется значение (0-1)
        //Пришло значение value, после сдвига ползунка
        G.T.Price = value * (MaxPrice - MinPrice) + MinPrice;
        G.T.Price = ValidPrice(G.T.Price, G.T.Symbol);
        Div_Price.value = G.T.Price;
        ChangePriceQuantity();
        //console.log("G.T.Price = " + G.T.Price);
    };
    let SetValue1 = ScrollBar([t, "", l0, ""], wScroll, "horizontal", ScrollMove1, DivCont);//Скрол    
    Div_Price.oninput = function () { //событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
        G.T.Price = ValidPrice(Div_Price.value, G.T.Symbol);
        ChangePriceQuantity();
        Div_Price.value = G.T.Price;
        let value = (G.T.Price - MinPrice) / (MaxPrice - MinPrice);
        SetValue1(value);//Перемещаем скролл
        //console.log("G.T.Price = " + G.T.Price);
    };
    Div_Price.oninput();
    Div_PriceCurrent.onclick = function () {
        G.T.Price = GetEndY("Price" + G.T.Symbol);//Последняя цена
        Div_Price.value = G.T.Price;
        Div_Price.oninput();
    }
    t += 2 * h;

    //Блок установки объема
    //"Объем"
    TextSimple([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.L[G.S.L].Volume, DivCont);
    let Div_Quantity = TextFrameInput([t, "", l01, ""], [w01, h], 10, G.T.Quantity, DivCont);//поле ввода объема   
    TextSimple([t, "", l02, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", G.T.B.Unit, DivCont); //Название валюты 
    //Кнопка "Весь"
    let Div_QuantityAll = ButtonText([t, "", "", l0], [w02, h], G.L[G.S.L].tt020, DivCont);
    t += 1.2 * h;
    //Скролл объема
    //Формула преобразования интервалов: (MaxQuantity-MinQuantity)/(ValueQuantity-MinQuantity)=(1-0)/(ValueScroll-0)    
    let ScrollMove2 = function (value) {//При перемещении ползунка, в функцию отправляется значение (0-1)
        //Пришло значение value, после сдвига ползунка
        if (G.T.Side == "SELL") {//Продать
            G.T.Quantity = value * (G.T.B.QMaxSet - G.T.B.QMinSet) + G.T.B.QMinSet;
        } else {//Купить
            let QuantityQuote = value * (G.T.Q.QMaxSet - G.T.Q.QMinSet) + G.T.Q.QMinSet;
            G.T.Quantity = QuantityQuote / G.T.Price;
        }
        G.T.Quantity = ValidQuantity(G.T.Quantity, G.T.Symbol, "Base", -1);

        Div_Quantity.value = G.T.Quantity;
        ChangePriceQuantity();
        //console.log("ScrollMove2: G.T.Quantity = " + G.T.Quantity);
    };
    let SetValue2 = ScrollBar([t, "", l0, ""], wScroll, "horizontal", ScrollMove2, DivCont);//Скрол    
    Div_Quantity.oninput = function () {//событие изменение содержания поля ввода текста
        AutoVerificationNumber(this);//Проверка ввода данных
        G.T.Quantity = ValidQuantity(Div_Quantity.value, G.T.Symbol, "Base", -1);
        let value;
        if (G.T.Side == "SELL") {//Продать
            value = (G.T.Quantity - G.T.B.QMinSet) / (G.T.B.QMaxSet - G.T.B.QMinSet);
        } else {//Купить
            let QuantityQuote = G.T.Price * G.T.Quantity;
            value = (QuantityQuote - G.T.Q.QMinSet) / (G.T.Q.QMaxSet - G.T.Q.QMinSet);
        }
        ChangePriceQuantity();
        Div_Quantity.value = G.T.Quantity;
        //console.log(" Div_Quantity.oninput: G.T.Quantity = " + G.T.Quantity);
        SetValue2(value);//Перемещаем скролл
        //console.log("G.T.Price = " + G.T.Price);
    };
    Div_Quantity.oninput();
    Div_QuantityAll.onclick = function () {
        if (G.T.Side == "SELL") {//Продать
            G.T.Quantity = G.T.B.QMax;
        } else {//Купить
            let QuantityQuote = G.T.Q.QMax;
            G.T.Quantity = QuantityQuote / G.T.Price;
        }
        Div_Quantity.value = G.T.Quantity;
        Div_Quantity.oninput();
    }

    t += h;

    //Таблица предварительного результата, ручной сделки
    let wt1 = 60;//Валюта
    let lt2 = l0 + wt1;
    let wt2 = 90;//Объем
    let lt3 = lt2 + wt2;
    let wt3 = 105;//Комиссия

    //Шапка
    //"Объем"
    TextSimpleA([t, "", lt2, ""], [wt2, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].Volume, DivCont);
    //"Комиссия"
    TextSimpleA([t, "", lt3, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].tt030, DivCont);
    //"Результат"
    TextSimpleA([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", G.L[G.S.L].tt031, DivCont);
    t += h;
    let DivI_CommissionBQ;
    //Базовая валюта
    DemarcationLine([t, "", l0, ""], wScroll, "horizontal", DivCont);
    TextSimpleA([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", G.T.B.Unit, DivCont);
    let DivI_QuantityB = TextSimpleA([t, "", lt2, ""], [wt2, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);
    if (G.T.Side == "BUY") {//Купить
        DivI_CommissionBQ = TextSimpleA([t, "", lt3, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);//Комиссия для базовой валюты 
    }
    let DivI_ResultB = TextSimpleA([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);//Результат
    t += h;
    //Котируемая валюта
    DemarcationLine([t, "", l0, ""], wScroll, "horizontal", DivCont);
    TextSimpleA([t, "", l0, ""], [wt1, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", G.T.Q.Unit, DivCont);
    let DivI_QuantityQ = TextSimpleA([t, "", lt2, ""], [wt2, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);
    if (G.T.Side == "SELL") {//Продать
        DivI_CommissionBQ = TextSimpleA([t, "", lt3, ""], [wt3, h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);//Комиссия для котируемой валюты 
    }
    let DivI_ResultQ = TextSimpleA([t, "", "", l0], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "right", "", DivCont);//Результат
    t += h;


    let DivI_Warning = TextSimpleA([t, "", l0, ""], ["", h], G.D.C.TWin, G.D.S.FontSizeNormal, "normal", "left", "", DivCont);//Предупреждения
    G.F.CreateOrderInfo = function (Info) {
        DivI_Warning.innerHTML = Info;
    }


    //Кнопка "Создать"
    let hB = G.D.S.ButtonH;//Высота кнопки
    let wB = GetDivSizeContent(inDiv).w - 2 * G.D.S.GapIn;//ширина     
    //"Создать"
    let Div_ButtonCreateOrder = ButtonText(["", G.D.S.GapIn, l0, ""], [wB, hB], G.L[G.S.L].Create, inDiv);

    let Div_ButtonCreateOrderON = function () { //Обновление пределов объема
        let n = G.SI[G.T.Symbol].BasePrecision;//Точность цены и объема 
        let Price = G.T.Price.toFixed(n);
        let Quantity = G.T.Quantity.toFixed(n);

        Message = {
            "Type": "CreateOrder",
            "Symbol": G.T.Symbol,
            "Side": G.T.Side,//Покупка "BUY", Продажа "SELL"
            "Price": Price,
            "Quantity": Quantity,
        };
        MessageSend(Message);
    };




    ChangePriceQuantity = function () {//Изменился объем или цена
        UpdateLimitQuantity();//Обновление пределов объема
        //Комиссии
        let MakerCommission = G.AI.MakerCommission   //Комиссия для мэйкеров (отложенная покупка/продажа). Множитель, где 1=100%.
        let SellerCommission = G.AI.SellerCommission //Комиссия для продавца. Множитель, где 1=100%.
        let BuyerCommission = G.AI.BuyerCommission   //Комиссия для покупателя. Множитель, где 1=100%.

        switch (G.T.Side) { // Постоянное значение true вместо foo
            case "SELL": //Продать
                {//+модуль, чтобы let не ругалась
                    let QuantityB = G.T.Quantity;
                    let QuantityQ = ValidQuantity(G.T.Quantity * G.T.Price, G.T.Symbol, "Quote", 0);
                    let CommissionQ = QuantityQ * (MakerCommission + SellerCommission);//Комиссия для котируемой валюты 
                    CommissionQ = ValidCommission(CommissionQ, G.T.Symbol, "Quote");
                    let ResultB = QuantityB;
                    let ResultQ = ValidQuantity(QuantityQ - CommissionQ, G.T.Symbol, "Quote", 0);
                    DivI_QuantityB.innerHTML = "-" + QuantityB;
                    DivI_QuantityQ.innerHTML = "+" + QuantityQ;
                    DivI_CommissionBQ.innerHTML = "-" + CommissionQ;//Комиссия для котируемой валюты 
                    DivI_ResultB.innerHTML = "-" + ResultB;
                    DivI_ResultQ.innerHTML = "+" + ResultQ;
                    switch (true) { // Постоянное значение true вместо foo
                        case QuantityB > G.T.B.QMax:
                            //DivI_Warning.innerHTML = "Превышение средств. В наличии " + G.T.B.QMax + " " + G.T.B.Unit;
                            //DivI_Warning.innerHTML = "Превышение имеющихся средств (" + G.T.B.QMax + " " + G.T.B.Unit+ ").";
                            //DivI_Warning.innerHTML = "Превышение доступного объема (" + G.T.B.QMax + " " + G.T.B.Unit+ ").";
                            //DivI_Warning.innerHTML = "Превышение объема (" + G.T.B.QMax + " " + G.T.B.Unit+ ").";

                            //Максимальный объем
                            DivI_Warning.innerHTML = G.L[G.S.L].tt040 + " " + G.T.B.QMax + " " + G.T.B.Unit;
                            ModEventBackground(G.D.C.WinFon, G.D.C.WinFon, Div_ButtonCreateOrder);//фокус
                            ModEventText(G.D.C.TWin, G.D.C.TWin, Div_ButtonCreateOrder); //НЕ фокус
                            Div_ButtonCreateOrder.onclick = null;
                            break;
                        case QuantityB < G.T.B.QMin:
                            //"Минимальный объем "
                            DivI_Warning.innerHTML = G.L[G.S.L].tt041 + " " + G.T.B.QMin + " " + G.T.B.Unit;
                            ModEventBackground(G.D.C.WinFon, G.D.C.WinFon, Div_ButtonCreateOrder);//фокус
                            ModEventText(G.D.C.TWin, G.D.C.TWin, Div_ButtonCreateOrder); //НЕ фокус
                            Div_ButtonCreateOrder.onclick = null;
                            break;
                        default:
                            DivI_Warning.innerHTML = "";
                            ModEventBackground(G.D.C.ButtonFonFocus, G.D.C.ButtonFon, Div_ButtonCreateOrder);//фокус
                            ModEventText(G.D.C.ButtonTextFocus, G.D.C.ButtonText, Div_ButtonCreateOrder); //НЕ фокус
                            Div_ButtonCreateOrder.onclick = Div_ButtonCreateOrderON;
                    }
                }
                break;
            case "BUY"://Купить
                let QuantityB = G.T.Quantity;
                let QuantityQ = ValidQuantity(G.T.Quantity * G.T.Price, G.T.Symbol, "Quote", 0);
                let CommissionB = QuantityB * (MakerCommission + BuyerCommission);//Комиссия для базовой валюты 
                CommissionB = ValidCommission(CommissionB, G.T.Symbol, "Base");
                let ResultB = ValidQuantity(QuantityB - CommissionB, G.T.Symbol, "Base", 0);
                let ResultQ = QuantityQ;
                DivI_QuantityB.innerHTML = "+" + QuantityB;
                DivI_QuantityQ.innerHTML = "-" + QuantityQ;
                DivI_CommissionBQ.innerHTML = "-" + CommissionB;//Комиссия для базовой валюты 
                DivI_ResultB.innerHTML = "+" + ResultB;
                DivI_ResultQ.innerHTML = "-" + ResultQ;
                switch (true) { // Постоянное значение true вместо foo
                    case QuantityQ > G.T.Q.QMax:
                        //DivI_Warning.innerHTML = "Превышение имеющихся средств (" + G.T.Q.QMax + " " + G.T.Q.Unit+ ").";
                        //DivI_Warning.innerHTML = "Превышение объема (" + G.T.Q.QMax + " " + G.T.Q.Unit+ ").";

                        //Максимальный объем
                        DivI_Warning.innerHTML = G.L[G.S.L].tt040 + " " + G.T.Q.QMax + " " + G.T.Q.Unit;
                        ModEventBackground(G.D.C.WinFon, G.D.C.WinFon, Div_ButtonCreateOrder);//фокус
                        ModEventText(G.D.C.TWin, G.D.C.TWin, Div_ButtonCreateOrder); //НЕ фокус
                        Div_ButtonCreateOrder.onclick = null;
                        break;
                    case QuantityQ < G.T.Q.QMin:
                        //"Минимальный объем "
                        DivI_Warning.innerHTML = G.L[G.S.L].tt041 + " " + G.T.Q.QMin + " " + G.T.Q.Unit;
                        ModEventBackground(G.D.C.WinFon, G.D.C.WinFon, Div_ButtonCreateOrder);//фокус
                        ModEventText(G.D.C.TWin, G.D.C.TWin, Div_ButtonCreateOrder); //НЕ фокус
                        Div_ButtonCreateOrder.onclick = null;
                        break;
                    default:
                        DivI_Warning.innerHTML = "";
                        ModEventBackground(G.D.C.ButtonFonFocus, G.D.C.ButtonFon, Div_ButtonCreateOrder);//фокус
                        ModEventText(G.D.C.ButtonTextFocus, G.D.C.ButtonText, Div_ButtonCreateOrder); //НЕ фокус  
                        Div_ButtonCreateOrder.onclick = Div_ButtonCreateOrderON;
                }
                break;
            default://Неопределен тип сделки
                "Не определено действие (Покупка | Продажа)"
                DivI_Warning.innerHTML = G.L[G.S.L].tt042;
                ModEventBackground(G.D.C.WinFon, G.D.C.WinFon, Div_ButtonCreateOrder);//фокус
                ModEventText(G.D.C.TWin, G.D.C.TWin, Div_ButtonCreateOrder); //НЕ фокус
                Div_ButtonCreateOrder.onclick = null;
        }
    }

    ChangePriceQuantity();
    DivCont.UpdateScroll();

}


//Приводит цену к валидному виду, согласно правилам из ExchangeInformation.
function ValidPrice(Price, Symbol) {
    //console.log("Symbol = " + Symbol);
    //console.log("Price = " + Price);
    let n = G.SI[Symbol].QuotePrecision;//Точность квотируемой валюты QuotePrecision
    let d = G.SI[Symbol].TickSize;//Кратность цены

    Price = Number(Price);
    //console.log("Price = " + Price);

    for (let i = 0; i < 10; i++) { //пока не сойдётся
        let PriceOld = Price;//для сравнения
        Price = NumToMultiplicity(Price, d, 0)//приводим к кратности
        //console.log("Price = " + Price);
        Price = Number(Price.toFixed(n));//приводим к точности
        //console.log("Price = " + Price);

        if (PriceOld == Price) {
            break;
        }
    }
    //console.log("Точность = " + n + " Кратность = " + d + " Price = " + Price);

    return Price;
}

//Приводит объем BaseQuote="Quote"/"Base" валюты к валидному виду, согласно правилам из ExchangeInformation. Валидация нужна только для базовой валюты.
function ValidQuantity(Quantity, Symbol, BaseQuote, z) {
    //console.log("Symbol = " + Symbol);
    //console.log("ValidQuantity: Quantity = " + Quantity);

    let n = G.SI[Symbol].BasePrecision;//Точность объема базовая
    if (BaseQuote == "Quote") {
        n = G.SI[Symbol].QuotePrecision;//Точность объема котируемая
    }
    //console.log("ValidQuantity: Точность = " + n);

    let d = G.SI[Symbol].StepSize;//Кратность объема

    Quantity = Number(Quantity);
    //console.log("Price = " + Price);

    for (let i = 0; i < 10; i++) { //пока не сойдётся
        let QuantityOld = Quantity;//для сравнения
        Quantity = NumToMultiplicity(Quantity, d, z)//приводим к кратности
        //console.log("ValidQuantity: Quantity = " + Quantity);
        Quantity = Number(Quantity.toFixed(n));//приводим к точности
        // console.log("ValidQuantity: Quantity = " + Quantity);
        if (QuantityOld == Quantity) {
            break;
        }
    }
    //console.log("ValidQuantity: Точность = " + n + " Кратность = " + d + " Quantity = " + Quantity);

    return Quantity;
}


//Вычисляет минимальный объем для базовой и котируемой валюты, по цене Price.
//BaseQuote=Quote минимальный объем котируемой валюты, чтобы создать сделку покупки. BUY
//BaseQuote=Base минимальный объем базовой валюты, чтобы создать сделку продажи. SELL
function MinQuantity(Price, Symbol, BaseQuote) {
    let MinResult = 0;
    if (BaseQuote == "Quote") {
        //console.log("Symbol = " + Symbol);
        //Взято из правил торговли MinQty - Минимальный объема ордера [базовая валюта]
        let MinQuote1 = G.SI[Symbol].MinNotional;
        //Вычисленный объем ордера необходимый, для того что бы получить минимальный итогового объема после сделки.
        let MinQuote2 = G.SI[Symbol].MinQty * Price;//Переводим BS.SI.MinNotional [котируемая валюта] в [базовая валюта]
        //Валидация полученного объема
        MinQuote2 = ValidQuantity(MinQuote2, Symbol, "Quote", +1);
        //Выбираем наибольшее значение среди вычисленных MinBase1 и MinBase2
        if (MinQuote1 < MinQuote2) {
            MinResult = MinQuote2;
        } else {
            MinResult = MinQuote1;
        }
    } else {//Base
        //console.log("Symbol = " + Symbol);
        //Взято из правил торговли MinQty - Минимальный объема ордера [базовая валюта]
        let MinBase1 = G.SI[Symbol].MinQty;
        //Вычисленный объем ордера необходимый, для того что бы получить минимальный итогового объема после сделки .
        let MinBase2 = G.SI[Symbol].MinNotional / Price //Переводим BS.SI.MinNotional [котируемая валюта] в [базовая валюта]
        //Валидация полученного объема
        MinBase2 = ValidQuantity(MinBase2, Symbol, "Base", +1);
        //Выбираем наибольшее значение среди вычисленных MinBase1 и MinBase2
        if (MinBase1 < MinBase2) {
            MinResult = MinBase2;
        } else {
            MinResult = MinBase1;
        }
    }
    return MinResult;
}


//Приводит объем BaseQuote="Quote"/"Base" валюты к валидному виду, согласно правилам из ExchangeInformation. Валидация нужна только для базовой валюты.
function ValidCommission(Commission, Symbol, BaseQuote) {
    //console.log("Symbol = " + Symbol);
    //console.log("Price = " + Price);

    let n = G.SI[Symbol].BaseCommissionPrecision;//Точность объема базовая
    if (BaseQuote == "Quote") {
        n = G.SI[Symbol].QuoteCommissionPrecision;//Точность объема котируемая
    }

    Commission = Number(Commission.toFixed(n));//приводим к точности

    return Commission;
}
