
//код измерения выполнения
//let StartTimer = Date.now();
//console.log("Длительность = " + (Date.now() - StartTimer) / 1000 + " [c]");

//проверяет поля ввода числа
//Срабатывает при событии. oninput = function () {AutoVerificationNumber(this)}
function AutoVerificationNumber(div) {
    //Числа с плавающей точкой >0
    let pNumber = /^[0-9]*[.|,]?[0-9]*$/;
    //console.log("AutoVerificationNumber");
    let textVal = div.value;
    if (pNumber.test(textVal)) {
        //Заменяем, на.
        div.value = div.value.replace(",", ".")
        //Валидно
        //console.log("Валидно " + textVal);
    } else {
        //console.log("НЕВалидно " + textVal);
        //Удалить последний символ
        div.value = textVal.slice(0, -1);
        //если после этого ничего не осталось ставим 0
        if (div.value == "") {
            div.value = "0";
        }
        //Повторная проверка
        AutoVerificationNumber(div);
    }
    //Условие maxsimum>minimum
    //document.getElementById("minimum").value = "1200";
    //document.getElementById("maxsimum").value = "1900";

}

function AutoVerificationNumberNegative(div) {
    //Числа с плавающей точкой <0
    let pNumber = /^[-]?[0-9]*[.|,]?[0-9]*$/;
    //console.log("AutoVerificationNumber");
    let textVal = div.value;
    if (pNumber.test(textVal)) {
        //Заменяем, на.
        div.value = div.value.replace(",", ".")
        //Валидно
        //console.log("Валидно " + textVal);
    } else {
        //console.log("НЕВалидно " + textVal);
        //Удалить последний символ
        div.value = textVal.slice(0, -1);
        //если после этого ничего не осталось ставим 0
        if (div.value == "") {
            div.value = "0";
        }
        //Повторная проверка
        AutoVerificationNumber(div);
    }
    //Условие maxsimum>minimum
    //document.getElementById("minimum").value = "1200";
    //document.getElementById("maxsimum").value = "1900";

}

//Проверит пустой ли объект
function ObjectIsEmpty(obj) {
    for (let key in obj) {
        return false;// если тело цикла начнет выполняться - значит в объекте есть свойства
    }
    return true;
}
//Проверка пустой ли объект.
function ObjectIsEmpty(obj) {
    for (let key in obj) {
        return false;// если тело цикла начнет выполняться — значит в объекте есть свойства
    }
    return true;
}


//Округление до N знаков после запятой
function RoundingToN(Value, N) {
    //console.log("RoundingToN Value=" + Value);
    if (typeof (Value) == "string") {
        //console.log("typeof (Value) == string");
        let V = Number(Value);
        if (Number.isNaN(V)) {
            //console.log("V == NaN");
            return Value;
        } else {
            Value = V;
        }
    }
    let n = Math.pow(10, N); //N=2 n=100
    return Math.round(Value * n) / n;// 1.23456 -> 123.456 -> 123 -> 1.23
}


//Перевод Unix [ms] в дату
function UnixToDate(Unix_ms) {
    //Пример. UnixToDate(Unix_ms).date +" "+ UnixToDate(DoublePixelLimit).time
    let Dt = new Date(Unix_ms);
    let Y = Dt.getFullYear();
    let M = Dt.getMonth() + 1;//от 0 до 11 (+1) -> от 1 до 12 
    let D = Dt.getDate();
    if (M < 10) M = "0" + M;
    if (D < 10) D = "0" + D;
    let date = Y + "." + M + "." + D;
    let h = Dt.getHours();
    let m = Dt.getMinutes();
    let s = Dt.getSeconds();
    if (h < 10) h = "0" + h;
    if (m < 10) m = "0" + m;
    if (s < 10) s = "0" + s
    let time = h + ":" + m + ":" + s;
    //console.log(Unix_ms + " ms = " + date + " " + time);

    return { time: time, date: date };
}

//Перевод даты в Unix [ms]
function DateToUnix(Dt) {
    let Unix_ms = +new Date(Dt);
    //console.log(" Dt = " + Dt + " Unix_ms =" + Unix_ms);
    return Unix_ms;
}

//Длительность мс в формате "299д 15ч 57м 36с 512мс"
function DurationMsToDate(Duration_ms) {

    let sign = 1;
    if (Duration_ms < 0) {
        sign = -1;
        Duration_ms = Math.abs(Duration_ms);
    }

    let DurationStr = "";
    let DurationPart = Duration_ms;

    let Y = Math.floor((DurationPart / (1000 * 60 * 60 * 24 * 365)));
    if (Y > 0) {
        if (Y <= 4) {
            DurationStr += Y + G.L[G.S.L].Year + " ";//г
        } else {
            DurationStr += Y + G.L[G.S.L].Years + " ";//л
        }
        DurationPart -= Y * (1000 * 60 * 60 * 24 * 365);
    }

    let D = Math.floor((DurationPart / (1000 * 60 * 60 * 24)));
    if (D > 0 || DurationStr != "") {
        DurationStr += D + G.L[G.S.L].Day + " ";//д
        DurationPart -= D * (1000 * 60 * 60 * 24);
    }
    let h = Math.floor((DurationPart / (1000 * 60 * 60)));
    if (h > 0 || DurationStr != "") {
        DurationStr += h + G.L[G.S.L].Hour + " ";//ч
        DurationPart -= h * (1000 * 60 * 60);
    }
    let m = Math.floor((DurationPart / (1000 * 60)));
    if (m > 0 || DurationStr != "") {
        DurationStr += m + G.L[G.S.L].Minute + " ";//м
        DurationPart -= m * (1000 * 60);
    }
    let s = Math.floor((DurationPart / (1000)));
    if (s > 0 || DurationStr != "") {
        DurationStr += s + G.L[G.S.L].Second + " ";//с
        DurationPart -= s * (1000);
    }
    if (Duration_ms < 1000 * 30) {
        DurationStr += DurationPart + G.L[G.S.L].Millisecond;//мс
    }

    if (sign < 0) {
        DurationStr = "- " + DurationStr;
    }

    //console.log(DurationStr);
    return DurationStr;
}

//Длительность мс в формате N значемых показателей. Например при N=2 "299д 15ч" или  "15ч 57м" или  "57м 36с"
function DurationMsToDateN(Duration_ms, N) {

    if (Duration_ms == 0) {
        return 0;
    }
    let DurationStr = "";
    let DurationPart = Duration_ms;
    let n = 0;

    let D = Math.floor((DurationPart / (1000 * 60 * 60 * 24)));
    if (D > 0) {
        DurationStr = D + "д "
        DurationPart -= D * (1000 * 60 * 60 * 24);
        n++;
        if (n == N) {
            return DurationStr;
        }
    }
    let h = Math.floor((DurationPart / (1000 * 60 * 60)));
    if (h > 0 || DurationStr != "") {
        DurationStr += h + "ч "
        DurationPart -= h * (1000 * 60 * 60);
        n++;
        if (n == N) {
            return DurationStr;
        }
    }
    let m = Math.floor((DurationPart / (1000 * 60)));
    if (m > 0 || DurationStr != "") {
        DurationStr += m + "м "
        DurationPart -= m * (1000 * 60);
        n++;
        if (n == N) {
            return DurationStr;
        }
    }
    let s = Math.floor((DurationPart / (1000)));
    if (s > 0 || DurationStr != "") {
        DurationStr += s + "с "
        DurationPart -= s * (1000);
        n++;
        if (n == N) {
            return DurationStr;
        }
    }
    if (Duration_ms < 1000 * 30 && Duration_ms > 0) {
        DurationStr += DurationPart + "мс"
    }

    //console.log(DurationStr);
    return DurationStr;
}

//Длительность мс в формате "299д 15ч"
function DurationMsToDateDH(Duration_ms) {


    let DurationStr = "";
    let DurationPart = Duration_ms;

    let D = Math.floor((DurationPart / (1000 * 60 * 60 * 24)));
    if (D > 0) {
        DurationStr = D + "д "
        DurationPart -= D * (1000 * 60 * 60 * 24);
    }
    let h = Math.floor((DurationPart / (1000 * 60 * 60)));
    if (h > 0 || DurationStr != "") {
        DurationStr += h + "ч "
        DurationPart -= h * (1000 * 60 * 60);
    }
    //console.log(DurationStr);
    return DurationStr;
}

//Преобразует/округляет число до 2 знаков и представляет в экспоненциальной форме (1.2е5)
function NumToFormatE(n) {
    if (n == 0) {
        return 0;
    }
    n = n.toExponential(1);// 1.235е+5. *аргумент указывает на кол зн после запятой
    n = n.replace("+", ""); // 1.235е5
    return n;
}

//Преобразует экспоненциальную форму числа в строку (1.2е5->"120000"  1.1368683772161603e-13->"0.00000000000011368683772161603" 
function EToFormatStr(number) {
    var data = String(number).split(/[eE]/);
    if (data.length == 1) return data[0];

    var z = '',
        sign = number < 0 ? '-' : '',
        str = data[0].replace('.', ''),
        mag = Number(data[1]) + 1;

    if (mag < 0) {
        z = sign + '0.';
        while (mag++) z += '0';
        return z + str.replace(/^\-/, '');
    }
    mag -= str.length;
    while (mag--) z += '0';
    return str + z;
}


//Преобразует/округляет число до n значимых знаков. Пример n=3 1.234=1.2; 123.4=123; 0.0123=0; -1.23=-1; 1234=1234; 1.1e-10=0
function NumToFormatN(number, n) {
    //console.log("number = " + number);
    let NumberStr = EToFormatStr(number);//Преобразует экспоненциальную форму в обычную
    //console.log("NumberStr = " + NumberStr);
    let nOrig = NumberStr.length;//Всего знаков, вместе с минусом и запятой.
    if (nOrig > n) {
        let numberArr = NumberStr.split(".")  // -123.456 = массив ["-123", "456"]
        if (numberArr[0].length + 1 >= n) {
            return Math.round(number)
        }
        let cut = nOrig - n;
        numberArr[1] = numberArr[1].slice(0, -cut);
        NumberStr = numberArr[0] + "." + numberArr[1];
        //console.log("return = " + Number(NumberStr));
        return Number(NumberStr);
    }
    // console.log("return = " + number);
    return number;
}



//Преобразует/округляет число к формату: 123m; 123; 123k; 123M; 123G;
function NumToFormatK(n) {
    //Определим количество знаков перед запятой
    let Ndot = 0;
    for (let i = -3; i <= 12; i++) {
        let v = n / Math.pow(10, i);
        if (v < 1 && v >= 0.1) {
            Ndot = i;
            break;
        }
    }
    //отбрасываем все знаки, кроме первых 3х. Получим 0,123
    nm = (n / Math.pow(10, Ndot)).toFixed(3);
    nm = nm * Math.pow(10, Ndot);
    //Получим
    //console.log("n = " + n + " Ndot = " + Ndot + " nm = " + nm);

    switch (true) {
        case -3 < Ndot && Ndot < 0://123m
            nm = 1000 * Math.round(nm * 100) / 100;
            return nm + "m";
            break;
        case 0 < Ndot && Ndot <= 3: //123
            nm = Math.round(nm * 100) / 100;
            return nm;
            break;
        case 3 < Ndot && Ndot <= 6: //123k
            nm = (Math.round(nm * 100) / 100) / 1000;
            return nm + "k";
            break;
        case 6 < Ndot && Ndot <= 9: //123M
            nm = (Math.round(nm * 100) / 100) / 1000000;
            return nm + "M";
            break;
        case 9 < Ndot && Ndot <= 12: //123G
            nm = (Math.round(nm * 100) / 100) / 1000000000;
            return nm + "G";
            break;
        default:
            return n;
    }
}

//Оставляет в массиве только уникальные значения
function UniqueValuesArray(Arr) {
    let newSet = new Set(Arr); // -> Set(6) { -1, 3, 9, -9, 100, -100 }
    //new Set создаёт новую коллекцию, а нам нужен массив
    //воспользуемся методом Array.from(). Получаем:
    return Array.from(newSet); // -> [ -1, 3, 9, -9, 100, -100 ]
}

//Кратность. Округляет число до ближайшего кратного Multiplicity
//Кратность: z = 0 в ближайшую сторону, z = 1 в большую сторону, z = -1 в меньшую сторону, 
function NumToMultiplicity(Num, Multiplicity, z) {
    let d = Num;
    switch (z) {
        case 0:
            d = Multiplicity * Math.round(Num / Multiplicity);
            break;
        case -1:
            d = Multiplicity * Math.floor(Num / Multiplicity);
            break;
        case 1: // В случае "case 0:" не было break, инструкции данного случая также будут выполнены
            d = Multiplicity * Math.ceil(Num / Multiplicity);
            break;
        default:
            console.log("ОШИБКА!!! ");
    }

    return d;
}




//Сортировка массива чисел
function ArrNumSort(Arr) {
    let CompareNumeric = function (a, b) {
        if (a > b) return 1;
        if (a < b) return -1;
    }

    return Arr.sort(CompareNumeric);
}

//Заменит в массиве Arr элемент со значением VDel и добавит VAdd
function ArrDelete(Arr, VDel) {
    let IndexDel = Arr.indexOf(VDel);//найдет один элемент, только первое вхождение
    if (IndexDel !== -1) {
        Arr.splice(IndexDel, 1);
    }
    return Arr;
}

//Заменит в массиве Arr элемент со значением VDel и добавит VAdd
function ArrReplacement(Arr, VDel, VAdd) {
    let IndexDel = Arr.indexOf(VDel);//найдет один элемент, только первое вхождение
    if (IndexDel !== -1) {
        Arr.splice(IndexDel, 1);
    }
    Arr.push(VAdd);
    return Arr;
}


//Преобразует значение x (от 0 до 1) из линейной шкалы, в значение y (от 0 до 1) нелинейной шкалы. Base от 1 до 20. Степень нелинейности
function ToLogScale(X, Base) {
    let Y = Math.log(X * (Base - 1) + 1) / Math.log(Base);
    return Y;
}
//Преобразует значение y (от 0 до 1) нелинейной шкалы в значение x (от 0 до 1) линейной шкалы. Base от 1 до 20. Степень нелинейности
function FromLogScale(Y, Base) {
    let X = (Math.pow(Base, Y) - 1) / (Base - 1);
    return X;
}



//Переводчик. Двунакправленный.
// Dict1 = ["Текст",...]. Пример ["Относительный", "Абсолютный"];
// Dict2 = ["Перевод",...]. Пример [ "Relative", "Absolute"];
function Translation(Word, Dict1, Dict2) {
    for (let i = 0; i < Dict1.length; i++) {
        if (Dict1[i] == Word) {
            return Dict2[i];
        }
    }
    for (let i = 0; i < Dict2.length; i++) {
        if (Dict2[i] == Word) {
            return Dict1[i];
        }
    }
}


